/*
 * jrCMS Main Classes and Utilities
 *
 * The main part contains all classes and functions needed for initial usage
 * of the content management system as well as an API. 
 * For proper usage of the history the JRCmsRsh plugin must be loaded and 
 * instantiated first. The real simple history functions require an empty 
 * blank.html file in the root directory.
 *
 * Conventions for JRCmsRsh history pool:
 * - each public object (class) gets a four digit ID 
 * - the last two digits are used to identify the methods
 *
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @version $Id: jrcms.js 608 2011-09-20 06:10:55Z jensraabe $ 
 * 
 * @copyright Copyright (c) 2011 Jens Raabe
 * Permission is hereby granted, free of charge, to any person 
 * obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * Plugins of the software package may relay to this copy right notice only
 * whereas assets or customer enhancements will have own copyrights.
 * The above copyright notice and this permission notice shall be included 
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR 
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
var JRCmsCore=new Class({_coreInfo:{name:"JRCmsCore",instance:"jrCMS",version:"0.3.0",revision:"$Revision: 608 $",developer:"Jens Raabe",developer_url:"http://www.raabe-berlin.de",license:"MIT",classId:1000}});var JRCmsUtils=new Class({});var JRCmsForm=new Class({Extends:JRCmsUtils});var JRCmsApi=new Class({Extends:JRCmsForm});var JRCmsPlugins=new Class({Extends:JRCmsUtils});var _requestLoaded=false;Request=Class.refactor(Request,{options:{jr_useSpinner:false,method:"post",link:"ignore",async:true,evalScripts:false},initialize:function(a){if($defined(a.jr_useSpinner)){a.useSpinner=a.jr_useSpinner}this.previous(a)},send:function(a){_requestLoaded=false;this.addEvent("onLoaded",this.onLoaded.bind(this));this.previous(a)},onLoaded:function(){_requestLoaded=!this.running},getSpinner:function(){if(!this.spinner){var a=document.id(this.options.spinnerTarget)||document.id(this.options.update);if(this.options.jr_useSpinner&&a){this.spinner=a.get("spinner",this.options.spinnerOptions);["onLoaded","onException","onCancel"].each(function(b){this.addEvent(b,this.spinner.hide.bind(this.spinner))},this)}else{if(this.options.useSpinner&&a){this.spinner=a.get("spinner",this.options.spinnerOptions);["onComplete","onException","onCancel"].each(function(b){this.addEvent(b,this.spinner.hide.bind(this.spinner))},this)}}}return this.spinner},onSuccess:function(){this.fireEvent("complete",arguments).fireEvent("success",arguments).fireEvent("loaded",arguments).callChain()},onFailure:function(){if($defined(window.jrCmsLog)){jrCmsLog.put("F#>> JRCmsApi.processRequest no content "+err)}this.previous()}});Xol=new Class({xml:null,xmlObj:{},convertXml2Obj:function(a){var b=new Object();if(this.hasChildNodesXml(a)){var c=(this.getFirstChildNameXmlNode(a)!="_array"?new Object():new Array());Array.each(this.getChildElementsXmlNode(a),function(f,d){var e=this.convertXml2Obj(f);if($type(c)!="array"){$extend(c,e)}else{if(this.hasAttributesXmlNode(f)){c[parseInt(this.getValueXmlNode(this.getFirstAttributeXmlNode(f)))]=e}else{c.push(e)}}},this);if(this.getNameXmlNode(a)=="_array"||this.getNameXmlNode(a)=="root"){return c}b[this.getNameXmlNode(a)]=c}else{b[this.getNameXmlNode(a)]=this.getDataXmlNode(a)}return b},getRootNodeXml:function(a){this.xml=a;this.xmlObj=new Object();return a.documentElement},getNameXmlNode:function(a){return((a.nodeName.length>1&&a.nodeName.search(/___/)==0)?a.nodeName.substr(3):a.nodeName)},getValueXmlNode:function(a){return a.nodeValue},getDataXmlNode:function(a){if(!this.hasAttributesXmlNode(a)){return($defined(a.firstChild)?(a.firstChild.textContent?a.firstChild.wholeText:a.firstChild.data):"")}else{return $defined(a.firstChild)?((this.getValueXmlNode(this.getFirstAttributeXmlNode(a)))=="number"?parseFloat(a.firstChild.data):a.firstChild.data==0?false:true):""}},hasChildNodesXml:function(a){return(!!a.childNodes&&a.childNodes.length!=0&&!$defined(a.firstChild.data))},getFirstChildNameXmlNode:function(a){if(this.hasChildNodesXml(a)){return this.getNameXmlNode(a.firstChild)}else{return null}},getChildrenXmlNode:function(a){if(this.hasChildNodesXml(a)){return a.childNodes}else{return null}},getChildElementsXmlNode:function(a){return this.filterByTypeXml(this.getChildrenXmlNode(a))},hasAttributesXmlNode:function(a){return(!!a.attributes&&a.attributes.length!=0)},getAttributesXmlNode:function(a){if(this.hasAttributesXmlNode(a)){return a.attributes}else{return null}},getFirstAttributeXmlNode:function(a){if(this.hasAttributesXmlNode(a)){return a.attributes[0]}else{return null}},filterByTypeXml:function(a){var c=this.xml.createElement("filteredNodes");for(i=0;i<a.length;i++){var b=a[i].cloneNode(true);c.appendChild(b)}return c.childNodes},xml2Obj:function(a){return $defined(a)?this.convertXml2Obj(this.getRootNodeXml(a)):null}});Request.XOL=new Class({Extends:Request,Implements:Xol,success:function(b,a){this.onSuccess(this.processScripts(b),a,this.xml2Obj(a))}});(function(){var a=1021;var b={jr_lang:"en",jr_userLevel:"000",jr_uploadUrl:"content/uploads",jr_editorLevel:"220",jr_webmasterLevel:"999",jr_loginDialogHidden:true,jr_langTxt:{},jr_langLoaded:false,jr_srcUrl:"src/",jr_pluginsUrl:"plugins/",jr_assetsUrl:"assets/",jr_divMain:"divMain",jr_divLogin:"divLogin",jr_divHMenu:"divHMenu",jr_divVMenu:"divVMenu",jr_divRMenu:"divRMenu",jr_showRMenu:".hideswitch",jr_divPupMenu:"divPupMenu",jr_divButtons:"divButtons",jr_divButtonsWrap:"divRTMenu",jr_showButtonsWrap:".hideswitch",jr_divRContent:"divRMenu",jr_divRContentWrap:".hideswitch",jr_divWindowSize:"divWindowSize",jr_divVersion:"divVersion",jr_divGrid:"divGrid",jr_divHelp:"divHelp",jr_thumbSubDir:".thumbs",jr_divRightDisplay:"block",jr_firebugConsole:true,jr_histDebug:false,jr_histEnabled:true,jr_histBackId:0,jr_types:["ajax","alink","apage","aeditor","js"],jr_buttonType:undefined,jr_dbischanged:false,jr_base64:false,jr_user_pw:false,jr_initParam:new Object(),jr_maintLevel:"444",jr_maintParam:new Object(),jr_projURL:"localhost",jr_ie_version:0,jr_ie_bug:false,jr_lowspeed:false,jr_loadPage:true,jr_spinnerOptions:{containerPosition:{position:"upperRight",offset:{x:-34,y:10}}},jr_spinnerTarget:undefined};JRCmsApi.implement({jrLog:function(c,d){if(((isNaN(this.options.jr_debug))?((this.options.jr_debug)?(1):(0)):this.options.jr_debug)<=0){return}if($defined(window.jrCmsLog)){jrCmsLog.put(c,d)}},processRequest:function(e){try{if(!$defined(e.data)){throw new Error("processRequest without data called!")}if(this.options.jr_ie_bug&&this._delayProcessRequest){this.processRequest.delay(200,this,e)}else{if(this.options.jr_ie_bug){this._delayProcessRequest=true;(function(){this._delayProcessRequest=false}).delay(200,this)}}if(!$defined(e.requestType)){e.requestType="xml"}var c=$merge({jr_useSpinner:(!$defined(this._showFrameLoadingSpinner)?true:false),spinnerOptions:this.options.jr_spinnerOptions,spinnerTarget:($defined(this.options.jr_spinnerTarget)?this.options.jr_spinnerTarget:this.options.jr_divMain)},e);c.spinnerOptions.message=this.getLangItem("reqspinner_msg");switch(c.requestType.toLowerCase()){case"form":case"html":c=$merge(c,{evalResponse:false,onSuccess:(!$defined(c.onSuccess)?function(j,f,k,h){var g=$merge(c.data);this.writeContentHTML($defined(h)?'<script type="text/javascript">'+h+"<\/script>"+k:k,{divCont:g._div,postMainFunc:($defined(g.successHandler)?(g.successHandler):null),noEditor:true})}.bind(this):c.onSuccess)});break;case"json":c=$merge(c,{onSuccess:(!$defined(c.onSuccess)?function(f){this.getContent(f)}.bind(this):c.onSuccess)});break;case"xol":c=$merge(c,{onSuccess:(!$defined(c.onSuccess)?function(g,f,j){var h=$merge(c.data);this.processXolContainer(j,$merge(h,{postMainFunc:($defined(h.successHandler)?(h.successHandler):null)}))}.bind(this):c.onSuccess)});break;default:c=$merge(c,{onSuccess:(!$defined(c.onSuccess)?function(g,f){var h=$merge(c.data,{postMainFunc:($defined(c.data.successHandler)?(c.data.successHandler):null)});if(f.getElementsByTagName("conthtml").length>0){var j=f.getElementsByTagName("conthtml").item(0);if($type(e.contMainFunc)=="function"){h.contMainFunc((typeof(j.textContent)!="undefined"?j.textContent:j.firstChild.nodeValue))}else{this.writeContentHTML((typeof(j.textContent)!="undefined"?j.textContent:j.firstChild.nodeValue),h)}}else{this._contentLoadedOnce=true}}.bind(this):c.onSuccess)});break}if(e.requestType.toLowerCase()!="form"){((e.requestType.toLowerCase()=="xml")?(new Request(c)):((e.requestType.toLowerCase()=="html")?(new Request.HTML(c)):((e.requestType.toLowerCase()=="xol")?(new Request.XOL(c)):(new Request.JSON(c))))).send()}else{c.data.set("send",$merge(c,{data:undefined}));c.data.send()}}catch(d){this.jrLog("F#>> processRequest fail: "+d)}},reloadPage:function(d){if(!$defined(d)){d="home"}switch(d){case"page":this.jrLog(">>>> jrCMS page refresh <<<<");self.location.reload();break;case"home":if(!$defined(this._reloadPageCalled)&&window.location.hash.search(/\?/)>0){this._reloadPageCalled=true;var c=(window.location.hash.search(/\#/)==0)?(a+window.location.hash.substring(window.location.hash.search(/\?/))):(window.location.hash);this.jrLog(">>>> jrCMS loading with hash: "+c+" <<<<");this.change(c)}else{this.jrLog(">>>> jrCMS load/reload home page<<<<");if(!jrCMS.accessRights(jrCmsInit.getUserLevel(),jrCmsInit.options.jr_maintLevel)){if(this.options.jr_histEnabled){this.execHP({uniqueId:a,parameter:JSON.encode(jrCmsInit.options.jr_initParam)})}else{jrCMS.getContentForNode(jrCmsInit.options.jr_initParam)}}else{if(this.options.jr_histEnabled){this.execHP({uniqueId:a,parameter:JSON.encode(jrCmsInit.options.jr_maintParam)})}else{jrCMS.getContentForNode(jrCmsInit.options.jr_maintParam)}}}break;default:this.jrLog(">>>> jrCMS page reload <<<<");this.historyStorageReset();self.location.href=jrCmsInit.options.jr_projURL;this.change.delay(50,this)}},processXolContainer:function(d,e){var c=false;if(!$defined(e)){var e=new Object()}if($defined(d.cssdata)){this.writeCssData(d.cssdata)}if($defined(d.menus)){d.menus.each(function(g,f){switch(g.menudiv){case this.options.jr_divHMenu:if($defined($(this.options.jr_divHMenu))){c=this.writeMenuHTML(g.menuhtml,{divMenu:this.options.jr_divHMenu})}else{this.jrLog("F#>> processXolContainer element: "+this.options.jr_divHMenu+" not available !!!");window.jrCMS.reloadPage("page")}break;case this.options.jr_divVMenu:if($defined($(this.options.jr_divVMenu))&&($(this.options.jr_divVMenu).get("html")==""||this.options.jr_refreshVMenu)){this.writeMenuHTML(g.menuhtml,{divMenu:this.options.jr_divVMenu,divRightDisplay:($defined(e.divRightDisplay)?e.divRightDisplay:this.options.jr_divRightDisplay)})}else{this.jrLog("F#>> processXolContainer element: "+this.options.jr_divVMenu+" not available !!!");window.jrCMS.reloadPage("page")}break;case this.options.jr_divRMenu:if($defined($(this.options.jr_divRMenu))){c=this.writeMenuHTML(g.menuhtml,{divMenu:this.options.jr_divRMenu})}else{this.jrLog("F#>> processXolContainer element: "+this.options.jr_divRMenu+" not available !!!");window.jrCMS.reloadPage("page")}break}}.bind(this))}if($defined(d.ctrlhtml)){this.writeButtonsHTML(d.ctrlhtml);c=true}else{this.hideFrame((($defined(e)&&$defined(e.divCtrl))?(e.divCtrl):(this.options.jr_divButtons)))}if($defined(d.conthtml)){if($type(e.contMainFunc)=="function"){e.contMainFunc(d.conthtml)}else{this.writeContentHTML(d.conthtml,e)}}else{this._contentLoadedOnce=true}if($defined(d.rightconthtml)){if($type(e.contRightFunc)=="function"){e.contRightFunc(d.rightconthtml)}else{this.writeRightContentHTML(d.rightconthtml,e)}}else{if(!c){if(($defined(e.divRightDisplay)&&e.divRightDisplay=="none")||this.options.jr_divRightDisplay=="none"){this.hideFrame(($defined(e.divRightContWrap)?(e.divRightContWrap):(this.options.jr_divRContentWrap)))}}}if($defined(d.contdata)&&$defined(d.contdata.dlgoptions)){this.writeDialog(d.contdata,$merge(d.contdata.dlgoptions,{dlgText:this.getLangItemSet()}))}this.jrLog("T:2>> processXolContainer finished",2)},writeContentHTML:function(d,g){try{if(!$defined(g.divCont)||!$defined($(g.divCont))){g.divCont=this.options.jr_divMain}if(!$defined(g.noEditor)){g.noEditor=false}g.strHtml=d;g.imgArray=g.strHtml.match(/<img[^>]*>/g);if($defined(g.imgArray)&&g.imgArray.length>0){this.loadImagesAndWriteContent.delay(5,this,$merge(g))}else{this.writeContent(g)}}catch(c){var f=" writeContentHTML: "+c;if(this.options.jr_debug){throw new Error(f)}}},writeRightContentHTML:function(d,g){try{g.postMainFunc=undefined;g.noEditor=true;g.divCont=($defined(g.divRightCont))?(g.divRightCont):(this.options.jr_divRContent);this.showFrame((($defined(g.divRightContWrap))?(g.divRightContWrap):(this.options.jr_divRContentWrap)));this.showFrame(g.divCont);this.writeContentHTML(d,g)}catch(c){var f=" writeRightContentHTML: "+c;if(this.options.jr_debug){throw new Error(f)}}},getHTML:function(h,d,g){try{if($type(h)=="object"&&$defined(h._src)&&$defined(h._div)){this.processRequest({async:($defined(g)?g:true),successHandler:(($type(d)=="function")?d:undefined),requestType:"html",link:"chain",url:h._src,data:h})}else{var f=" getHTML with wrong parameter called";if(this.options.jr_debug){throw new Error(f)}}}catch(c){var f=" getHTML: "+c;if(this.options.jr_debug){throw new Error(f)}}},registerFunctions:function(c){if(!$defined(c)||$type(c)!="object"){throw new Error("registerFunctions with wrong parameter called!")}if(this.options.jr_histEnabled){if(!$defined(window.jrCmsRshSource)||window.jrCmsRshSource.addSourcePoolEntered){this.registerFunctions.delay(50,this,$merge(c));return false}jrCmsRshSource.add(c);this.jrLog("T:4#>> registerFunctions (jrCmsRshSource.add) for "+c.instance+" finished!",4)}if($defined(c.successHandler)&&$type(c.successHandler)=="function"){c.successHandler.run()}},addRequestHP:function(e,d,c){if(this.options.jr_histEnabled&&$defined(window.jrCmsRsh)){return jrCmsRsh.addRequestHP(e,d,c)}else{return null}},addHP:function(f,e,d,c){if(this.options.jr_histEnabled&&$defined(window.jrCmsRsh)){return jrCmsRsh.addHP(f,e,d,c)}else{return false}},execHP:function(c){if(this.options.jr_histEnabled&&$defined(window.jrCmsRsh)){return jrCmsRsh.execHP(c)}else{return false}},change:function(c,d){if(this.options.jr_histEnabled&&$defined(window.jrCmsRsh)){return jrCmsRsh.change(c,d)}else{return false}},historyStorageReset:function(){if(this.options.jr_histEnabled&&$defined(window.historyStorage)){return historyStorage.reset()}else{return false}},loadScriptFiles:function(c){try{var g=new Array();if($type(c)=="object"){g.push(c)}else{g=$A(c)}g.each(function(k,e){var j=this.getUniqueScriptId(k.jsfile.substring(0,k.jsfile.lastIndexOf(".")));if($chk($$("script."+j)[0])){$$("script."+j)[0].dispose()}var h=new Asset.javascript((k.path+k.jsfile.toLowerCase()),{"class":j,onload:($defined(k.loadfunc)?k.loadfunc:function(){return true})})}.bind(this))}catch(d){var f=" loadScriptFiles: "+d;if(this.options.jr_debug){throw new Error(f)}}},loadStyleFiles:function(c){try{var f=new Array();if(!$defined(c)){f=[{cssfile:"layout.css",path:this.options.jr_srcUrl+"css/"},{cssfile:"navigation.css",path:this.options.jr_srcUrl+"css/"},{cssfile:"content.css",path:this.options.jr_srcUrl+"css/"},{cssfile:"patchIE6.css",path:this.options.jr_srcUrl+"css/"}]}else{if($type(c)=="object"){f.push(c)}else{f=$A(c)}}f.each(function(h,e){if((h.cssfile.search(/IE/)!=-1&&this.options.jr_ie_bug)||h.cssfile.search(/IE/)==-1){var k=this.getUniqueStylesFileId(h.cssfile.substring(0,h.cssfile.lastIndexOf(".")));if(!$chk($$("link."+k)[0])){var j=new Asset.css((h.path+h.cssfile.toLowerCase()),{"class":k})}}}.bind(this))}catch(d){var g=" loadStyleFiles: "+d;if(this.options.jr_debug){throw new Error(g)}}},preLoadImages:function(d){try{if(!$defined(d)){var d=new Object();d.a="pldimg";d.ipp=$defined(this.options.jr_imgPreloadPrefix)?this.options.jr_imgPreloadPrefix:"prl";if($defined(this.options.jr_buttonType)){d.taskType=this.options.jr_buttonType}this.processRequest({requestType:"xol",url:this.options.jr_srcUrl+"jrcms.php",data:d,jr_useSpinner:false,onSuccess:function(g,e,f){d.imgArray=new Array();f.img.each(function(j,h){d.imgArray.push(j.src)}.bind(this));this._preloadedImages=new Asset.images(d.imgArray,{onComplete:(!$defined(d.onComplete)?function(h){this.jrLog("T:2#>> preLoadImages finished!",2)}.bind(this):d.onComplete),onError:function(){this.jrLog("F#>> preLoadImages.AssetImages Failure !!!")}.bind(this)})}.bind(this)})}else{this._preloadedImages=new Asset.images(d.imgArray,{onComplete:(!$defined(d.onComplete)?function(e){this.jrLog("T:2#>> preLoadImages finished!",2)}.bind(this):d.onComplete),onError:function(){this.jrLog("F#>> preLoadImages.AssetImages Failure !!!")}.bind(this)})}}catch(c){this.jrLog("F#>> preLoadImages fail: "+c)}},getLangItemSet:function(){return window.document.retrieve("jr_langTxt")||(new Object())},getLangItem:function(d){var c=this.getLangItemSet();return $defined(c[d])?c[d]:""},retrieveLangFile:function(d,g,c){try{var f=new Object();f.a="getLangFile";f.fn=d+g;this.processRequest({requestType:"xol",url:"src/jrcms.php",method:"get",data:f,onSuccess:function(k,h,j){if($type(j)=="object"){window.document.store("jr_langTxt",$merge(j,this.getLangItemSet()))}else{this.jrLog("F#>> retrieveLangFile failed for: "+($defined(this._pluginInfo)?(this._pluginInfo.name+": "+g):(g))+" !")}if($type(c)=="function"){c.run()}}.bind(this)})}catch(e){this.jrLog("F#>> retrieveLangFile fail: "+e)}},accessRights:function(e,c,d){if(!$defined(d)){d="default"}switch(d){case"read":return this.readRights(e,c);break;case"write":return this.writeRights(e,c);break;case"create":return this.createRights(e,c);break;default:return(this.readRights(e,c)&&this.writeRights(e,c)&&this.createRights(e,c))}return false},writeRights:function(d,c){d.trim();c.trim();if(d.length<3||c.length<3){throw new Error("writeRights with wrong parameter called!")}return((d.substr(1,1).toInt()>=c.substr(1,1).toInt())&&d.substr(1,1).toInt()>0)},readRights:function(d,c){d.trim();c.trim();if(d.length<3||c.length<3){throw new Error("readRights with wrong parameter called!")}return(d.substr(0,1).toInt()>=c.substr(0,1).toInt())},createRights:function(d,c){d.trim();c.trim();if(d.length<3||c.length<3){throw new Error("createRights with wrong parameter called!")}return((d.substr(2,1).toInt()>=c.substr(2,1).toInt())&&d.substr(2,1).toInt()>0)},writeMenuHTML:function(c,g){try{this.jrLog("T:3>> writeMenuHTML.menuHtml: "+c.replace(/<\/?[^>]+(>|$)/g,"").substr(0,120),3);if(!$defined(g)){var g=new Object()}g=$merge({divMenu:this.options.jr_divVMenu,divRightDisplay:"block"},g);c.stripScripts(true);if((g.divMenu!=this.options.jr_divRMenu)||(g.divMenu==this.options.jr_divRMenu&&$defined($(this.options.jr_divRMenu))&&$(this.options.jr_divRMenu).get("html").indexOf("<ul>")>-1&&c=="")||(g.divMenu==this.options.jr_divRMenu&&c!="")){$(g.divMenu).empty().set("html",c);$(g.divMenu).scrollTop=$(g.divMenu).scrollHeight;if(((g.divMenu==this.options.jr_divVMenu||g.divMenu==this.options.jr_divHMenu)&&g.divRightDisplay=="none")||(g.divMenu==this.options.jr_divRMenu&&c==""&&g.divRightDisplay=="none")){this.hideFrame((($type(this.options.jr_showRMenu))?(this.options.jr_showRMenu):(this.options.jr_divRMenu)))}else{this.showFrame((($type(this.options.jr_showRMenu))?(this.options.jr_showRMenu):(this.options.jr_divRMenu)))}if($type(g.postMenuFunc)=="function"){g.postMenuFunc.run()}return true}return false}catch(d){var f=" writeMenuHTML: "+d;if(this.options.jr_debug){throw new Error(f)}}},writeButtonsHTML:function(c,h){try{this.jrLog("T:3>> writeButtonsHTML.ctrlHtml: "+c.replace(/<\/?[^>]+(>|$)/g,"").substr(0,120),3);if(!$defined(h)){var h=new Object()}this.showFrame((($defined(h.showCtrl))?(h.showCtrl):(this.options.jr_showButtonsWrap)));if(!$defined(h.divCtrl)){h.divCtrl=this.options.jr_divButtons}if($defined(c)){if(!$(h.divCtrl)){var f=new Element("div",{id:h.divCtrl});$(($defined(h.divCtrlWrap)?(h.divCtrlWrap):(this.options.jr_divButtonsWrap))).grab(f)}this.showFrame(h.divCtrl);$(h.divCtrl).set("html",c)}}catch(d){var g=" writeButtonsHTML: "+d;if(this.options.jr_debug){throw new Error(g)}}},writeCssData:function(c){try{this.jrLog("T:3>> writeCssData.cssData: "+c.mnu_css.substr(0,10),3);if($defined(c.mnu_css)&&c.mnu_css!="none"){this.writeCSS(c.mnu_css)}if($defined(c.mdesc)&&c.mdesc!="none"){var g=$$("meta[name=description]");g[0].set("content",c.mdesc)}if($defined(c.mkey)&&c.mkey!="none"){var g=$$("meta[name=keywords]");g[0].set("content",g[0].get("content")+" "+c.mkey)}}catch(d){var f=" writeCssData: "+d;if(this.options.jr_debug){throw new Error(f)}}},cssProperty:function(g,d){try{g=g.replace(/\#|\./g,"");if(g==""){return false}var c=d.replace(/;/g,"").toLowerCase().split(":");if($defined($(g))){$(g).setStyle(c[0],c[1])}else{if($defined($$("."+g))){$$("."+g)[0].setStyle(c[0],c[1])}else{if($defined($$(g))){$$(g)[0].setStyle(c[0],c[1])}}}}catch(f){var h=" cssProperty failure: "+f;if(this.options.jr_debug){throw new Error(h)}}},writeCSS:function(e){e=e.replace("/ |\n|\r/g","");var d=new Array();var c=e.split("}");c.each(function(g,f){d=g.split("{");this.cssProperty(d[0],d[1])}.bind(this))},getHelpDoc:function(e){try{if(!$defined(e)){var e=new Object()}if(!$defined(e.plugin)){e.plugin=this._pluginInfo.name}if(!this.writeRights(this.getUserLevel(),this.options.jr_webmasterLevel)){e.helpIFrame="ifrHelpContent";e.divCont=e.helpIFrame;if(!$defined($(this.options.jr_divHelp))){$$("body").grab((new Element("div",{id:this.options.jr_divHelp})).grab((new Element("div",{"class":"helpTasks"})).grab((new Element("a",{id:"helpToggle",href:"#"})).grab(new Element("img",{src:"src/images/help_enabled.gif"}))).grab(new Element("br")).grab((new Element("a",{id:"helpClose",href:"#"})).grab(new Element("img",{src:"src/images/close_enabled.gif"})))).grab(new Element("div",{id:e.helpIFrame})).grab(new Element("div",{"class":"nf"})));var c=new Fx.Slide(e.helpIFrame,{mode:"horizontal"});$("helpToggle").addEvent("click",function(f){f.stop();c.toggle()});$("helpClose").addEvent("click",function(f){f.stop();this.hideFrame(this.options.jr_divHelp)}.bind(this));this.showFrame(this.options.jr_divHelp);c.slideIn()}else{this.showFrame(this.options.jr_divHelp)}}e.a="getHelpDoc";this.processRequest({requestType:"xol",url:jrCMS.options.jr_srcUrl+jrCMS.options.jr_phpSRC,data:e,onSuccess:((!this.writeRights(this.getUserLevel(),this.options.jr_webmasterLevel))?(function(g,f,h){this.writeContentHTML(h.conthtml,e)}.bind(this)):undefined)})}catch(d){this.jrLog("F#>> jrCMS.getHelpDoc failure: "+d)}},saveHelpDoc:function(d){try{if(!$defined(d)){return false}d.cont=jrCmsEditor.getXinhaTextArea();this.processRequest({requestType:"html",url:jrCMS.options.jr_srcUrl+jrCMS.options.jr_phpSRC,data:d,onSuccess:function(g,e,h,f){if($defined(f)){$exec(f)}}.bind(this)})}catch(c){this.jrLog("F#>> jrCMS.saveHelpDoc failure: "+c)}},setUserLevel:function(c){if($defined(window.jrCmsInit)){jrCmsInit.setOptions({jr_userLevel:c})}else{this.setOptions({jr_userLevel:c})}},getUserLevel:function(){if($defined(window.jrCmsInit)){return jrCmsInit.options.jr_userLevel}else{return this.options.jr_userLevel}},_globalOptions:b,_contentLoadedOnce:false,_delayProcessRequest:false,_preloadedImages:null,_reloadPageCalled:null,_slideLogin:null,_showFrameLoadingSpinner:null,writeContent:function(c){c.strHtml.stripScripts(true);$(c.divCont).set("html",c.strHtml);if($defined(c.anchor)&&$defined($$('a[name="'+c.anchor+'"]')[0])){$(c.divCont).scrollTo(0,($$('a[name="'+c.anchor+'"]')[0].offsetTop-4))}else{$(c.divCont).scrollTo(0,0)}this._contentLoadedOnce=true;if($type(c.postMainFunc)=="function"){c.postMainFunc.run()}if(!c.noEditor&&$type(window.jrCmsEditor)=="object"){jrCmsEditor.activateEditor(c.strHtml)}},loadImagesAndWriteContent:function(c){c.imgArray=c.imgArray.map(function(e,d){if(e.search(/src="/)>=0){return((e.match(/src="[^"]*"/g)[0]).replace(/src="/g,"")).replace(/"/g,"")}else{return((e.match(/src=[^\s]*/g)[0]).replace(/src=/g,""))}});c.onComplete=function(){this.jrLog("T:2#>> loadImagesAndWriteContent finished!",2);this.writeContent(c)}.bind(this);this.preLoadImages(c)},showMenuId:function(d,c){if($defined(c)){c.each(function(f,e){this.hideMenuId(f)}.bind(this))}if($defined($(d))){$(d).show()}},hideMenuId:function(c){if($defined($(c))){$(c).hide()}}})})();(function(){var b=new Object;var a={dlgEnabled:true,dlgUrl:undefined,dlgSrc:undefined,dlgText:{_kill:"Kill Dialog",_hide:"Hide Dialog",_show:"Show Dialog",_lock:"Lock Dialog",_unlock:"Unlock Dialog"},dlgFrameStyle:"top:1px;right:1px;",dlgContent:"dlg",dlgParent:null,dlgKillable:true,dlgDragable:true,dlgSizable:true,dlgScroller:true,dlgMenu:true,dlgType:"top",dlgTitle:undefined,dlgOpacity:1,dlgButtons:null,dlgUseFieldset:true,dlgCssClass:undefined,dlgWrapper:"div",dlgPlacement:"top",dlgMovable:false,dlgLeftWidth:undefined,dlgRightWidth:undefined,dlgMinSize:{x:100,y:100},dlgLockOriginalSize:true,dlgKeepInContainer:true,dlgTabIndex:1,dlgWithEditor:false,dlgFadeTime:100,dlgDebug:false,dlgDebugOutput:"divSaveResult",dlgWrapperOpt:new Object()};JRCmsForm.implement({Implements:[Events,Options,Chain],createDialog:function(c,e){b=this;if(!$defined(c.dlgParent)){c.dlgParent=$$("body")[0]}if(($defined(c.dlgType)&&(c.dlgType!="top"&&c.dlgType!="login"))||($defined(c.dlgDragable)&&!c.dlgDragable)){c.dlgDragable=false;c.dlgSizable=false;c.dlgScroller=false}c=b.setDialogOptions(c);b.killDialog(c);b.dlgCreated=true;b.dlgOriginalSize=false;var d=new Element(c.dlgWrapper,$merge({id:"dlgWrapper"+c.dlgType,"class":"dlgwrapper"+($defined(c.dlgCssClass)?" "+c.dlgCssClass:""),style:c.dlgFrameStyle},c.dlgWrapperOpt));d.store("options",c);d.store("dlgElScr",new Element("div",{"class":(c.dlgScroller?"_scroller":"_nscroller")}));d.store("dlgElCont",new Element("div",{id:c.dlgContent}));d.store("dlgElMenu",new Element("div",{id:"dlgMenu"+c.dlgType,"class":"dlgmenu"}));if(c.dlgMenu){b.addDialogButtons(d)}if(c.dlgType!="top"&&c.dlgType!="login"){d.retrieve("dlgElMenu").setStyle("height",d.retrieve("dlgElCont").getSize().y)}if(c.dlgSizable){d.store("dlgElSz",new Element("div",{id:"dlgSize",events:{mousedown:function(f){f.stopPropagation();d.addEvent("selectstart",b.stopEvent)},mouseup:function(f){d.removeEvent("selectstart",b.stopEvent)},contextmenu:b.stopEvent}}))}b.insertDialog(d,e);b.toggleLockDialog(c)},writeDialog:function(g,c){try{b=this;var c=$merge($merge(a,c),g.header);var d=$(c.dlgContent);d.eliminate("options");d.eliminate("dlgElCont");d.eliminate("dlgElAccWrapper");d.addClass("dlgwrapper");d.store("options",c);d.store("dlgElCont",$(c.dlgContent));b.writeDialogContent(d,g)}catch(f){var h=" writeDialog: "+f;if(c.dlgDebug){throw new Error(h)}}},saveDialog:function(d,f,g){var h=false;if($defined(f)){f.run()}if($defined(d.a)){$$('input[name="a"]').set("value",d.a)}var c=$$("form");var e=$$(".dlgwrapper")[0];c.each(function(k,j){if(($defined(d.formOnly)&&!d.formOnly.contains(k.name.substr(0,k.name.indexOf("_"))))||($defined(d.formExclude)&&d.formExclude.contains(k.name.substr(0,k.name.indexOf("_"))))){c[j]=null}});c=c.erase(null);if(e.retrieve("options").dlgDebug>=4){$(e.retrieve("options").dlgDebugOutput).empty()}if(e.retrieve("options").dlgWithEditor){this.syncTextAreas()}c.each(function(k,j){if($defined(k)){var l=new Form.Validator(k,{evaluateOnSubmit:false,evaluateFieldsOnBlur:false,evaluateFieldsOnChange:false,errorPrefix:"imacs: ",onFormValidate:function(o,n,m){if(o){if(e.retrieve("options").dlgType!="login"){this.killDialog(e.retrieve("options"))}else{this.toggleHideDialog(e.retrieve("options"));e.retrieve("dlgElScr").setStyle("opacity",0)}this.processRequest({requestType:"form",data:n,evalScripts:(c.length-1==j)?true:false,async:false,onSuccess:(e.retrieve("options").dlgDebug>=4)?(function(p){$(e.retrieve("options").dlgDebugOutput).set("html",$(e.retrieve("options").dlgDebugOutput).get("html")+"<br />"+p)}.bind(this)):(function(){}.bind(this))})}}.bind(this),onElementFail:function(n,m){h=true;n.focus();alert(e.retrieve("options").dlgText[m[0]])}.bind(this),onElementPass:function(m){this.saveDialogValue(m)}.bind(this)});l.validate();if(c.length-1==j&&$defined(g)){g.run(!h,this)}}}.bind(this))},elCheckbox:function(c,e,d){c.set({type:"checkbox","class":"checkbox",value:(d?1:0),checked:d});c.addEvent("click",function(f){f.target.value=(f.target.checked?1:0)}.bind(this));return this.elInput(c)},elCheckboxes:function(d,f,e,c){d.set({type:"checkbox",name:d.get("name")+"[]"});return this.elInput(d,f,e,c)},elRadiobox:function(d,f,e,c){d.set("type","radio");return this.elInput(d,f,e,c)},elPassword:function(c,e,d){return c.set("type","password")},elOptions:function(d,g,f,c){function e(j,k,h){h.each(function(n,l){var m=new Element("option",{value:n.idx,html:n.value});if(k==n.idx){m.set("selected",true)}j.grab(m)});return j}if($type(c)=="function"){d.addEvent("click",function(j){$(j.target).removeEvents();var h=$(j.target).options[$(j.target).selectedIndex].value;$(j.target).empty();$(j.target).grab(new Element("option",{value:undefined,html:this.getLangItem("option_select")}));return e($(j.target),h,c())}.bind(this));d.grab(new Element("option",{value:f,html:(this.getLangItem(f).length>0?this.getLangItem(f):f),selected:true}))}else{d=e(d,f,c)}return d},elSubDlg:function(d,g,e,c){var f=new Object();f.el=d;f.valueName=g;f.value=e;c.delay(50,this,f);return d},elCalendar:function(c,e,d){c=(d!="")?c.set("value",Date.parse(d).format("%x")):c;var f=new Element("span",{"class":"dlgCalendar"}).grab(c).grab(new Element("img",{id:"togglePicker_"+c.id,alt:"",src:"src/assets/vlacalendar/images/calendar.gif","class":"pickerImg",width:"13px",height:"12px"}));this.loadScriptFiles({jsfile:"vlacal-v2.1.cmp.js",path:this.options.jr_assetsUrl+"vlacalendar/jslib/",loadfunc:function(){this.loadStyleFiles([{cssfile:"vlacal-v2.1.css",path:this.options.jr_assetsUrl+"vlacalendar/styles/"}]);new vlaDatePicker(c.id,{openWith:"togglePicker_"+c.id,offset:{y:-2,x:2},format:"m/d/y",ieTransitionColor:"",prefillDate:false,filePath:this.options.jr_assetsUrl+"vlacalendar/inc/"})}.bind(this)});return f},processDialogValue:function(c,e,d){return c},saveDialogValue:function(c){return true},dialogElement:function(e,d,c,f,g){return({valueName:e,value:d,valueGroup:c,valueDialogMethod:($defined(f)?f:"input"),valueValidator:($defined(g)?g:"none")})},dialogHeader:function(e,d,c){return({refName:e,value:d,a:($defined(c)?c:"todo")})},changeDialogElementValue:function(c,e,d){$A(c).each(function(f,g){if(f.valueName==e){c[g].value=d}},this);return c},actEditorForElement:function(c){if($defined(window.jrCmsEditor)){jrCmsEditor.activateEditorForElement(c)}},syncTextAreas:function(){if($defined(window.jrCmsEditor)){jrCmsEditor.syncXinhaTextAreas()}},setDialogOptions:function(c){if($defined(c.dlgType)){c.dlgType=c.dlgType.toLowerCase()}c=$merge(a,c);var d=function(h){var e=new Array();var g=new Object();var f=new Object();if(h.dlgKillable){g._kill=new Element("div",{id:"_kill"+h.dlgContent,"class":"_kill _stdbutton",events:{click:function(){b.killDialog(h)}}})}g._hide=new Element("div",{id:"_hide"+h.dlgContent,"class":"_hide _stdbutton",events:{click:function(){b.toggleHideDialog(h)}}});if(h.dlgDragable){g._lock=new Element("div",{id:"_lock"+h.dlgContent,"class":"_lock _stdbutton",events:{click:function(){b.toggleLockDialog(h)}}})}if($defined(h.dlgTitle)){f._title=new Element("div",{id:"_title"+h.dlgContent,"class":"_dlgtitle",html:h.dlgTitle})}if($defined(h.dlgButtons)){$each(h.dlgButtons,function(k,j){h.dlgButtons[j]=new Element("div",{id:j+h.dlgContent,"class":j+" _button",events:{click:k}})})}h.dlgButtons=(h.dlgType=="top"||h.dlgType=="login")?($merge(h.dlgButtons,f,g)):($merge(g,h.dlgButtons));$each(h.dlgButtons,function(k,j){k.set("title",h.dlgText[j]);e.push(k)});return e};c.dlgButtons=d(c);return c},insertDialog:function(d,e){var c=d.retrieve("options");if($defined(e)){d.store("options",$merge(d.retrieve("options"),e.header));this.writeDialogContent(d,e)}d.inject(c.dlgParent,c.dlgPlacement).adopt(d.retrieve("dlgElMenu"),d.retrieve("dlgElScr").grab(d.retrieve("dlgElCont")),d.retrieve("dlgElSz"));if(c.dlgDragable){d.store("dlgDragger",d.makeDraggable({container:b.getDialogContainer(c),handle:$(c.dlgContent+"Menu"+c.dlgType),onDrag:b.addDialogDragger.bind(this,d),onComplete:b.addDialogComplete.bind(this,d)}))}if(c.dlgSizable){d.store("dlgResizer",d.makeResizable({handle:d.retrieve("dlgElSz"),onDrag:b.addDialogSizer.bind(this,d),onComplete:b.addDialogComplete.bind(this,d)}))}d.set("opacity",c.dlgOpacity);this.updateDialogSize(d)},toggleLockDialog:function(c){var e=$("dlgWrapper"+c.dlgType);var d=$$("#dlgMenu"+c.dlgType+" ._lock")[0]||$$("#dlgMenu"+c.dlgType+" ._unlock")[0];if(c.dlgMovable){if($chk(d)){d.removeClass("_unlock");d.addClass("_lock");d.setAttribute("title",c.dlgText._lock);e.retrieve("dlgElMenu").setStyle("cursor","move");if($chk(e.retrieve("dlgElSz"))){e.retrieve("dlgElSz").setStyle("cursor","se-resize")}}if($defined(e.retrieve("dlgDragger"))){e.retrieve("dlgDragger").attach()}if($defined(e.retrieve("dlgResizer"))){e.retrieve("dlgResizer").attach()}}else{if($chk(d)){d.removeClass("_lock");d.addClass("_unlock");d.setAttribute("title",c.dlgText._unlock);e.retrieve("dlgElMenu").setStyle("cursor","default");if($chk(e.retrieve("dlgElSz"))){e.retrieve("dlgElSz").setStyle("cursor","default")}}if($defined(e.retrieve("dlgDragger"))){e.retrieve("dlgDragger").detach()}if($defined(e.retrieve("dlgResizer"))){e.retrieve("dlgResizer").detach()}}return c.dlgMovable=!c.dlgMovable},toggleHideDialog:function(c){var d=$$("#dlgMenu"+c.dlgType+" ._hide")[0]||$$("#dlgMenu"+c.dlgType+" ._show")[0];if(!b.uiHidden){if($chk(d)){d.removeClass("_hide");d.addClass("_show");d.setAttribute("title",c.dlgText._show)}b.hideDialog(c)}else{if($chk(d)){d.removeClass("_show");d.addClass("_hide");d.setAttribute("title",c.dlgText._hide)}b.showDialog(c)}return b.uiHidden=!b.uiHidden},killDialog:function(c){if($chk($("dlgWrapper"+c.dlgType))){$("dlgWrapper"+c.dlgType).dispose()}b.dlgOriginalSize=false;b.dlgCreated=false},getDialogContainer:function(c){return c.dlgKeepInContainer?Browser.Engine.trident?false:c.dlgParent:false},getDialogOriginalSize:function(c){return b.dlgOriginalSize=!b.dlgOriginalSize?c.getSize():b.dlgOriginalSize},updateDialogSize:function(c){if(c.retrieve("options").dlgType!="top"&&c.retrieve("options").dlgType!="login"){c.retrieve("dlgElMenu").setStyle("height",((c.retrieve("dlgElCont").getSize().y<c.getSize().y)?c.getSize().y:c.retrieve("dlgElCont").getSize().y))}},lockDialogSize:function(c){var d=c.retrieve("options").dlgLockOriginalSize?b.getDialogOriginalSize(c):c.retrieve("options").dlgMinSize;if(c.getSize().y<d.y){c.setStyle("height",d.y)}if(c.getSize().x<d.x){c.setStyle("width",d.x)}},addDialogButtons:function(c){var d=function(f){var e=[];$each(f.retrieve("options").dlgButtons,function(g){e.push(g)});return e};c.store("dlgElMenu",c.retrieve("dlgElMenu").adopt(d(c)))},addDialogSizer:function(c){b.addDialogDragger(c);b.lockDialogSize(c)},addDialogDragger:function(c){c.retrieve("dlgElScr").addEvent("selectstart",b.stopDialogEvent);c.retrieve("dlgElScr").setStyle("MozUserSelect","none")},addDialogComplete:function(c){c.retrieve("dlgElScr").removeEvent("selectstart",b.stopDialogEvent);c.retrieve("dlgElScr").setStyle("MozUserSelect","text")},stopDialogEvent:function(c){return c.stop()},showDialog:function(c){if(!$chk($("dlgWrapper"+c.dlgType))){return false}var d=$("dlgWrapper"+c.dlgType);if(Fx.Tween){d.retrieve("dlgElScr").set("tween",{duration:c.dlgFadeTime}).fade("in");if($chk(d.retrieve("dlgElSz"))){d.retrieve("dlgElSz").setStyle("visibility","visible")}}else{d.retrieve("dlgElScr").setStyle("display","")}return $("dlgWrapper"+c.dlgType).fireEvent("show")},hideDialog:function(c){if(!$chk($("dlgWrapper"+c.dlgType))){return false}var d=$("dlgWrapper"+c.dlgType);if(Fx.Tween){d.retrieve("dlgElScr").set("tween",{duration:c.dlgFadeTime}).fade("out");if($chk(d.retrieve("dlgElSz"))){d.retrieve("dlgElSz").setStyle("visibility","hidden")}}else{d.retrieve("dlgElScr").setStyle("display","none")}return $("dlgWrapper"+c.dlgType).fireEvent("hide")},writeDialogContent:function(d,e){var c="";e.data.each(function(g,f){if(c!=g.valueGroup.split(":")[0]){c=g.valueGroup.split(":")[0];if($defined(g.valueGroup.split(":")[1])){d.store("options",$merge(d.retrieve("options"),{dlgFormSrc:(g.valueGroup.split(":")[1]).toLowerCase()+"/"+(g.valueGroup.split(":")[1]).toLowerCase()+".php"}))}else{if($defined(d.retrieve("options").dlgSrc)){d.store("options",$merge(d.retrieve("options"),{dlgFormSrc:d.retrieve("options").dlgSrc}))}else{throw new Error("no dlgSrc specified")}}d.retrieve("dlgElCont").grab(this.dlgForm(d,c))}g.valueGroup=c;this.dlgRow(d,g)}.bind(this))},dlgForm:function(d,c){d.store("dlgElForm",new Element("form",{name:c+"_form","class":"dlgForm"+($defined(d.retrieve("options").dlgCssClass)?" "+d.retrieve("options").dlgCssClass:""),action:d.retrieve("options").dlgUrl+d.retrieve("options").dlgFormSrc,method:"post",events:{submit:function(f){this.stopDialogEvent(f)}.bind(this)}}));d.store("dlgElTable",new HtmlTable({properties:{id:c+"_tbl","class":d.retrieve("options").dlgContent+"Table"+($defined(d.retrieve("options").dlgCssClass)?" "+d.retrieve("options").dlgCssClass:"")}}));d.retrieve("dlgElForm").adopt(this.dlgHiddenInput({valueName:d.retrieve("options").refName,value:d.retrieve("options").value}),this.dlgHiddenInput({valueName:"a",value:d.retrieve("options").a}),d.retrieve("dlgElTable"));if(d.retrieve("options").dlgUseFieldset){return new Element("fieldset",{"class":c+" dlgFieldset"+($defined(d.retrieve("options").dlgCssClass)?" "+d.retrieve("options").dlgCssClass:"")}).grab(new Element("legend",{html:d.retrieve("options").dlgText[c]}),"top").grab(d.retrieve("dlgElForm"),"bottom")}else{return d.retrieve("dlgElForm")}},dlgRow:function(c,d){switch(d.valueDialogMethod.split(":")[0].toLowerCase()){case"text":c.retrieve("dlgElTable").push([this.dlgColL(c,d,2)]);break;case"accordion":case"accordioneditor":if(!$chk(c.retrieve("dlgElAccWrapper"))){c.retrieve("dlgElTable").push([this.dlgColR(c,d,2)])}this.dlgAccordion(c,d);break;case"hidden":c.retrieve("dlgElForm").grab(this.dlgHiddenInput(d),"top");break;default:c.retrieve("dlgElTable").push([this.dlgColL(c,d,1),this.dlgColR(c,d,1)])}},elInput:function(d,f,e,c){var g=new Element("span",{"class":"checkboxes"});if($defined(c)){c.each(function(k,j){var h=d.clone();if(k.idx==e){h.set("checked",true)}h.set({value:k.idx,title:k.value});g.grab(h).grab(new Element("span",{html:k.value}))})}else{g.grab(d)}return g},dlgHiddenInput:function(c){return new Element("input",{id:c.valueName,name:c.valueName,value:c.value,type:"hidden"})},dlgInput:function(c,e){var d=new Element("input",{id:e.valueName,name:e.valueName,title:c.retrieve("options").dlgText[e.valueName],"class":(e.valueValidator!="none"?e.valueValidator:""),value:e.value,tabindex:c.retrieve("options").dlgTabIndex++,disabled:(e.valueValidator=="disabled")?true:false});return(!$defined(e.valueDialogMethod.split(":")[1]))?d:window[e.valueDialogMethod.split(":")[1]].processDialogValue(d,e.valueName,e.value)},dlgTextarea:function(c,d){var e=new Element((d.valueValidator!="disabled"?"textarea":"div"),{id:d.valueName,name:d.valueName,title:c.retrieve("options").dlgText[d.valueName],"class":(d.valueValidator!="none"?d.valueValidator:""),html:d.value,tabindex:c.retrieve("options").dlgTabIndex++,readonly:(d.valueValidator=="disabled")?true:false});e=(!$defined(d.valueDialogMethod.split(":")[1]))?e:window[d.valueDialogMethod.split(":")[1]].processDialogValue(e,d.valueName,d.value);if(d.valueValidator!="disabled"&&d.valueDialogMethod.split(":")[0].toLowerCase().search(/editor/)!=-1){c.store("options",$merge(c.retrieve("options"),{dlgWithEditor:true}));this.actEditorForElement(e)}return e},dlgSelect:function(c,e){var d=new Element("select",{id:e.valueName,name:e.valueName,title:c.retrieve("options").dlgText[e.valueName],"class":(e.valueValidator!="none"?e.valueValidator:""),tabindex:c.retrieve("options").dlgTabIndex++,disabled:(e.valueValidator=="disabled")?true:false}).grab(new Element("option",{value:undefined,html:c.retrieve("options").dlgText.option_select,selected:true}));return($defined(e.valueDialogMethod.split(":")[1]))?window[e.valueDialogMethod.split(":")[1]].processDialogValue(d,e.valueName,e.value):d.grab(new Element("option",{value:0,html:e.value}))},dlgAccordion:function(d,g){if(!$chk(d.retrieve("dlgElAccWrapper"))){d.store("dlgElAccWrapper",new Element("div",{id:g.valueGroup+"_accordion","class":"accordion"}));d.eliminate(g.valueGroup+"_accordion");return d.retrieve("dlgElAccWrapper")}if(!$chk(d.retrieve(g.valueGroup+"_accordion"))){d.store(g.valueGroup+"_accordion",new Accordion(d.retrieve("dlgElAccWrapper"),"div.accordion_toggler","textarea.accordion_element",{opacity:false,onActive:function(j,h){j.setStyle("color","#000")},onBackground:function(j,h){j.setStyle("color","#666")}}))}var f=new Element("h3",{"class":"accordion_toggler",html:d.retrieve("options").dlgText[g.valueName]});var e=new Element("div",{"class":"accordion_element"}).grab(this.dlgTextarea(d,g));var c=0;d.retrieve(g.valueGroup+"_accordion").addSection(f,e,c)},dlgSubDlg:function(d,e){var f=new Element("span",{"class":"subDlg"}).grab((e.valueDialogMethod.split(":")[0].toLowerCase().search(/calendar/)!=-1)?this.dlgInput(d,$merge(e,{valueDialogMethod:"calender"})).grab():this.dlgHiddenInput(e));var c=new Element("div",{id:e.valueName+"_subdlg",name:e.valueName+"_subdlg",title:d.retrieve("options").dlgText[e.valueName]});return(!$defined(e.valueDialogMethod.split(":")[1]))?f:f.grab(window[e.valueDialogMethod.split(":")[1]].processDialogValue(c,e.valueName,e.value))},dlgElement:function(c,d){return((d.valueDialogMethod.split(":")[0].toLowerCase()=="input")?(this.dlgInput(c,d)):(d.valueDialogMethod.split(":")[0].toLowerCase()=="select")?(this.dlgSelect(c,d)):(d.valueDialogMethod.split(":")[0].toLowerCase().search(/textarea/)!=-1)?(this.dlgTextarea(c,d)):(d.valueDialogMethod.split(":")[0].toLowerCase().search(/accordion/)!=-1)?(this.dlgAccordion(c,d)):(d.valueDialogMethod.split(":")[0].toLowerCase().search(/subdialog/)!=-1)?(this.dlgSubDlg(c,d)):(d.valueDialogMethod.split(":")[0].toLowerCase().search(/calendar/)!=-1)?(this.dlgInput(c,d)):null)},dlgColL:function(e,f,c){var d=(c<=1?(e.retrieve("options").dlgText[f.valueName]+(f.valueValidator.search(/\brequired\b/)!=-1?"<sup>*</sup>: ":": ")):f.value);return{content:d,properties:{colspan:c,"class":f.valueGroup+"_left"+(c>1?"_c2 ":" ")+($defined(e.retrieve("options").dlgCssClass)?e.retrieve("options").dlgCssClass+" ":"")+f.valueName,styles:{padding:0,width:($defined(e.retrieve("options").dlgLeftWidth)?(c<=1?e.retrieve("options").dlgLeftWidth.toInt():e.retrieve("options").dlgLeftWidth.toInt()+e.retrieve("options").dlgRightWidth.toInt()):undefined)}}}},dlgColR:function(d,e,c){return{content:this.dlgElement(d,e),properties:{colspan:c,"class":e.valueGroup+"_right"+(c>1?"_c2 ":" ")+($defined(d.retrieve("options").dlgCssClass)?d.retrieve("options").dlgCssClass+" ":"")+e.valueName,styles:{padding:0,width:($defined(d.retrieve("options").dlgRightWidth)?(c<=1?d.retrieve("options").dlgRightWidth.toInt():d.retrieve("options").dlgLeftWidth.toInt()+d.retrieve("options").dlgRightWidth.toInt()):undefined)}}}}})})();(function(){JRCmsUtils.implement({chars2entities:function(d,c){var a="";d.replace(/\&amp;/,"&");d.replace(/\&nbsp;/," ");for(var b=0;b<d.length;b++){switch(d.charCodeAt(b)){case 39:case 43:if($defined(c)&&c=="proc"&&(d.charCodeAt(b)==45)){a+=d.charAt(b)}else{a+="%#"+d.charCodeAt(b)+";"}break;default:if(d.charCodeAt(b)>127){a+="%#"+d.charCodeAt(b)+";"}else{a+=d.charAt(b)}}}return a},dec2bin:function(h){var f=new Array();var g="";for(var d=0;d>-1;d++){var e=Math.pow(2,d);if(e>h){break}f[d]=e}f.reverse();for(var c=0;c<f.length;c++){var a=f[c];var b=parseInt(h/a);g+=b+"";h-=f[c]*b}return g},bin2dec:function(c){var c=c+"";var d=c.split("");d.reverse();var e=0;for(var b=0;b<d.length;b++){var a=d[b]*Math.pow(2,b);e+=a}return e},resolveRelativeUrl:function(d,c){if(c.match(/^([^:]+\:)?\/\//)){return c}else{var a=d.split("/");if(a[a.length-1]===""){a.pop()}var e=c.split("/");if(e[0]=="."){e.shift()}while(e[0]==".."){a.pop();e.shift()}return a.join("/")+"/"+e.join("/")}},convertDirToUrl:function(a){if($type(a)=="string"){a=a.replace(/^\//,"");a=a.replace(/\x2f*$/,"/");if(!a.match(/^([^:]+\:)?\//)){var b=window.location.toString().replace(/\?.*$/,"").split("/");b.pop();a=this.resolveRelativeUrl(b.join("/"),a)}}else{a=window.location.toString().replace(/\?.*$/,"").split("/");a.pop();a=this.resolveRelativeUrl(a.join("/"),"")}return a},getUniqueScriptId:function(b,a){return(!$defined(a)?"jrsrc":a).toLowerCase()+"-"+b.replace(/([a-z])([A-Z])([a-z])/g,function(e,d,c,f){return d+"-"+c.toLowerCase()+f}).toLowerCase()},getUniqueStylesFileId:function(a,b){return this.getUniqueScriptId(a,(!$defined(b)?"jrcss":b))},getElementsByClassName:function(h,g){if(!g){g=document.getElementsByTagName("body")[0]}var b=[];var f=new RegExp("\\b"+h+"\\b");var e=g.getElementsByTagName("*");for(var d=0,c=e.length;d<c;d++){if(f.test(e[d].className)){b.push(e[d])}}return b},pageSelect:function(d){if(!$defined(d)){var d=new Object()}this.setOptions({jr_maxPage:Math.ceil(($defined(d.total)?(d.total/d.perpage):1))});var a=new Element("div");a.addClass("pSDiv");a.setStyle("width","auto");a.setStyle("height",this.options.jr_repCtrlHeight);a.inject(this.options.jr_divMain);var b=new Element("div");b.addClass("pSDiv2");a.appendChild(b);var c='<div class="pSGroup"><select class="rp" name="rp">';this.options.jr_perPageOptions.each(function(f,e){c+='<option value="'+f+'" '+(((!$defined(d.perpage)&&e==0)||($defined(d.perpage)&&d.perpage==f))?'selected="selected">':">")+f+"</option>"}.bind(this));c+="</select></div>";c+='<div class="btnseparator"></div><div class="pSGroup"><div class="pFirst pButton"></div><div class="pPrev pButton"></div></div>';c+='<div class="btnseparator"></div><div class="pSGroup"><span class="pcontrol"><input type="text" value="'+d.page+'" size="2" style="text-align:center"/> / '+this.options.jr_maxPage+"<span></span></span></div>";c+='<div class="btnseparator"></div><div class="pSGroup"><div class="pNext pButton"></div><div class="pLast pButton"></div></div>';b.innerHTML=c;b.getElement(".pFirst").addEvent("click",this.jrFirstPage.bind(this,d));b.getElement(".pPrev").addEvent("click",this.jrPrevPage.bind(this,d));b.getElement(".pNext").addEvent("click",this.jrNextPage.bind(this,d));b.getElement(".pLast").addEvent("click",this.jrLastPage.bind(this,d));b.getElement(".rp").addEvent("change",this.jrPerPageChange.bind(this,d));b.getElement("input").addEvent("keyup",this.jrPageChange.bind(this,d))},jrFirstPage:function(a){a.page=1;this[a.a].run(a,this)},jrPrevPage:function(a){if(parseInt(a.page)>1){a.page--;this[a.a].run(a,this)}},jrNextPage:function(a){if((parseInt(a.page)+1)>this.options.jr_maxPage){return}a.page++;this[a.a].run(a,this)},jrLastPage:function(a){a.page=this.options.jr_maxPage;this[a.a].run(a,this)},jrPerPageChange:function(a){a.page=1;a.perpage=$(this.options.jr_divMain).getElement(".rp").value;this[a.a].run(a,this)},jrPageChange:function(b){var a=$(this.options.jr_divMain).getElement("div.pSDiv2 input").value;if(a>0&&a<=this.options.jr_maxPage){if(this.refreshDelayID){$clear(this.refreshDelayID)}b.page=a;this.refreshDelayID=this[b.a].run(b,this).delay(1000,this,$merge(b))}},setButtonEvent:function(a,c){try{if($defined(a)){if($type(c)=="function"){$(a).addEvent("click",c);$(a).erase("onclick");$(a).set("class","taskenabled");$(a).set("html",$(a).get("html").replace(/disabled/,"enabled"))}else{$(a).removeEvents("click");$(a).erase("onclick");$(a).set("class","taskdisabled");$(a).set("html",$(a).get("html").replace(/enabled/,"disabled"))}}else{throw new Error("wrong taskId")}}catch(b){var d=" setButtonEvent: "+b;if(this.options.jr_debug){throw new Error(d)}}},isSet:function(a,b){if(a.substr(b,1)==1){return true}else{return false}},buttonHandler:function(c,a,g){try{if($type(g)=="number"){g=this.dec2bin(g)}for(var b=0;b<g.length;b++){if(c[b].id!=null){if(this.isSet(g,b)){this.setButtonEvent(c[b].id,a[b])}else{this.setButtonEvent(c[b].id,0)}}}return true}catch(d){var f=" buttonHandler: "+d;if(this.options.jr_debug){throw new Error(f)}}},hideFrame:function(a){(($defined($(a)))?($(a)):(((a.test(".")&&$defined($$(a))))?($$(a)):($$("."+a)))).hide()},showFrame:function(a){(($defined($(a)))?($(a)):(((a.test(".")&&$defined($$(a))))?($$(a)):($$("."+a)))).show()},deleteFrame:function(a){(($defined($(a)))?($(a)):(((a.test(".")&&$defined($$(a))))?($$(a)):($$("."+a)))).dispose()},clearFrame:function(a){(($defined($(a)))?($(a)):(((a.test(".")&&$defined($$(a))))?($$(a)):($$("."+a)))).empty().set("html","")}})})();(function(){JRCmsPlugins.implement({_pluginLoadStatus:{},getPluginConstructor:function(a){a=a.substr(0,2).toUpperCase()+a.substr(2);return $type(window[a])=="class"?window[a]:undefined},getPluginScriptId:function(a){return this.getUniqueScriptId(a)},getPluginDir:function(a){return this.options.jr_pluginsUrl+a.toLowerCase()},pluginPing:function(b){var a=new Request({url:b.src,method:"head",emulation:true,onSuccess:function(){if($type(b.successHandler)=="function"){b.successHandler.run(b,this)}}.bind(this),onFailure:function(c){if($type(b.failHandler)=="function"){b.failHandler.run(b,this)}}.bind(this)});a.send(null)},setPluginState:function(b,a){this._pluginLoadStatus[b]=a},getPluginState:function(a){return this._pluginLoadStatus[a]},registerPlugin:function(c){if($type(c.pluginName)!="string"){throw new Error("JRCmsPlugins.registerPlugin with wrong parameter called!")}if(this.getPluginState(c.pluginName)=="failed"){return false}else{if(this.getPluginState(c.pluginName)!="loaded"&&this.getPluginConstructor(c.pluginName)==undefined){this.registerPlugin.delay(50,this,$merge(c));return false}}this.jrLog("T:3#>> Register Plugin: "+c.pluginName+" domReady! ",3);var a=this.getPluginConstructor(c.pluginName);if($type(a)!="class"){throw new Error("JRCmsPlugins.registerPlugin: This should never happen. But why does it do? ("+c.pluginName+")");return false}if(!$defined(a._pluginInfo)){a._pluginInfo={name:c.pluginName.substr(0,2).toLowerCase()+c.pluginName.substr(2)}}try{window[a._pluginInfo.name]=new a($merge(this.options,{cmp:c.cmp}),a._pluginInfo.name);this.setPluginState(c.pluginName,"ready");this.jrLog(("P:I>> Plugin: "+c.pluginName+" with Version: "+window[a._pluginInfo.name].getVersion()+" registered!"));if($type(c.successHandler)=="function"){c.successHandler.delay(20,this)}}catch(b){this.setPluginState(c.pluginName,"failed");if($defined($(this.getPluginScriptId(c.pluginName)))){$(this.getPluginScriptId(c.pluginName)).dispose()}this.jrLog("F#>> Can not register Plugin: "+c.pluginName+".  "+b)}},refreshPlugin:function(c){if($type(c.pluginName)!="string"){throw new Error("JRCmsPlugins.registerPlugin with wrong parameter called!")}var a=this.getPluginConstructor(c.pluginName);if($type(a)!="class"){throw new Error("JRCmsPlugins.refreshPlugin: This should never happen. But why does it do? ("+c.pluginName+")");return false}if(!$defined(a._pluginInfo)){a._pluginInfo={name:c.pluginName.substr(0,2).toLowerCase()+c.pluginName.substr(2)}}try{if($defined(window[a._pluginInfo.name])&&$defined(window[a._pluginInfo.name].refresh)){window[a._pluginInfo.name].refresh($merge(this.options,{cmp:c.cmp}));this.setPluginState(c.pluginName,"refreshed");this.jrLog(("P:I>> Plugin: "+c.pluginName+" with Version: "+window[a._pluginInfo.name].getVersion()+" refreshed!"));if($type(c.successHandler)=="function"){c.successHandler.delay(20,this)}}else{if($defined(window[a._pluginInfo.name])){this.registerPlugin(c)}}}catch(b){this.setPluginState(c.pluginName,"failed");$(this.getPluginScriptId(c.pluginName)).dispose();this.jrLog("F#>> Can not refresh Plugin: "+c.pluginName+".  "+b)}},loadPlugin:function(c){if($type(c)=="string"){var c=new Object({pluginName:c})}if($defined(this.getPluginConstructor(c.pluginName))){this.refreshPlugin(c);return true}this.setPluginState(c.pluginName,"loading");var a=this.getPluginDir(c.pluginName)+"/"+c.pluginName.toLowerCase()+(($defined(c.cmp)&&!c.cmp)?(".js"):(".cmp.js"));var b=new Asset.javascript(a,{"class":this.getPluginScriptId(c.pluginName),onload:function(){this.setPluginState(c.pluginName,"loaded");this.registerPlugin($merge(c))}.bind(this)});if(this.options.jr_debug>=6){this.pluginPing({src:a,pluginName:c.pluginName,successHandler:function(d){},failHandler:function(d){this._pluginLoadStatus[d.pluginName]="failed";this.jrLog("F#>> Plugin: "+d.pluginName+" with url: "+d.src+" missing")}})}return true},loadPlugins:function(a,b){a.each(function(c,d){if(this.readRights(this.getUserLevel(),c.userLevel)){if((d+1)>=a.length){c.successHandler=b}this.loadPlugin(c)}else{if(d==a.length-1){if($defined(b)){b.delay(20,this)}}}}.bind(this))},updateRegisteredPlugins:function(a,b){a.each(function(c,d){if(this.readRights(this.getUserLevel(),c.userLevel)){if((d+1)>=a.length){c.successHandler=b}this.registerPlugin(c)}else{if(d==a.length-1){if($defined(b)){b.delay(20,this)}}}}.bind(this))}})})();(function(){JRCmsCore.implement({Implements:[Options,JRCmsPlugins,JRCmsApi],options:{jr_lang:"de",jr_debug:false,jr_webmasterLevel:"999",jr_refreshVMenu:false,jr_loginHidden:false,jr_loginload:"home",jr_loginDialogHidden:true,jr_loginDispUserRole:undefined,jr_heightOfLogin:105,jr_heightOfLoginH:24,jr_dbischanged:false,jr_divFrame:"divFrame",jr_loginFailure:false},getClassId:function(){return this._coreInfo.classId},getVersion:function(){return(this._coreInfo.version+"_"+this._coreInfo.revision.slice(this._coreInfo.revision.search(/:.+/)+1)).replace(/\$/g,"").replace(/ /,"")},initialize:function(b,a){this.setOptions(b);this.setOptions({jr_phpSRC:"jrcms.php"});this.hideMainFrameLoading();this.retrieveLangFile(this.options.jr_srcUrl+"lang/","lang."+this.options.jr_lang,function(){this.setOptions({jr_langLoaded:true})}.bind(this));this.loadPlugins(this.options.jr_pluginList,this.loadPostProcessing)},loadPostProcessing:function(){this.loadStyleFiles();this.registerFunctions({instance:this._coreInfo.instance,classId:this.getClassId(),functions:[{functionName:"getContent",methodId:1,functionType:"ajax"},{functionName:"getContent",methodId:2,functionType:"aeditor"},{functionName:"getLogin",methodId:4,functionType:"ajax"},{functionName:"setLang",methodId:10,functionType:"js"},{functionName:"reloadPage",methodId:11,functionType:"js"},{functionName:"chgWindowSize",methodId:13,functionType:"ajax"},{functionName:"notImplemented",methodId:16,functionType:"js"},{functionName:"showAbout",methodId:17,functionType:"ajax"},{functionName:"getContentForNode",methodId:21,functionType:"js"}],successHandler:function(){this.jrLog("C:I>> imacs Version: "+this.getVersion()+" ready!");this.jrLog("C:I>> ========== jrCMS Init Sequence is finished ============");this._coreStatus="ready";this.updateXtpTable();if(this.options.jr_loadPage){this.reloadPage("home")}this.showMainFrameLoaded();this.getLoginSection(this.getUserLevel())}.bind(this)})},getContent:function(e,c){try{var a=1;if(!$defined(e.a)||e.a!="getcntNode"){var b=this.addRequestHP(this.getClassId()+a,e,"getContent")}if(!$defined(e.a)){e.a="getcnt"}e.mt=this.options.jr_menuType;this.processRequest({requestType:"xol",url:this.options.jr_srcUrl+this.options.jr_phpSRC,data:e,_hp:b,jr_useSpinner:e.a!="getcntNode"?true:false})}catch(d){this.jrLog("F#>> jrCMS.getContent failure: "+d)}},getContentForNode:function(d,b){try{var a=21;d.a="getcntNode";d.mt=this.options.jr_menuType;this.getContent(d)}catch(c){this.jrLog("F#>> jrCMS.getContentForNode failure: "+c)}},getLogin:function(c){try{var a=4;if(!$defined(c)){var c=new Object()}if(!$defined(c.a)){c.a="gin"}if(!$defined(c._div)){$(this.options.jr_divMain).empty().grab(new Element("div",{id:"divLoginDialog"}));c._div="divLoginDialog"}if($defined(this.options.jr_loginDispUserRole)){c.dsp_ur=true}$(c._div).empty();this.processRequest({requestType:"xol",url:this.options.jr_srcUrl+this.options.jr_phpSRC,_hp:undefined,data:c,jr_useSpinner:false,onSuccess:(function(f,d,e){this.writeDialog(e,{dlgContent:c._div,dlgText:this.getLangItemSet(),dlgUrl:this.options.jr_srcUrl,dlgSrc:this.options.jr_phpSRC,dlgUseFieldset:false})}.bind(this))})}catch(b){this.jrLog("F#>> jrCMS.getLogin failure: "+b)}},login:function(c){try{var a=6;this.saveDialog({a:(!$defined(c)?"in":c.a),formOnly:["loginDialog"]},$lambda,(function(d){if(d&&!this.options.jr_loginFailure){this.loadPlugins(this.options.jr_pluginList,function(){this.updateXtpTable();this.loadStyleFiles();this.getLoginSection(this.getUserLevel());this._reloadPageCalled=null;this.reloadPage("home")}.bind(this))}else{return false}}.bind(this)))}catch(b){this.jrLog("F#>> login failure: "+b)}},logout:function(c){try{var a=7;this.fireEvent("hide");if(!this.options.jr_loginHidden){$("dlgWrapperlogin").fireEvent("hide");this.saveDialog({a:(!$defined(c)?"out":c.a),formOnly:["loginDialog"]},$lambda,(function(d){if(d){this.reloadPage("ALL")}else{return false}}.bind(this)))}else{this.processRequest({url:this.options.jr_srcUrl+this.options.jr_phpSRC,data:{a:(!$defined(c)?"out":c.a)},evalScripts:true,onSuccess:function(d){this.reloadPage("'ALL'")}.bind(this)})}}catch(b){this.jrLog("F#>> logout failure: "+b)}},setLang:function(c,b){var a=10;if(!$defined(c)){var c=new Object()}if(!$defined(c.lang)){c.lang=this.options.jr_lang}c.a="setLang";c._div=this.options.jr_divMain;if(this.options.jr_lang!=""){this.processRequest({requestType:"html",url:this.options.jr_srcUrl+this.options.jr_phpSRC,successHandler:function(){window.jrCMS.reloadPage("ALL")}.bind(this),data:c})}},updateXtpTable:function(){if($defined(window.jrCmsRshSource)){if(this.accessRights(this.getUserLevel(),this.options.jr_webmasterLevel)){var a=new Object();a.a="updateXtpTable";a.procs=new Array();$A(jrCmsRshSource.histSrcPool).each(function(c,b){var d=JSON.decode(c);if($defined(d)&&$defined(d.functionType)&&d.functionType!=""){a.procs[b]=JSON.decode(c)}});a.procs=JSON.encode(a.procs);this.processRequest({url:this.options.jr_srcUrl+this.options.jr_phpSRC,data:a,onSuccess:function(b,c){if(b=="1"){this.jrLog("C:I>> jrCMS xTP table updated ")}}.bind(this)})}else{if(this.options.jr_histDebug){throw new Error("jrCMS.updateXtpTable jrCmsRshSource no available")}}}},chgWindowSize:function(e,c){try{var a=13;var b=this.addRequestHP(this.getClassId()+a,e,"chgWindowSize");e.a="getcnt";e.mt=this.options.jr_menuType;this.processRequest({url:this.options.jr_srcUrl+this.options.jr_phpSRC,data:e,_hp:b,requestType:"xol",onSuccess:function(f,g,k){var j=g;if($defined(k.cssdata)){this.writeCssData(k.cssdata);var h='<span class="nav" onClick="window.jrCMS.chgWindowSize({id:'+e.id+",root:"+e.root;h+=",cssid:"+((this._windowSizeDown)?(e.cssid+1):(e.cssid-1))+'});">';h+='<img src="src/images/spacer.gif" width="16px" height="12px" /></span>';$(this.options.jr_divWindowSize).empty().set("html",h);this._windowSizeDown=(this._windowSizeDown)?(false):(true)}}.bind(this)})}catch(d){this.jrLog("F#>> jrCMS.chgWindowSize failure: "+d)}},notImplemented:function(b){var a=16;alert("sorry not implemented")},showAbout:function(){try{var a=17;var d=new Object();var b=this.addRequestHP(this.getClassId()+a,d,"showAbout");d.a="getAbout";this.processRequest({url:this.options.jr_srcUrl+this.options.jr_phpSRC,data:d,_hp:b,onSuccess:function(e){var h='<span class="about" onClick="window.open(\'http://jrcmsdev.sourceforge.net\'); return false;">';h+='<img src="src/images/imacs_logo.png" /></span><br /><hr class="about" /><br />';h+=($defined(e)?e:($defined($$("title"))?($$("title")[0].text):("CM System")))+'</b><hr class="about" />';var g=MooTools.version;h+="Core:<br /><blockquote> imacs V"+this.getVersion()+"<br />on base of MooTools V"+MooTools.version+"<br />";h+="under MIT-style license<br />Copyright (c) 2010,2011 Jens Raabe";h+='<p><i>For Code, Documentation  &amp; Developer Team please have a look on: <span class="about" onClick="window.open(\'https://sourceforge.net/apps/trac/jrcmsdev\'); return false;">';h+='http:\\jrcmsdev.sourceforge.net</span></i></p></blockquote><hr class="about" />';h+="Active modules and developer info:<br /><p><table>";h+="<tr><td>&nbsp; &gt; JRCms: </td>";h+="<td>ID"+this.getClassId()+"&nbsp;&nbsp;</td>";h+="<td>V"+this.getVersion()+"&nbsp;&nbsp;</td>";h+="<td>"+this._coreInfo.developer+"</td></tr>";for(pN in this._pluginLoadStatus){var f=pN.substr(0,2).toLowerCase()+pN.substr(2);h+="<tr><td>&nbsp; &gt; "+pN+": </td>";h+="<td>ID"+window[f].getClassId()+"&nbsp;&nbsp;</td>";h+="<td>V"+window[f].getVersion()+"&nbsp;&nbsp;</td>";h+="<td>"+window[f]._pluginInfo.developer+"</td></tr>"}if($defined(window.Xinha)&&$defined(window.Xinha.version)){h+='<tr><td>&nbsp; &gt; Xinha: </td><td colspan="2">V'+window.Xinha.version.Release+"</td></tr>"}h.replace(/\$/g,"");this.writeContentHTML(h,{noEditor:true})}.bind(this)})}catch(c){this.jrLog("F#>> jrCMS.showAbout failure: "+c)}},showSrcVersions:function(){try{var a=14;this.showAbout()}catch(b){this.jrLog("F#>> showSrcVersions failure: "+b)}},getSpecialLabelHTML:function(d){try{var a=15;if($type(d)=="object"&&$defined(d.l)){d.a="getMnuId";var b=this.addRequestHP(this.getClassId()+a,d,"getSpecialLabelHTML");this.processRequest({url:this.options.jr_srcUrl+this.options.jr_phpSRC,data:d,_hp:b,requestType:"json"})}}catch(c){this.jrLog("F#>> getSpecialLabelHTML failure: "+c)}},_coreStatus:"loading",_windowSizeDown:true,postLoginProcessing:function(){},createLoginDialog:function(a){if($defined($$(".minheight_righttaskbox")[0].clientHeight)&&$$(".minheight_righttaskbox")[0].clientHeight>0){this.setOptions({jr_heightOfRMenu:$$(".minheight_righttaskbox")[0].clientHeight})}else{this.createLoginDialog.delay(500,this);return false}this.createDialog({dlgDragable:false,dlgSizable:false,dlgScroller:false,dlgKillable:false,dlgParent:$(this.options.jr_divLogin),dlgText:this.getLangItemSet(),dlgUrl:this.options.jr_srcUrl,dlgSrc:this.options.jr_phpSRC,dlgContent:"divLoginDialog",dlgType:"login",dlgFrameStyle:"top:0px;right:0px;",dlgCssClass:"loginDlg",dlgTitle:(this.getUserLevel()!="000"?this.getLangItem("logged_in"):this.getLangItem("logged_out")),dlgWrapperOpt:{events:{show:function(b){$$(".minheight_rightbox")[0].setStyle("height",this.options.jr_heightOfLogin);$$(".minheight_righttaskbox")[0].setStyle("height",this.options.jr_heightOfRMenu-this.options.jr_heightOfLogin+this.options.jr_heightOfLoginH)}.bind(this),hide:function(b){$$(".minheight_rightbox")[0].setStyle("height",this.options.jr_heightOfLoginH);$$(".minheight_righttaskbox")[0].setStyle("height",this.options.jr_heightOfRMenu)}.bind(this)}}});if(this.options.jr_loginDialogHidden){this.toggleHideDialog($("dlgWrapperlogin").retrieve("options"))}else{this.showDialog($("dlgWrapperlogin").retrieve("options"))}this.getLogin({a:"gin",ul:a,_div:"divLoginDialog"})},getLoginSection:function(c){try{if($defined($(this.options.jr_divLogin))&&!this.options.jr_loginHidden){$(this.options.jr_divLogin).empty();this.createLoginDialog(c)}else{if($defined($(this.options.jr_divLogin))){var b=new Object();b.a="gindiv";b.ul=c;b._div="divLogin";this.processRequest({requestType:"html",url:jrCMS.options.jr_srcUrl+jrCMS.options.jr_phpSRC,data:b})}}}catch(a){this.jrLog("F#>> getLoginSection failure: "+a)}},hideMainFrameLoading:function(){if($defined($(this.options.jr_divFrame))&&!$defined(this._showFrameLoadingSpinner)){this.hideFrame(this.options.jr_divFrame);var a=new Element("div",{id:"dflDiv",styles:{backgroundColor:"transparent",overflow:"auto",fontFamily:"microsoft, sans-serif, helvetica, ariel, serif"}});$(this.options.jr_divFrame).inject(a,"before");var b=new Element("div",{styles:{width:"auto",margin:"0px auto","text-align":"center"}});b.grab(new Element("img",{src:this.options.jr_projURL+"src/images/prlspinner_big.gif"}));this._showFrameLoadingSpinner=new Spinner("dflDiv",{message:this.getLangItem("spinner_msg"),img:b});this._showFrameLoadingSpinner.show(true)}else{}},showMainFrameLoaded:function(){if($defined($(this.options.jr_divFrame))&&$(this.options.jr_divFrame).getStyle("display")=="none"&&!this._contentLoadedOnce){this.jrLog("C:I>> showMainFrameLoaded waits for form loaded once! ");this._contentLoadedOnce=true;this.showMainFrameLoaded.delay(400,this);return false}this._showFrameLoadingSpinner.destroy();this._showFrameLoadingSpinner=null;if($defined($("dflDiv"))){this.deleteFrame("dflDiv")}(function(){this.showFrame(this.options.jr_divFrame);this.jrLog("C:I>> showMainFrameLoaded set to display:block! ")}).delay(400,this)},processDialogValue:function(a,c,b){switch(c){case"UserName":a.addEvent("focus",function(d){if(d.target.value==this.getLangItem("u_user")){d.target.value=""}}.bind(this));return a;break;case"UserPass":a.addEvent("focus",function(d){if(d.target.value==this.getLangItem("u_pw")){d.target.value=""}}.bind(this));a.addEvent("keydown",function(d){if(d.key=="enter"){this.login({a:"in"})}}.bind(this));return a.set("type","password");break;default:break}return a}})})();