/*
 * jrCmsEditor
 *
 * This module integrates the Xinha editor in jrCMS
 *
 * @package jrCMS
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @version $Id: jrcmseditor.js 588 2011-08-26 11:53:30Z ctna0371 $ 
 * 
 * @copyright Copyright (c) 2008,2009,2010 Jens Raabe
 * license: MIT-style license, see jrcms.js
 */
var JRCmsEditor=new Class({_pluginInfo:{name:"JRCmsEditor",version:"0.3.0",revision:"$Revision: 588 $",developer:"Jens Raabe",developer_url:"http://www.raabe-berlin.de",license:"MIT",classId:2400}});(function(){JRCmsEditor.implement({Implements:[Options,JRCmsApi],options:{jr_debug:false,jr_lang:"de",jr_xinhaSkin:"silva",jr_xinhaContentCss:"src/css/xinha.css",jr_xinhaShowLoading:false,jr_myXinhaArea:[],jr_myXinhaPlugins:["ExtendedFileManager"],jr_xinhaLoaded:false,jr_edAppHeight:110,jr_edAppWidth:340},editor:null,editor_elementId:null,editor_txtArea:null,editor_txtArea_changed:false,editor_initialHtml:null,editor_saveButton:[],editor_buttonResetString:"",getClassId:function(){return this._pluginInfo.classId},getVersion:function(){return(this._pluginInfo.version+"_"+this._pluginInfo.revision.slice(this._pluginInfo.revision.search(/:.+/)+1)).replace(/\$/g,"").replace(/ /g,"")},addEditorAreaEntered:false,initialize:function(b,a){this.setOptions(b);this.setOptions({jr_phpSRC:"jrcmseditor/jrcmseditor.php"});this.loadStyleFiles({cssfile:"JRCmsEditor.css",path:this.options.jr_pluginsUrl+"jrcmseditor/css/"});this.confEditor();window._editor_url=this.options.jr_assetsUrl+"xinha";window._editor_lang=this.options.jr_lang;window._editor_skin=this.options.jr_xinhaSkin;this.retrieveLangFile(this.options.jr_pluginsUrl+"jrcmseditor/lang/","lang."+this.options.jr_lang,function(){this.options.jr_eLangLoaded=true}.bind(this));if(!$defined(window.Xinha)){this.loadScriptFiles({jsfile:"XinhaCore.js",path:this.options.jr_assetsUrl+"xinha/",loadfunc:function(){this.jrLog("T:I>> jrCmsEditor:initialize domReady! ",2);this.options.jr_xinhaLoaded=true;this.loadScriptFiles({jsfile:"my_config.js",path:this.options.jr_assetsUrl+"xinha/",loadfunc:function(){this.jrLog("T:I>> jrCmsEditor:startPlugin loading! ",2);Xinha.loadPlugins(this.options.jr_myXinhaPlugins)}.bind(this)})}.bind(this)})}},refresh:function(a){},create:function(e){var b=1;try{var a=true;if($A(this.options.jr_myXinhaPlugins).length>0){$A(this.options.jr_myXinhaPlugins).each(function(h,g){if(!$type(window.Xinha)||(Xinha._pluginLoadStatus[h]!="ready"&&Xinha._pluginLoadStatus[h]!="failed")){a&=false}})}if(!this.options.jr_xinhaLoaded||!a){this.create.delay(50,this,$merge(e));this.jrLog("T:I>> jrCmsEditor:create wait for domReady! ",2);return false}this.jrLog("T:I>> jrCmsEditor:create domReady! ",2);if(!$type(window.Xinha)){throw new Error("No Xinha editor instantiated!")}var c=this;this.editor=null;if(e.width=="element"){e.width=$(e.txtArea).getStyle("width");e.height=$(e.txtArea).getStyle("height")}var d=new Xinha.Config();d.pageStyleSheets=[this.options.jr_xinhaContentCss];d.toolbar=$defined(e.toolbar)?e.toolbar:d.toolbar;d.statusBar=$defined(e.statusBar)?e.statusBar:d.statusBar;d.killWordOnPaste=$defined(e.killWordOnPaste)?e.killWordOnPaste:true;d.makeLinkShowsTarget=$defined(e.makeLinkShowsTarget)?e.makeLinkShowsTarget:true;d.stripScripts=$defined(e.stripScripts)?e.stripScripts:false;d.showLoading=$defined(e.showLoading)?e.showLoading:this.options.jr_xinhaShowLoading;d.htmlRemoveTags=$defined(e.htmlRemoveTags)?e.htmlRemoveTags:/imagedata/;d.specialReplacements=$defined(e.specialReplacements)?e.specialReplacements:d.specialReplacements;d.width=(!$defined(e.width))?(d.width):(((e.width!="auto")?(e.width):(((Browser.Engine.trident&&this.options.jr_ie_version<7)?((parseInt($(this.options.jr_divMain).getStyle("width").replace("px",""))-6)+"px"):((parseInt($(this.options.jr_divMain).getStyle("width").replace("px",""))-6)+"px")))));d.height=(!$defined(e.height))?(d.height):(((e.height!="auto")?(e.height):(((Browser.Engine.trident&&this.options.jr_ie_version<7)?((parseInt($(this.options.jr_divMain).getStyle("height").replace("px",""))-6)+"px"):((parseInt($(this.options.jr_divMain).getStyle("height").replace("px",""))-6)+"px")))));if($defined(this.editor_buttonResetString)&&this.editor_buttonResetString!=""){d.hideSomeButtons(this.editor_buttonResetString)}if($defined(e.genSaveButton)&&e.genSaveButton){d=this.addButtonToConfig(d,{addButtons:$A(this.editor_saveButton).combine($A(e.addButtons))});d.Events.onKeyPress=this.onKeyPress.bind(this);d.Events.onExecCommand=this.onExecCommand.bind(this);d.Events.onUpdateToolbar=this.onUpdateToolbar.bind(this)}else{d=this.addButtonToConfig(d,e)}Xinha.startEditors(Xinha.makeEditors((new Array(e.txtArea)),d,($defined(e.xinaPlugins)?e.xinaPlugins:this.options.jr_myXinhaPlugins)));this.editor_elementId=e.txtArea;this.editor=Xinha.getEditor(this.editor_elementId);this.editor.whenDocReady(this.addOwnParameter.bind(this,e))}catch(f){this.jrLog("F#>> jrCmsEditor.create failure: "+f)}},getXinhaTextArea:function(){var a=2;var b=Xinha._currentlyActiveEditor;if($type(window.Xinha)&&$defined(b)&&b._textArea.name!=""){this.jrLog("T:3#>> jrCmsEditor.getXinhaTextArea _textArea: "+b._textArea.name,3);return this.chars2entities(__xinhas[b.__htmlarea_id_num].getEditorContent())}else{this.jrLog("T:4#>> jrCmsEditor.getXinhaTextArea _textArea not active",4)}},syncEditorByFunction:function(a,b){if($defined(window.Xinha)&&$defined(__xinhas)&&__xinhas.length>=1&&a!=null){$A(__xinhas).each(function(d,c){if($defined($(d._textArea.name))&&d._textArea.name==a){$(d._textArea.name).set($defined(navigator.product)&&navigator.product=="Gecko"?"html":"value",this.chars2entities(d.getEditorContent()));if(b!=null&&$type(b)=="function"){b.apply(this,[d._textArea.name,$(d._textArea.name).get("html")])}return}}.bind(this))}},syncXinhaTextAreas:function(){var a=9;if($defined(window.Xinha)&&$defined(__xinhas)&&__xinhas.length>=1){$A(__xinhas).each(function(c,b){if($defined($(c._textArea.name))){$(c._textArea.name).set("value",this.chars2entities(c.getEditorContent()))}}.bind(this))}},save:function(c){var a=3;try{if(!$defined(c)){var c=new Object();c.root=$defined($("root"))?$("root").value:null;c.id=$defined($("id"))?$("id").value:null;c.div=$defined($("div"))?$("div").value:null;c.cid=$defined($("cid"))?$("cid").value:null;c.a=$defined($("a"))?$("a").value:null}c.cont=this.getXinhaTextArea();if(!$defined(c.id)){return false}c.a="sacnt";this.processRequest({requestType:"html",url:this.options.jr_pluginsUrl+this.options.jr_phpSRC,evalScripts:false,data:c,onSuccess:function(f,d,g,e){if($defined(e)){$exec(e);if($defined(check)&&check=="saved"){this.changedReset()}}}.bind(this)})}catch(b){this.jrLog("F#>> jrCmsEditor.save failure: "+b)}},activateEditor:function(c){var b=4;var a=this.options.jr_myXinhaArea;for(myXarea in this.options.jr_myXinhaArea){if((c.indexOf(myXarea)>-1)&&($type(this.options.jr_myXinhaArea[myXarea])=="object")){var d=this.options.jr_myXinhaArea[myXarea];d.txtArea=myXarea;this.create(d)}}},activateEditorForElement:function(b){var a=8;var c=b.get("name");var d=this.options.jr_myXinhaArea[c];d.txtArea=c;this.create.delay(50,this,d)},loadPreview:function(c){var a=5;try{if(!$defined(c)){var c=new Object();c.root=$("root").value;c.id=$("id").value;c.div=$("div").value;c.a=$("a").value}if(confirm(this.getLangItem("load_preview"))==false){return false}this.hideFrame(this.options.jr_divButtons);c.a="gacnt";this.processRequest({requestType:"xol",url:this.options.jr_srcUrl+jrCMS.options.jr_phpSRC,data:c,evalScripts:true})}catch(b){this.jrLog("F#>> jrCmsEditor.loadPreview failure: "+b)}},addEditorArea:function(c){var a=6;try{this.addEditorAreaEntered=true;if($defined(c)&&($type(c)=="object")){for(myXarea in c){this.options.jr_myXinhaArea[myXarea]=c[myXarea]}this.jrLog("T:3#>> jrCmsEditor.addEditorArea "+myXarea+" finished!",3)}else{throw new Error("wrong parameter")}this.addEditorAreaEntered=false}catch(b){this.addEditorAreaEntered=false;this.jrLog("F#>> jrCmsEditor.addEditorArea failure: "+b)}},addButtonToConfig:function(b,c){var a=7;if($defined(c)){if($defined(c.addButtons)){c.addButtons.each(function(e,d){b.registerIcon(e.icon.id,e.icon.path);b.registerButton({id:e.id,tooltip:e.tooltip,image:e.icon.path,textMode:e.textMode,action:e.action});b.addToolbarElement(e.id,e.anchore,-1);if(!$defined(this.editor_buttonResetString)||!this.editor_buttonResetString.contains(e.id)){this.editor_buttonResetString+=($defined(e.id)&&e.id!=null)?(" "+e.id):("")}}.bind(this))}}if($defined(b.iconList.savesubmitunchanged)){b.registerIcon("savesubmitchanged",this.options.jr_pluginsUrl+"jrcmseditor/images/ed_save_red.gif")}return b},unlockEditorContent:function(){var a=10;var b=new Object();b.a="unlockEditorContent";if($defined($("id"))){b.id=$("id").value}else{return false}this.processRequest({url:this.options.jr_pluginsUrl+this.options.jr_phpSRC,evalScripts:false,data:b,onSuccess:function(e,c,f,d){if($defined(d)){$exec(d)}alert("unlocked")}.bind(this)})},confEditor:function(){if(this.addEditorAreaEntered){this.confEditor.delay(50,this);this.jrLog("T:3#>> jrCmsEditor:confEditor wait for addEditiorArea! ",3);return false}this.jrLog("T:3#>> jrCmsReports:confEditor ready! ",3);this.addEditorArea({myXinhaTextarea:{width:"auto",height:"auto",statusBar:false,toolbar:[["popupeditor"],["separator","formatblock","bold","italic","underline","strikethrough"],["separator","forecolor","hilitecolor","textindicator"],["separator","subscript","superscript"],["linebreak","separator","justifyleft","justifycenter","justifyright","justifyfull"],["separator","insertorderedlist","insertunorderedlist","outdent","indent"],["separator","inserthorizontalrule","createlink","insertimage","inserttable"],["linebreak","separator","undo","redo","selectall","print"],["separator","killword","clearfonts","removeformat","toggleborders","splitblock","lefttoright","righttoleft"],["separator","htmlmode","showhelp","about"]],genSaveButton:true,addButtons:[{id:"myPreview",tooltip:this.getLangItem("preview_load"),icon:{id:"preview",path:this.options.jr_pluginsUrl+"jrcmseditor/images/preview.gif"},anchore:"popupeditor",textMode:true,action:function(a){this.loadPreview()}.bind(this)},{id:"myLink",tooltip:this.getLangItem("insert_link"),icon:{id:"mylink",path:this.options.jr_pluginsUrl+"jrcmseditor/images/ed_link.gif"},anchore:"createlink",textMode:true,action:function(a){this.dialogInternalLink()}.bind(this)}]}});this.editor_saveButton=[{id:"mySave",tooltip:this.getLangItem("save_data"),icon:{id:"savesubmitunchanged",path:this.options.jr_pluginsUrl+"jrcmseditor/images/ed_save_green.gif"},anchore:"popupeditor",textMode:true,action:function(a){this.save()}.bind(this)}]},processDialogValue:function(a,c,b){switch(c){case"link_label":return this.getInternalLinkList(this.options.jr_pluginsUrl+this.options.jr_phpSRC,a);break;default:if(c!="link_hint"&&c!="link_color"){if(c.search(/link_/)!=-1){a.addEvent("click",function(d){this.getInternalLinkList(d.target.value)}.bind(this))}a.set({type:"radio",checked:(c=="link_menu"?true:false),value:b,name:"link_proc","class":"link_proc",title:c});return a;break}}return a},internalLinkSelect:function(a){if(!$defined(a)){var a=new Object();a.header=this.dialogHeader("unused",0,"dummy");a.data=new Array()}a.data.push(this.dialogElement("link_menu",this.options.jr_pluginsUrl+this.options.jr_phpSRC,"linkDialog","input:jrCmsEditor"));a.data.push(this.dialogElement("link_label",this.getLangItem("option_select"),"linkDialog","select:jrCmsEditor","required"));a.data.push(this.dialogElement("link_hint",this.getLangItem("link_text"),"linkDialog","input","required"));a.data.push(this.dialogElement("link_color","#ff0000","linkDialog","input","required"));return a},internalAppSelect:function(a){a.data.push(this.dialogElement("app_hr",this.getLangItem("app_hr"),"linkDialog","text"));a.data.push(this.dialogElement("app_hint",this.getLangItem("app_hint"),"linkDialog","text"));return a},dialogInternalLink:function(){try{MooTools.lang.setLanguage(this.options.jr_lang+"-"+this.options.jr_lang.toUpperCase());var a=this.internalLinkSelect();a=this.internalAppSelect(a);this.createDialog({dlgContent:"linkdialogdiv",dlgText:this.getLangItemSet(),dlgTitle:this.getLangItem("link_reference"),dlgUrl:this.options.jr_pluginsUrl,dlgSrc:this.options.jr_phpSRC,dlgUseFieldset:false,dlgFrameStyle:"top:50px;left:100px;",dlgButtons:{dlgSave:function(c){this.insertInternalLink(c)}.bind(this)}},a)}catch(b){this.jrLog("F#>> jrCmsEditor.dialogInternalLink failure: "+b)}},insertInternalLink:function(f){var h=$$(".dlgwrapper")[0];var c=h.getElements("input");var b=new Object();var a=$$("input[name=link_proc");a.each(function(l,k){if(l.checked){b.link_typ=l.id.substring(0,l.id.indexOf("_"));if(b.link_typ.search(/app/)!=-1){b.app_proc=l.value;b.app_id=l.id}return}});c.each(function(l,k){switch(l.id){case"link_hint":b[l.id]=(l.value!="")?this.chars2entities(l.value):"none";break;case"link_color":b[l.id]=(l.value!="")?l.value:"none";break;default:if(l.value!=""){b[l.id]=this.chars2entities(l.value)}}},this);c=h.getElements("select");c.each(function(l,k){b[l.id]=(l.selectedIndex>0)?(l.options[l.selectedIndex].value):null});var d;if($defined(b.link_label)){d=b.link_label.substr(b.link_label.search(/\'id\'\:\'/)+6);d=d.substring(0,d.search(/\',/))}else{d="999"}if(b.link_typ=="link"){if(!$defined(b.link_label)){alert(this.getLangItem("input_missing"));h.getElementById("link_label").focus();return false}var j=new Element("span",{id:"elem_"+d,"class":"internallink",onclick:b.link_label,html:b.link_hint,styles:{color:b.link_color}})}else{var j=new Element("div",{id:b.app_id+"_frame","class":"appwrapper",styles:{width:this.options.jr_edAppWidth+1+"px",height:this.options.jr_edAppHeight+4+"px"}});var i=new Element("div",{id:b.app_id,"class":"appbox"}).adopt(new Element("script",{type:"text/javascript",html:b.app_proc+"();"}),new Element("img",{id:b.app_id+"_placeholder",src:"src/plugins/jrcmseditor/images/app_placeholder.png",alt:"App Placeholder",styles:{width:this.options.jr_edAppWidth+"px",height:this.options.jr_edAppHeight+"px"}}));var e=new Element("div",{"class":"shadow-appbox"}).grab(new Element("div",{"class":"shadow-appbox-e"}).adopt(new Element("div",{"class":"shadow-appbox-ne"}),new Element("div",{"class":"shadow-appbox-s"}).grab(i)));if(!$defined(b.link_label)){j.grab(e)}else{j.adopt(e,new Element("div",{id:"app_"+d,"class":"internallinkApp",onclick:b.link_label,html:b.link_hint}))}}var g=__xinhas[Xinha._currentlyActiveEditor.__htmlarea_id_num];h.dispose();g.insertNodeAtSelection(j)},getInternalLinkList:function(a,c){var b=new Array();this.processRequest({requestType:"xol",url:a,data:{a:"getInternalLink"},async:false,onSuccess:function(f,d,e){b=e}.bind(this),onFailure:function(d){this.jrLog("F#>> jrCmsEditor.getInternalLinkList no content "+d)}.bind(this)});if(!$defined(c)){var c=$("link_label")}if($defined(b)&&$defined(b.jr_linkList)&&$chk(c)){c.empty();c.grab(new Element("option",{value:0,text:this.getLangItem("option_select"),selected:true}));$A(b.jr_linkList).each(function(f,d){var e=new Element("option",{value:(b.jr_linkProc+"("+JSON.encode(f)+")").replace(/\"/g,"'"),text:f.label});c.grab(e)})}return c},addOwnParameter:function(a){this.editor_txtArea=this.editor._textArea;this.editor_txtArea_changed=false;this.editor_initialHtml=this.editor.getInnerHTML();if($defined(a)&&$type(a.whenXinhaDocReady)=="function"){a.whenXinhaDocReady.run(a,this)}if(this.editor._doc!=null){Xinha._addEvents(this.editor._doc,["keypress"],this.onKeyPress.bind(this))}},onKeyPress:function(a){if(a.ctrlKey&&this.editor.getKey(a)=="s"){this.save().bind(this);Xinha._stopEvent(a);return true}else{if(!this.editor_txtArea_changed){if(this.getChanged(a)){this.setChanged()}return false}}},onExecCommand:function(a){if(this.editor_txtArea_changed&&a=="undo"){if(this.editor_initialHtml==this.editor.getInnerHTML()){this.setUnChanged()}return false}},onUpdateToolbar:function(){if(!$defined(this.editor_initialHtml)){this.editor_initialHtml=this.editor.getInnerHTML()}if(!this.editor_txtArea_changed){if(this.getChanged()){this.setChanged()}return false}},getChanged:function(a){if(!$defined(this.editor_initialHtml)){this.editor_initialHtml=this.editor.getInnerHTML()}if(this.editor_initialHtml!=(($defined(a)&&!a.ctrlKey)?(this.editor.getInnerHTML()+this.editor.getKey(a)):(this.editor.getInnerHTML()))&&this.editor_txtArea_changed==false){this.editor_txtArea_changed=true;return true}else{return false}},setChanged:function(){if($defined(this.editor)&&$defined(this.editor._toolbarObjects.mySave)){this.editor._toolbarObjects.mySave.swapImage(this.editor.config.iconList.savesubmitchanged);this.editor.updateToolbar()}},setUnChanged:function(){this.editor_txtArea_changed=false;if($defined(this.editor)&&$defined(this.editor._toolbarObjects.mySave)){this.editor._toolbarObjects.mySave.swapImage(this.editor.config.iconList.savesubmitunchanged)}},changedReset:function(){this.editor_initialHtml=null;this.setUnChanged()}})})();