/*
 * History Class that provides history, history data, and bookmarking for DHTML and Ajax applications.
 * A generic function is available on base of the 'real simple history' (Brian Dillard, Brad Neuberg)
 * adapted and streamlined/rewritten for the mootools frame work.
 * The revised class DhtmlHistory is named JRCmsRsh in accordance with the naming convention of
 * the JRCms Frame and comes with an additional definition of a source pool which is used by the history
 * for decoding/encoding of history entries.
 *
 * Conventions:
 * 1) we need the provided "blank.html* file for IE
 * 2) the JRCmsRshSource has to be instantiated as jrCmsRshSource first
 * 3) the JRCmsRsh shall be instantiated as jrCmsRsh while the DOM is finally loaded
 *
 * @package rsh: real simple ajax history
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @version $Id: jrcmsrsh.js 438 2011-02-10 07:08:44Z jensraabe $ 
 * 
 * @copyright Copyright (c) 2008,2009, Jens Raabe
 * license: MIT-style license, see jrcms.js
 */
var JRCmsRsh=new Class({_pluginInfo:{name:"JRCmsRsh",version:"0.2.2",revision:"$Revision: 438 $",developer:"Jens Raabe",developer_url:"http://www.raabe-berlin.de",license:"MIT",classId:1100}});HistoryStorage=new Class({_pluginInfo:{name:"HistoryStorage",version:"0.2.2",revision:"$Revision: 438 $",developer:"",developer_url:"",license:"MIT",classId:0}});JRCmsRshSource=new Class({_pluginInfo:{name:"JRCmsRshSource",version:"0.2.1",revision:"$Revision: 438 $",developer:"",developer_url:"",license:"MIT",classId:0}});(function(){JRCmsRsh.implement({Implements:[Options,JRCmsApi],options:{jr_histDebug:false,jr_histSupported:true,jr_base64:false,jr_lowspeed:false,jr_lowspeedTimer:400,jr_highspeedTimer:100,jr_histBackId:0},getClassId:function(){return this._pluginInfo.classId},getVersion:function(){return(this._pluginInfo.version+"_"+this._pluginInfo.revision.slice(this._pluginInfo.revision.search(/:.+/)+1)).replace(/\$/g,"").replace(/ /g,"")},initialize:function(b){try{if($type(jrCmsRshSource)!="object"){throw"History Source Pool 'JRCmsRshSource' not instantiated!"}this.setOptions(b);this.refactorRequest();window.historyStorage=new HistoryStorage(b);this.currentLocation="";if(Browser.Engine.trident){this.createIE(this.getCurrentHash())}this.addEventListener(window,"unload",function(){this.firstLoad=null}.bind(this));if(!historyStorage.hasKey(this.PAGELOADEDSTRING)){this.ignoreLocationChange=true;this.firstLoad=true;historyStorage.put(this.PAGELOADEDSTRING,true)}else{this.ignoreLocationChange=false;this.fireOnNewListener=true}var a=(this.options.jr_lowspeed||this.options.jr_ie_bug)?(this.options.jr_lowspeedTimer):(this.options.jr_highspeedTimer);this.intervalID=function(){this.checkLocation()}.periodical(a,this);this.addListener(this.change)}catch(c){var d="No Ajax History is available by using the back button.\n"+c;if(this.options.jr_histDebug){throw new Error(d)}else{this.jrLog("F#>>"+d)}}},refactorRequest:function(){window.Request=Class.refactor(Request,{initialize:function(a){if($defined(a._hp)){a.link="cancel";["onLoaded","onException","onCancel"].each(function(b){this.addEvent(b,window.jrCmsRsh.resetAtomicRequest.bind(window.jrCmsRsh))},this)}this.previous(a)},send:function(b){if($defined(this.options._hp)){window.jrCmsRsh.addHP(this.options._hp._hpUniqueId,this.options._hp._hpParam,this.options._hp._hpDesc,function(){if($defined(window.jrCmsLog)){jrCmsLog.put("HP:>> "+this.options._hp._hpDesc+": "+JSON.encode(this.options._hp._hpParam))}}.bind(this));if(window.jrCmsRsh.activeAtomicRequest()){return false}var a=window.jrCmsRsh.setAtomicRequest.bind(window.jrCmsRsh);a();this.setOptions({_hp:undefined})}this.previous(b)}})},addRequestHP:function(c,b,a){return $merge({_hpUniqueId:c,_hpParam:b,_hpDesc:a})},addListener:function(a){this.listener=a;if(this.fireOnNewListener){this.fireHistoryEvent(this.currentLocation);this.fireOnNewListener=false}},addEventListener:function(c,b,a){if(c.addEventListener){c.addEventListener(b,a,false)}else{if(c.attachEvent){c.attachEvent("on"+b,function(){a(window.event)})}}},add:function(c,f){this.intervalID=$clear(this.intervalID);if(this.currentWaitTime<0){this.currentWaitTime=0}this.ieAtomicLocationChange=true;this.ignoreLocationChange=true;c=this.removeHash(c);if(document.getElementById(c)&&this.options.jr_histDebug){var d="Exception: History locations can not have the same value as _any_ IDs that might be in the document, due to a bug in IE; please ask the developer to choose a history location that does not match any HTML IDs in this document. The following ID is already taken and cannot be a location: "+c;throw new Error(d)}historyStorage.put(c,f);this.currentLocation=c;window.location.hash="#"+c;if(Browser.Engine.trident){this.iframe.src="blank.html?"+c}var b=function(){this.currentWaitTime=this.currentWaitTime-this.waitTime;if(this.currentWaitTime==0){this.ieAtomicLocationChange=false}var e=(this.options.jr_lowspeed||this.options.jr_ie_bug)?(this.options.jr_lowspeedTimer):(this.options.jr_highspeedTimer);if($type(window.jrCmsInit)){e=(jrCmsInit.options.jr_lowspeed||this.options.jr_ie_bug)?(this.options.jr_lowspeedTimer):(this.options.jr_highspeedTimer)}this.intervalID=function(){this.checkLocation()}.periodical(e,this)}.bind(this);this.currentWaitTime=this.currentWaitTime+this.waitTime;var a=b.delay(this.currentWaitTime,this)},addHP:function(g,f,d,b){try{if(!this.options.jr_histSupported){return}if($type(b)=="function"){b.run()}if(!$defined(f)){var f=new Object()}else{if($type(f)!="object"){throw"Parameter 'param' must be an object string like {param1:value,param2:value}!!"}}if(!$defined(d)){var d="jrCmsRsh Event"}else{if($type(d)!="string"){throw"Parameter 'desc' must be a string !!"}}this.add(this.codeHistStr(g,f),d)}catch(a){var c="addHP failure\n "+a;if(jrCmsRsh.options.jr_histDebug){throw new Error(c)}else{this.jrLog("F#>>"+c)}}},execHP:function(c){try{if(this.atomicRequestRunning){return false}var f=JSON.decode(c.parameter);if(this.options.jr_histBackId>0&&$defined(f.root)&&$defined(f.id)&&$defined(f.cssid)){c.uniqueId=this.options.jr_histBackId}this.jrLog("HP:>> execute with:"+c.uniqueId+", "+c.parameter);var d=jrCmsRshSource.get(c.uniqueId);if(!$defined(d)&&!this.execHPDelayedOnce){this.execHPDelayedOnce=true;this.execHP.delay(50,this,$merge(c));return false}else{if(!$defined(d)){this.jrLog("HP:>> NOT executed:"+c.uniqueId+", "+c.parameter);return false}}window[d.instance][d.functionName].run(JSON.decode(c.parameter),window[d.instance])}catch(a){var b="jrCmsRsh.execHP failure\n"+a;if(jrCmsRsh.options.jr_histDebug){throw new Error(b)}else{this.jrLog("F#>>"+b)}}},change:function(d,i){try{if(d!=undefined&&d!=""){var g=($type(i)=="object"&&i!==null?JSON.encode(i):i);var a=d;var c=a.substring(0,a.search(/\?/));var h=($type(jrCmsRsh)=="object"&&jrCmsRsh.options.jr_base64)?(((a.search(/\?/)+1!=a.search(/\{/))?(Base64.decode(a.substring((a.search(/\?/)+1)))):(unescape(a.substring((a.search(/\?/)+1)))))):(((a.search(/\?/)+1!=a.search(/\{/))?(Base64.decode(a.substring((a.search(/\?/)+1)))):(unescape(a.substring((a.search(/\?/)+1))))));jrCmsRsh.execHP({uniqueId:c,parameter:h})}else{window.location.hash="";this.firstLoad=null}}catch(b){var f="jrCmsRsh.change failure\n"+b;if(jrCmsRsh.options.jr_histDebug){throw new Error(f)}else{this.jrLog("F#>>"+f)}}},getCurrentLocation:function(){if(Browser.Engine.trident&&this.firstLoad!==null){return this.getIframeHash()}else{return this.getCurrentHash()}},getCurrentHash:function(){var b=window.location.href;var a=b.indexOf("#");return unescape((a>=0?b.substr(a+1):""))},PAGELOADEDSTRING:"DhtmlHistory_pageLoaded",listener:null,intervalID:null,waitTime:200,currentWaitTime:0,currentLocation:null,iframe:null,execHPDelayedOnce:false,ignoreLocationChange:null,fireOnNewListener:null,firstLoad:null,ieAtomicLocationChange:null,atomicRequestRunning:false,createIE:function(b){this.waitTime=400;var a="blank.html?"+b;var c=new Element("iframe",{id:"rshHistoryFrame",src:a,styles:{border:(this.options.jr_histDebug)?("1px solid black"):("0"),width:(this.options.jr_histDebug)?("800px"):("1px"),height:(this.options.jr_histDebug)?("80px"):("1px")}});$$("body").grab(c);this.iframe=$("rshHistoryFrame")},fireHistoryEvent:function(a){var b=historyStorage.get(a);this.listener.call(null,a,b)},checkLocation:function(){if(!Browser.Engine.trident&&this.ignoreLocationChange){this.ignoreLocationChange=false;return}if(Browser.Engine.trident&&this.ieAtomicLocationChange){return}var a=this.getCurrentLocation();if(a==this.currentLocation){return}this.ieAtomicLocationChange=true;if(Browser.Engine.trident){this.iframe.src="blank.html?"+a}this.currentLocation=a;this.ieAtomicLocationChange=false;this.fireHistoryEvent(a)},getIframeHash:function(){var b=this.iframe.contentWindow.document;var a=String(b.location.search);if(a.length==1&&a.charAt(0)=="?"){a=""}else{if(a.length>=2&&a.charAt(0)=="?"){a=a.substring(1)}}return unescape(a)},removeHash:function(b){var a;if(b===null||b===undefined){a=null}else{if(b===""){a=""}else{if(b.length==1&&b.charAt(0)=="#"){a=""}else{if(b.length>1&&b.charAt(0)=="#"){a=b.substring(1)}else{a=b}}}}return a},iframeLoaded:function(a){if(this.ignoreLocationChange){this.ignoreLocationChange=false;return}var b=String(a.search);if(b.length==1&&b.charAt(0)=="?"){b=""}else{if(b.length>=2&&b.charAt(0)=="?"){b=b.substring(1)}}window.location.hash=b;this.fireHistoryEvent(b)},codeHistStr:function(c,b){var a=c+"?"+((this.options.jr_base64)?(Base64.encode(JSON.encode(b))):(JSON.encode(b)));return a},setAtomicRequest:function(){this.atomicRequestRunning=true;this.jrLog(">>>>>>>> AJAX Begin <<<<<<<<<<<<<<")},resetAtomicRequest:function(){this.atomicRequestRunning=false;this.jrLog(">>>>>>>> AJAX End <<<<<<<<<<<<<<")},activeAtomicRequest:function(){return this.atomicRequestRunning}})})();(function(){HistoryStorage.implement({Implements:[Options],options:{jr_histDebug:false},getClassId:function(){return this._pluginInfo.classId},getVersion:function(){return this._pluginInfo.revision},initialize:function(a){this.setOptions(a);var b=new Element("div",{id:"rshStorageForm",styles:{border:"0",left:(this.options.jr_histDebug)?("0"):("-1000px"),top:(this.options.jr_histDebug)?("0"):("-1000px"),width:(this.options.jr_histDebug)?("100%"):("1px"),height:(this.options.jr_histDebug)?("100%"):("1px"),position:(this.options.jr_histDebug)?("relative"):("absolute")}});$$("body").grab(b);var c=new Element("textarea",{id:"rshStorageField",styles:{border:(this.options.jr_histDebug)?("1px solid black"):("0"),left:(this.options.jr_histDebug)?("0"):("-1000px"),top:(this.options.jr_histDebug)?("0"):("-1000px"),width:(this.options.jr_histDebug)?("800px"):("1px"),height:(this.options.jr_histDebug)?("80px"):("1px"),position:(this.options.jr_histDebug)?("relative"):("absolute")}});$("rshStorageForm").grab(c);this.storageField=$("rshStorageField");if(Browser.Engine.presto){this.storageField.focus()}},put:function(a,b){this.assertValidKey(a);if(this.hasKey(a)){this.remove(a)}this.storageHash[a]=b;this.saveHashTable()},get:function(a){this.assertValidKey(a);this.loadHashTable();var b=this.storageHash[a];if(!$defined(b)){b=null}return b},remove:function(a){this.assertValidKey(a);this.loadHashTable();delete this.storageHash[a];this.saveHashTable()},reset:function(){this.storageField.value="";this.storageHash={}},hasKey:function(a){this.assertValidKey(a);this.loadHashTable();return($type(this.storageHash[a]))},storageHash:{},hashLoaded:false,storageField:null,assertValidKey:function(a){var b=($type(a)=="string");if(!b&&this.options.jr_histDebug){throw new Error("Please provide a valid key for window.historyStorage. Invalid key = "+a+".")}},loadHashTable:function(){if(!this.hashLoaded){var a=this.storageField.value;if(a!==""&&a!==null){this.storageHash=JSON.decode(a);this.hashLoaded=true}}},saveHashTable:function(){this.loadHashTable();var a=JSON.encode(this.storageHash);this.storageField.set("value",a)}})})();
/*
 * Class which defines all methods to maintain a storage
 * of functions usable by the history
 *
 * @author Jens Raabe <jens@raabe-berlin.de>
 */
(function(){JRCmsRshSource.implement({Implements:[Options],histSrcPool:new Array(),addSourcePoolEntered:false,options:{jr_lang:"de",jr_debug:false,jr_ptypes:["ajax","alink","apage","aeditor","js"],jr_srcpath:"src/",jr_phpSRC:"src/jrcms.php"},getClassId:function(){return this._pluginInfo.classId},getVersion:function(){return this._pluginInfo.revision},initialize:function(b,a){this.setOptions(b);this.histSrcPool=[]},add:function(c){try{this.addSourcePoolEntered=true;c.functions.each(function(f,d){var e={uniqueId:(c.classId+f.methodId).toString(),instance:c.instance,functionName:f.functionName,functionType:f.functionType};this.histSrcPool[((c.classId+f.methodId).toString())]=JSON.encode(e)}.bind(this));this.histSrcPool.clean();this.addSourcePoolEntered=false}catch(a){this.addSourcePoolEntered=false;var b="jrCmsRshSource.add failure\n"+a;if(this.options.jr_histDebug){throw new Error(b)}}},get:function(d){try{var a=d.toString();for(unId in this.histSrcPool){if((a==unId.toString())&&$defined(this.histSrcPool[unId])){return JSON.decode(this.histSrcPool[unId])}}return undefined}catch(b){var c="jrCmsRshSource.get failure\n"+b;if(this.options.jr_histDebug){throw new Error(c)}}}})})();window.jrCmsRshSource=new JRCmsRshSource();