<?php
/**#@+
 * This class provides the imacs server configuration (php)
 *
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @version $Id: cConfig.php 607 2011-09-20 05:58:51Z jensraabe $ 
 * 
 * @copyright Copyright (c) 2011 Jens Raabe (MIT)
 * license: MIT-style license, see jrcms.js
 */
 
/**
 * @class CONFIG
 * @package Server
 * @subpackage Config
 */ 
class CONFIG {
	
	CONST VERSION		= '$Revision: 607 $';
	CONST AUTHOR		= 'Jens Raabe';
	CONST PACKAGE		= 'Basic';
	CONST LAST_CH		= '$Date: 2011-09-20 07:58:51 +0200 (Di, 20 Sep 2011) $';
	
	CONST project		= 'jrCMS';
	CONST projectVersion= '0.3.0';
	CONST webmaster		= 'jens@raabe-berlin.de';
	CONST webmasterLevel= '999';
	CONST editorLevel	= '220';
	CONST title			= 'imacs';
	CONST uploadDIR		= '/content/uploads';
	CONST lang			= 'en';
	/**
	 * @ignore in php documentation
	 */
	CONST dbUpgrade		= true;
	/**
	 * @ignore in php documentation
	 */
	CONST codeSP		= 'false'; 	// site parameter code/decode - default 'false' = no coding
	/**
	 * @ignore in php documentation
	 */
	CONST mssqlpath		= 'C:/MeineProgramme/xampp/mssql/bin/';	// /usr/bin used for DB dump
	CONST protocol		= 'http';	//http or https without slash and colon
	/**
	 * @ignore in php documentation
	 */
	CONST docPath		= '/imacs'; //only for local development at XAMPP used, default empty
	/**
	 * @ignore in php documentation
	 */
	CONST srcPath		= '/imacs';

	/*
	 * .htaccess Rewrite Engine
	 */
	/** 
	 * @ignore in php documentation
	 */
	CONST rEngine		= 'on'; // 'on' .htaccess will be generated
	/**
	 * @ignore in php documentation
	 */
	CONST rRDelim		= '_'; // RewriteRule delimiter
	/**
	 * @ignore in php documentation
	 */
	CONST rRPfx			= '';  // RewriteRule prefix, e.g. '^/'
	/**
	 * @ignore in php documentation
	 */
	CONST rRTarget		= 'index.php';  // external target, default ''
	/**
	 * @ignore in php documentation
	 */
	CONST rRCtrl		= 'R'; // Rewrite options, default 'R'
	
	/*
	 * Database Data
	 * Remark: The database must be created first (by hand ;-))
	 */
	CONST dbms				= 'mysql';
	/**
	 * @ignore in php documentation
	 */
	CONST ms_dbhost			= ''; // MS SQL Server
	/**
	 * @ignore in php documentation
	 */
	CONST ms_database		= ''; // MS SQL Server
	/**
	 * @ignore in php documentation
	 */
	CONST ms_dbuser			= ''; // MS SQL Server
	/**
	 * @ignore in php documentation
	 */
	CONST ms_dbpwd			= ''; // MS SQL Server
	/**
	 * @ignore in php documentation
	 */
	CONST my_dbhost			= 'localhost'; // MySQL
	/**
	 * @ignore in php documentation
	 */
	CONST my_database		= 'imacs'; // MySQL
	/**
	 * @ignore in php documentation
	 */
	CONST my_dbuser			= 'root'; // MySQL
	/**
	 * @ignore in php documentation
	 */
	CONST my_dbpwd			= ''; // MySQL

	CONST sql_tbl_menu		= 'web_menu';			//'menu';
	CONST sql_tbl_ul		= 'web_userlevel';		//'userlevel';
	CONST sql_tbl_cnt		= 'web_content';		//'content';
	CONST sql_tbl_user		= 'web_user';			//'user';
	CONST sql_tbl_styles	= 'web_styles';			//'styles';
	CONST sql_tbl_pTypes	= 'web_types';			//'ptypes';
	CONST sql_tbl_proc		= 'web_procedures';		//'procedures';
	CONST sql_tbl_xTP		= 'web_xtypeprocedure';	//'xtypeproc';
	CONST sql_tbl_gData		= 'web_generaldata';	//'gdata';
	CONST sql_tbl_sact		= 'web_specialaction';	//'saction';
	CONST sql_tbl_ctc		= 'web_ctc';			//'concurrency'

	/**
	 * Menu types, do not change !!
	 * @ignore in php documentation
	 */
	CONST divMain		= 'divMain';
	CONST divHMenu		= 'divHMenu';
	CONST divVMenu		= 'divVMenu';
	CONST divRMenu		= 'divRMenu';
	CONST divPupMenu	= 'divPupMenu';
	CONST divRContent	= 'divRContent';
	
	/**
	 * Session time
	 */
	CONST sessionTimeOut	= 60;				// timeout value in minutes of a session 
	
	/*
	 * Functionalities
	 */
	CONST loginHidden		= FALSE;			// short/hidden or complete login dialog (True/False)
												// similar CONST also in cConfig.js
	CONST loginWithPWMaint	= 3;				// which ul is allowed to maintain the own password [0, 1, 2, ...] x 100
												// e.g. only admin (300) is allowed to, then this constant has to be 3 
	
	CONST taskIconPath		= 'src/images/btn/';// default path of task button icons 
	CONST thumbSubDir		= '.thumbs';		// default subdirectory of thumbs generated by xinha
	CONST thumbPrefix		= '.';				// default prefix of thumbnails (mandatory, no empty string)
	CONST thumbProportions	= TRUE;				// default flag to indicate that size proprtions shall be kept
	CONST thumbQuality		= 90;				// default flag to indicate that size proprtions shall be kept
	CONST thumbHeight		= 80;				// default height (96) of thumbnail generated by xinha
	CONST thumbWidth		= 100;				// default width (96) of thumbnail generated by xinha
												// Remark: more than 100px require styles adaptations
	CONST thumbExclSubDir	= NULL;				// could be used to exclude directory from search												
	CONST maxFileSizeImage	= 300;				// maximum size for uploading image files (300 kB here)
	CONST maxFileSizeLink	= 2000;				// maximum size for uploading files (2000 kB here)
	CONST maxFolderSize		= 50;				// Maximum upload folder size in Megabytes (0 disable check)											
	
	
	/**
	 * @ignore in php documentation
	 * Do nothing
	 */
	public function __construct(){

	}
	
// -----------------------
	
	/**
	 * Returns the styles to be loaded.
	 * 
	 * @ignore in php documentation
	 * @access public
	 * @return string (array)
	 */
	public static function cssLoads(){
		
		$strHtml = '<link class="jrcss-project" rel="stylesheet" type="text/css" href="'.self::protocol.'://'.$_SERVER['HTTP_HOST'].self::docPath.'/css/project.css" />';
//		$strHtml = '<!--[if lt IE 7]><link rel="stylesheet" type="text/css" href="'.self::protocol.'://'.$_SERVER['HTTP_HOST'].self::docPath.'/css/patchIE6.css" /><![endif]-->';
		
		return $strHtml;
	}
	
// -----------------------
	
	/**
	 * Returns the java script includes, general variables
	 * 
	 * @ignore in php documentation
	 * @access public
	 * @return string (array)
	 */
	public static function jsLoads(){
		
		$ulevel = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		$strHtml = '<script type="text/javascript">';
		$strHtml.= 'var codePar = '.self::codeSP.';'; // code/decode site parameter on base of Base64.encode/decode
		$strHtml.= 'var jrlang = \''.((!isset($_SESSION["language"]))? (self::lang) : ($_SESSION["language"])).'\';';
		$strHtml.= 'var projURL = \''.self::protocol.'://'.$_SERVER['HTTP_HOST'].self::srcPath.'\';';
		$strHtml.= 'var projProtocol = \''.self::protocol.'\';';
		$strHtml.= 'var ulevel = \''.$ulevel.'\';';
		$strHtml.= 'var taskList = '.json_encode(self::taskList()).';';
		$strHtml.= 'var uploadDIR = \''.self::uploadDIR.'\';';
		$strHtml.= 'var editorLevel = \''.self::editorLevel.'\';';
		$strHtml.= 'var webmasterLevel = \''.self::webmasterLevel.'\';';
		$strHtml.= 'var loginHidden = \''.self::loginHidden.'\';';
		$strHtml.= 'var projVersion = \''.self::projectVersion.'\';';
		$strHtml.= 'var projName = \''.self::project.'\';';
		$strHtml.= 'var debug = '.(isset($_GET['t']) ? $_GET['t'] : '0');
		$strHtml.= '</script>';
		$strHtml.= '<script type="text/javascript" src="'.self::protocol.'://'.$_SERVER['HTTP_HOST'].self::srcPath.'/src/mootools.cmp.js"></script>';
		$strHtml.= '<script type="text/javascript" src="'.self::protocol.'://'.$_SERVER['HTTP_HOST'].self::srcPath.'/src/mootools-more.cmp.js"></script>';
		$strHtml.= '<script type="text/javascript" src="'.self::protocol.'://'.$_SERVER['HTTP_HOST'].self::srcPath.'/src/webtoolkit.base64.cmp.js"></script>';
		$strHtml.= '<script type="text/javascript" src="'.self::protocol.'://'.$_SERVER['HTTP_HOST'].self::srcPath.'/src/jrcms.js"></script>';
		$strHtml.= '<script type="text/javascript" src="'.self::protocol.'://'.$_SERVER['HTTP_HOST'].self::srcPath.'/conf/cConfig.js"></script>';
		
		return $strHtml;
	}

// -----------------------
	
	/**
	 * Returns the Classes to be used.
	 * 
	 * @ignore in php documentation
	 * @access public
	 * @return string (array)
	 */
	public static function loadClasses(){
		
		$filepath = $_SERVER['DOCUMENT_ROOT'].self::srcPath.'/src/';

		require_once($filepath.'cException.php');
		if (self::dbms == 'mysql') {
			require_once($filepath.'cMySqlDriver.php');
			require_once($filepath.'cMySqlQueries.php');
		} else {
			require_once($filepath.'cMsSqlDriver.php');
			require_once($filepath.'cMsSqlQueries.php');
		}		
		require_once($filepath.'cDbInterface.php');
		require_once($filepath.'cUser.php');
		require_once($filepath.'cMenu.php');
		require_once($filepath.'cJrcms.php');
		require_once($filepath.'cJrcmsApi.php');
		require_once($filepath.'cJrcmsHelp.php');
	}
		
// -----------------------
	
	/**
	 * Returns the PHP includes to be used
	 * 
	 * @ignore in php documentation
	 * @access public
	 * @return string (array)
	 */
	public static function loadScripts(){
		
		$filepath = $_SERVER['DOCUMENT_ROOT'].self::srcPath.'/src/';
		
		require_once($filepath.'jrcmsutilities.php');
		
	}

// -----------------------
	
	/**
	 * Returns the data for DB.
	 * 
	 * @ignore in php documentation
	 * @access public
	 * @return string (array)
	 */
	public static function dbData(){
		if (self::dbms == 'mysql') 
			$dbconf = array(
				'dbhost' 		=> self::my_dbhost,
				'dbuser'		=> self::my_dbuser,
				'database'	=> self::my_database,
				'dbpwd'			=> self::my_dbpwd
			);
		else // MS SQL Server
			$dbconf = array(
				'dbhost' 		=> self::ms_dbhost,
				'dbuser'		=> self::ms_dbuser,
				'database'	=> self::ms_database,
				'dbpwd'			=> self::ms_dbpwd
			);
			
		return $dbconf;
	}
	
// -----------------------
	
	/**
	 * Returns the project data.
	 * 
	 * @ignore in php documentation
	 * @access public
	 * @return string (array)
	 */
	public static function pData(){
		$pconf = array(
			'project' 	=> self::project,
			'title'		=> self::title,
			'webmaster'	=> self::webmaster
		);
		return $pconf;
	}

// -----------------------

	/**
	 * definition of task lists (buttons/icons)
	 * {@source }
	 * @access public
	 * @return array
	 */
	public static function taskList(){
		//!! ATTENTION!! do not change sequence of tasks 
		//unless you have controlled all occurencies
		//enhancements are uncritical
		return  array( 
				'std' => array(
				//##controls set for standard tasks
					0 => array(
						// Task: NEW
						"script" => Null,
						"id" => "task_new"),
					1 => array(
						// Task: EDIT
						"script" => Null,
						"id" => "task_edit"),
					2 => array(
						// Task: VIEW
						"script" => Null,
						"id" => "task_view"),
					3 => array(
						// Task: SAVE
						"script" => Null,
						"id" => "task_save"),
					4 => array(
						// Task: DELETE
						"script" => Null,
						"id" => "task_trash"),
					5 => array(
						// Separator
						"script" => '##',
						"id" => NULL),
					6 => array(
						// Task: CUT
						"script" => NULL,
						"id" => "task_cut"),
					7 => array(
						// Task: COPY
						"script" => NULL,
						"id" => "task_copy"),
					8 => array(
						// Task: CLEAR
						"script" => NULL,
						"id" => "task_clear"),
					9 => array(
						// Separator
						"script" => '##',
						"id" => NULL),
					10 => array(
						// Task: Help
						"script" => NULL,
						"id" => "task_help")
					),
				'maint' => array(
				//##controls set for maintenance tasks
					0 => array(
						// Task: NEW
						"script" => Null,
						"id" => "task_new"),
					1 => array(
						// Task: EDIT
						"script" => Null,
						"id" => "task_edit"),
					2 => array(
						// Task: SAVE
						"script" => Null,
						"id" => "task_save"),
					3 => array(
						// Task: DELETE
						"script" => Null,
						"id" => "task_trash"),
					4 => array(
						// Separator
						"script" => '##',
						"id" => NULL),
					5 => array(
						// Task: MOVE UP
						"script" => Null,
						"id" => "task_up"),
					6 => array(
						// Task: MOVE DOWN
						"script" => Null,
						"id" => "task_down"),
					7 => array(
						// Separator
						"script" => '##',
						"id" => NULL),
					8 => array(
						// Task: FOLDER UP
						"script" => Null,
						"id" => "task_folder_up"),
					9 => array(
						// Task: FOLDER DOWN
						"script" => Null,
						"id" => "task_folder_down"),
					10 => array(
						// Separator
						"script" => '##',
						"id" => NULL),
					11 => array(
						// Task: Help
						"script" => NULL,
						"id" => "task_help")
					)
				);
	}
	
// -----------------------

	/**
	 * load the choosen language settings 
	 * 
	 * @ignore in php documentation
	 * @access public
	 * @return nothing
	 */

	public static function loadLanguage() {

		global $lang_php, $lang_js;
		
		$_SESSION["language"] =  self::lang;
		$_SESSION["srcPath"] = self::srcPath;
		$filepath = $_SERVER['DOCUMENT_ROOT'].self::docPath.'/lang/';
		$filename_lang = $filepath.'lang.'.$_SESSION["language"];
		
		if (file_exists($filename_lang) ) {
		
			if (is_readable($filename_lang) ) {
			
					include_once($filename_lang);
			}
		}
		//language support of core
		include_once(($_SERVER['DOCUMENT_ROOT'].self::docPath.'/src/lang/lang.'.$_SESSION["language"]));
		$lang_php = array_merge($lang_cphp, $lang_php);
		$lang_js = array_merge($lang_cjs, $lang_js);
		
	}

// -----------------------
	
	/**
	 * ini_sets...
	 * @ignore in php documentation
	 */
	public static function ini_sets(){
		error_reporting(E_ALL | E_STRICT);
		//error_reporting(E_NONE);
		date_default_timezone_set('Europe/Berlin');
		ini_set('session.bug_compat_warn', "0");
		ini_set('session.bug_compat_42', "0");
		ini_set('session.use_only_cookies', "1");
		ini_set('allow_url_fopen', "0");
		ini_set("session.gc_maxlifetime", "3600");

		ini_set('memory_limit', '64M'); 
		ini_set('max_execution_time', '240'); 
		ini_set('max_input_time', '240');
		
	}
	
// -----------------------
	
	/**
	 * @ignore in php documentation
	 * @return int
	 * 
	 * Mode_rewrite URIs on or off
	 * Off	= !return 1
	 * On	= return 1
	 */
	public static function uri(){
		return 1;
	}
	
// -----------------------

	/**
	 * @ignore in php documentation
	 * @access public
	 * @return nothing
	 */
	public static function loadConfig(){
		self::ini_sets();
		self::loadLanguage();
		self::loadClasses();
		// init exception handler;
		$myErr = & new MyException();
		$api = new JRCMSAPI();
		// initial setting of user level
		$_SESSION["ul"] = $api->isUserLoggedIn();
		// load scripts
		self::loadScripts();
		$_SESSION["srcPath"] = self::srcPath;
		$api = Null;
	}

// -----------------------

	/**
	 * @ignore in php documentation
	 * @access public
	 * @return nothing
	 */
	public static function jrCmsApi(){
		return new JRCMSAPI();
	}
// -----------------------
}