<?php
 /**
 * @package jrcms
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: index.php 605 2011-09-19 06:15:37Z jensraabe $ 
 * 
 * @copyright Copyright (c) 2008..2011, Jens Raabe & Clemens Schultz
 * Permission is hereby granted, free of charge, to any person 
 * obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included 
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR 
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
//TODO: shall be used only in case of significant changes
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Datum in der Vergangenheit
// -- start session
session_start(); 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
<?php
// --- load config
require_once('conf/cConfig.php');
CONFIG::loadConfig();
?>
<head>
	<title><?php echo CONFIG::title; ?></title>
	<link rel="shortcut icon" href="logo.ico" type="image/ico" />
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
	<meta name="copyright" content="Copyright (C) J.Raabe" />
	<meta name="description" content="" />
	<meta name="keywords" content="" />
	<meta name="robots" content="all" />
	<meta name="content-language" content="de" />
	<meta name="mime-type" content="html,htm,php" />
	<?php echo CONFIG::cssLoads(); ?>
	<?php echo CONFIG::jsLoads(); ?>
</head>
<?php flush(); ?>
<body>
<div id="divFrame" class="layout">	
	<div id="divColHeader" class="col-header">
		<!-- Logo-Box / BEGIN -->
		<div id="divLogo" class="logo-s">
			<div class="logo-box"><div class="logo-ne"></div><div class="logo-sw"></div><div class="logo-se"></div>
				<div id="divHeader">
					<div id="divWindowSize"><span class="nav" onclick="window.jrCMS.chgWindowSize({id:14,root:3,cssid:12});"><img src="src/images/spacer.gif" width="16px" height="12px" /></span></div>
					imacs
				</div>
			</div>
		</div>
		<!-- Logo-Box / END -->

		<!-- Horizontal Menu / BEGIN -->
		<div class="nav-e"><div class="nav-sw"></div>
			<div class="col-nav">
				<div id="divHMenu"><?php echo CONFIG::jrCmsApi()->getMenu();?>
				</div>
				<!-- >ul class="secondnav">
					<li><span class="hid">En</span></li>
					<li><span class="hid">Ger</span></li>
					<li><span class="hid">Pl</span></li>
				</ul -->
				<span class="secondnav" onclick="jrCMS.showAbout();return false;"><?php echo CONFIG::projectVersion; ?></span>
				<div class="nf"></div>
			</div>
		</div>
		<!-- Horizontal Menu / END -->
	</div>
	
	<div class="col-content">
		<div class="col-left fll">
			<!--  Content left row BEGIN -->
			<div class="shadow">
				<div class="shadow-cbox-e"><div class="shadow-cbox-ne"></div>
					<div class="shadow-cbox-s">
						<div class="cbox minheight_leftbox">
							<div id="divLeft" class="content">
								<div id="divVMenu"></div>
							</div>
						</div>
					</div>
				</div>
			</div>
			<!--  Content left row END -->
		</div>
		<div class="col-right fll">
			<div class="col-content-left fll">
				<!--  Content row BEGIN -->
				<div class="shadow">
					<div class="shadow-cbox-e"><div class="shadow-cbox-ne"></div>
						<div class="shadow-cbox-s">
							<div class="cbox minheight">
								<div id="divMain" class="content"></div>
							</div>
						</div>
					</div>
				</div>
				<!--  Content row END -->
			</div>
			<div class="col-content-right fll">
				<!--  Content right row BEGIN -->
				<!-- LOGIN -->
				<?php if (!CONFIG::loginHidden) {?>
				<div class="shadow">
					<div class="shadow-cbox-e"><div class="shadow-cbox-ne"></div>
						<div class="shadow-cbox-s">
							<div class="cbox minheight_rightbox">
								<div id="divRight">
									<div id="divLogin">
										<div class="divLoginHeader">			
											<a id="v_toggle" href="#">
												<img id="loginToggle" alt="toggler" src="src/images/restore.gif" />
											</a>
											<span id="spanLoginHeader">
											<?php
												if (CONFIG::jrCmsApi()->isUserLoggedIn() > 0)
													echo $lang_php['logged_in'];
												else
													echo $lang_php['logged_out'];
											?>
											</span>
										</div>
										<div class="nf"></div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<?php }?>
				<!-- TASK Menu -->
				<div class="shadow hideswitch">
					<div class="shadow-cbox-e"><div class="shadow-cbox-ne"></div>
						<div class="shadow-cbox-s">
							<div id="divRTMenu" class="cbox minheight_righttaskbox">
								<div id="divRMenu" class="content">
								</div>
							</div>
						</div>
					</div>
				</div>
				<!--  Content right row END -->
			</div><div class="nf"></div>
		</div><div class="nf"></div>
	</div>

	<div class="col-footer">
		<!-- Navigation footer BEGIN -->
		<div class="shadow-s">
			<div class="footerbox"><div class="shadow-footer-sw"></div>
				<ul>
					<li><span onclick="jrCMS.getContentForNode({l:'<?php echo $lang_php['contact']; ?>'});return false;"><?php echo $lang_php['contact']; ?></span></li>
					<li><span onclick="jrCMS.getContentForNode({l:'<?php echo $lang_php['webmaster']; ?>'});return false;"><?php echo $lang_php['webmaster']; ?></span></li>
					<li><span onclick="jrCMS.getContentForNode({l:'<?php echo $lang_php['impressum']; ?>'});return false;"><?php echo $lang_php['impressum']; ?></span></li>
					<li><span onclick="jrCMS.getContentForNode({l:'<?php echo $lang_php['sitemap']; ?>'});return false;"><?php echo $lang_php['sitemap']; ?></span></li>
				</ul>
				<div class="flr iconmail"><a href="mailto:<?php echo CONFIG::webmaster; ?>">&nbsp;&nbsp;</a></div>
				<div class="flr iconprint" onclick="Javascript:window.print();">&nbsp;</div>
				<?php if (CONFIG::loginHidden) {?>
					<div class="flr copyw" onclick="window.open('http://jrcmsdev.sourceforge.net'); return false;">powered by imacs</div>
					<div id="divLogin" class="flr shortlogin"><span class="nav" name="login" onclick="jrCMS.getLogin({a:'gin'}); return false;">&copy;</span></div>
				<?php } else {?>
					<div class="flr copyw" onclick="window.open('http://jrcmsdev.sourceforge.net'); return false;">&copy; powered by imacs</div>
				<?php }?>
				<div class="nf"></div>
			</div>
		</div>
		<!-- Navigation footer END -->
	</div>
</div>
</body>
</html>
<?php
# ENDE
?>