<?php
/**
 * adaptations to own project all marked with 'jens'
 * @author jens@raabe-berlin.de
 * $Revision: 1.2 $
 */

// jens: load configuration variables of own project
session_start();
require_once($_SERVER['DOCUMENT_ROOT'].$_SESSION['srcPath'].'/conf/cConfig.php');
if(isset($_SESSION["language"]))
	$filename = lang.'.'.$_SESSION["language"];
else
	$filename = lang.'.'.CONFIG::lang;
require_once($filename);
/*jens
define('COOKIE', 'username');
define('REDIRECT', '../');

$users = array('user'=>'../');

if(!isset($_COOKIE[COOKIE]) || !isset($users[$_COOKIE[COOKIE]])) {
	header('Location: '.REDIRECT);
	die();
}
define('BASE_DIR', $users[$_COOKIE[COOKIE]]);
*/

define('BASE_DIR', $_SERVER['DOCUMENT_ROOT'].CONFIG::srcPath.CONFIG::uploadDIR.'/');

error_reporting(E_ALL^E_NOTICE);

// to add an extension for a particular capability, 'ext'=>true
// $allowed what is allowed when renaming, uploading, and downloading
// $sources files where the source may need to be viewed
// $html files that produce HTML for validating
// $css files that produces CSS for validating
// $edit files that can be edited through the web
// $mp3 audio files that can be played through the flash player
// $image files that can manipulated on the web
// $download files that can't be downloaded through 'Save target as...'
$allowed  = array('jpg'=>1, 'gif'=>1, 'png'=>1,  'tif'=>1, 'bmp'=>1, 'htm'=>1, 'html'=>1, 'css'=>0, 'js'=>0,
                  'xml'=>1, 'php'=>0, 'phps'=>0, 'txt'=>1, 'doc'=>1, 'rtf'=>1, 'pdf'=>1,  'ppt'=>1, 'xls'=>1,
                  'csv'=>1, 'rpm'=>1, 'zip'=>1,  'tar'=>1, 'gz'=>1,  'sql'=>1, 'mdb'=>1,  'swf'=>1, 'mp3'=>0,
                  'tgz'=>1, 'rar'=>1, 'conf'=>1, 'tpl'=>1, 'inc'=>1, 'm'=>1,   'ico'=>1,  'kmz'=>1, 'torrent'=>1,
                  'jpeg'=>1);
$sources  = array('html'=>1, 'htm'=>1, 'php'=>1, 'js'=>1, 'm3u'=>1);
$html     = array('html'=>1, 'htm'=>1, 'php'=>1);
$css      = array('css'=>1);
$edit     = array('php'=>1, 'html'=>1, 'htm'=>1, 'css'=>1, 'js'=>1, 'xml'=>1, 'phps'=>1, 'txt'=>1, 'cvs'=>1, 'sql'=>1, 'conf'=>1);
$mp3      = array('mp3'=>1);
$image    = array('jpg'=>1, 'png'=>1, 'gif'=>1);
$download = array('php'=>1);

// max image dimensions when cropping
define('MAX_IMAGE_WIDTH', 640);
define('MAX_IMAGE_HEIGHT', 480);

$date_format = 'n/j/Y H:i';

$dir_img = 'dir.gif'; // image name, file will be located in the exts directory

// what to display for the file/folder options
$disp_edit     = '<img src="i/edit.gif" alt="E"/>';
$disp_delete   = '<img src="i/delete.gif" alt="D"/>';
$disp_rename   = '<img src="i/rename.gif" alt="R"/>';
$disp_copy     = '<img src="i/copy.gif" alt="C"/>';
$disp_source   = '<img src="i/source.gif" alt="S"/>';
$disp_validate = '<img src="i/validate.gif" alt="V"/>';
$disp_extract  = '<img src="i/extract.gif" alt="X"/>';
$disp_play     = '<img src="i/play.gif" alt="P"/>';
$disp_image    = '<img src="i/image.gif" alt="I"/>';
$disp_download = '<img src="i/download.gif" alt="W"/>';
$disp_open     = '<img src="i/open.gif" alt="O"/>';
$disp_empty    = '<img src="i/empty.gif" alt="T"/>';

// what to display for functions
$disp_create   = '<input type="image" src="i/create.gif"/>';
$disp_upload   = '<input type="image" src="i/upload.gif"/>';
$disp_search   = '<input type="image" src="i/search.gif"/>';

// check options, use only the image filename
$disp_zip      = 'i/extract.gif';

// what to display for navigation
$disp_home     = '<img src="i/home.gif" alt=""/>'.$lang_mng['mng_cnt29'];
$disp_refresh  = '<img src="i/refresh.gif" alt=""/>'.$lang_mng['mng_cnt30'];
$disp_up       = '<img src="i/up.gif" alt=""/>'.$lang_mng['mng_cnt28'];
$disp_help     = '<img src="i/help.gif" alt=""/>'.$lang_mng['mng_cnt31'];
$disp_back     = '&laquo; '.$lang_mng['back'];

// error and success prefixes
$disp_success  = '';
$disp_error    = '<img src="i/error.gif" alt=""/> ';

// validators
$html_validator = 'http://validator.w3.org/check?uri=';
$css_validator  = 'http://jigsaw.w3.org/css-validator/validator?uri=';

// no more editing

function getExt($name) {
	if(($pos = strrpos($name, '.')) !== false) return strtolower(substr($name, $pos+1));
	else return '';
}

if(!function_exists('scandir')) {
	function scandir($dir) {
		$ret = array();
		if($link = opendir($dir)) {
			while($item = readdir($link)) $ret[] = $item;
			closedir($link);
		}
		return $ret;
	}
}

function renderImage($src, $dest, $sx, $sy, $dw, $dh, $sw, $sh) {
	$ext = getExt($src);
	if($ext == 'jpg') $im = @imagecreatefromjpeg($src);
	elseif($ext == 'png') $im = @imagecreatefrompng($src);
	elseif($ext == 'gif') $im = @imagecreatefromgif($src);
	if(!$im) return false;

	$new = @imagecreatetruecolor($dw, $dh);
	if($new) {
		if(@imagecopyresampled($new, $im, 0, 0, $sx, $sy, $dw, $dh, $sw, $sh)) {
			if($ext == 'jpg') $ret = @imagejpeg($new, $dest, 75);
			elseif($ext == 'png') $ret = @imagepng($new, $dest);
			else $ret = @imagegif($new, $dest);
		}
		else $ret = false;
		@imagedestroy($new);
	}
	else $ret = false;
	@imagedestroy($im);

	return $ret;
}

function prevDir($dir) {
	if(substr($dir, -1) == '/') $dir = substr($dir, 0, -1);
	if(($pos=strrpos($dir, '/')) !== false) return substr($dir, 0, $pos+1);
	else return '';
}

function getSize($size) {
	$suffixes = array('Bytes', 'KB', 'MB', 'GB', 'TB', 'PB');
	$i = 0;
	while($size >= 1024) {
		$size /= 1024;
		$i++;
	}
	return number_format($size, ($i == 0 ? 0 : 2)).' '.$suffixes[$i];
}

function getDirCount($dir) {
	return count(scandir(BASE_DIR.$dir)) - 2; // for . and ..
}

function unzip($dir, $file, $allowed) {
	if(!function_exists('zip_open')) return array(0, '?');
	$good = 0;
	$total = 0;
	$zip = @zip_open(realpath(BASE_DIR.$dir.$file));

	if($zip) {
		while($zip_entry = zip_read($zip)) {
			$name = zip_entry_name($zip_entry);
			$filename = $name;
			$newdir = BASE_DIR.$dir;
			while(($pos = strpos($filename, '/')) !== false) {
				$newdir.=substr($filename, 0, $pos).'/';
				$filename = substr($filename, $pos+1, strlen($filename) - $pos - 1);
				if(!file_exists($newdir)) @mkdir($newdir);
			}

			$total++;
			if(!file_exists(BASE_DIR.$dir.$name) && $allowed[getExt($name)]) {
				if(zip_entry_open($zip, $zip_entry, 'r')) {
					$buf = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
					$fd = @fopen(BASE_DIR.$dir.$name, 'w');
					if($fd) {
						if(@fwrite($fd, $buf)) $good++;
			  			@fclose($fd);
					}
					zip_entry_close($zip_entry);
				}
			}
		}
		zip_close($zip);
	}
	return array($good, $total);
}

function getImageFactor($x, $y) {
	$factor = max(array($x / MAX_IMAGE_WIDTH, $y / MAX_IMAGE_HEIGHT));
	if($factor < 1) $factor = 1;
	return $factor;
}

function newName($dir, $name, $extra='') {
	$ext = getExt($name);
	$name = substr($name, 0, strlen($name) - strlen($ext) - 1).$extra;
	$x = 0;
	$end = '';
	while(file_exists(BASE_DIR."{$dir}{$name}{$end}.{$ext}")) {
		$end = "_{$x}";
		$x++;
	}
	return "{$name}{$end}.{$ext}";
}

function emptydir($dir) {
	if(substr($dir, -1) != '/') $dir .= '/';
	$list = scandir(BASE_DIR.$dir);
	unset($list[0], $list[1]);
	foreach($list as $item) {
		if(is_dir(BASE_DIR.$dir.$item)) {
			if(!emptydir($dir.$item)) return false;
		}
		elseif(!@unlink(BASE_DIR.$dir.$item)) return false;
	}
	if(!@rmdir(BASE_DIR.$dir)) return false;
	return true;
}

// get the current working directory
$dir = (isset($_GET['dir']) ? str_replace('//', '/', $_GET['dir']) : '');
if(strpos($dir, '..') !== false) $dir = '';
if($dir != '' && substr($dir, -1) != '/') $dir .= '/';
$prev = prevDir($dir);

// get the current working file
$file = (isset($_GET['file']) ? stripslashes($_GET['file']) : '');
if(strpos($file, '/') !== false) $file = '';
$ext = getExt($file);

$action = (isset($_GET['action']) ? $_GET['action'] : '');
$search = isset($_GET['query']);
$query = ($search ? $_GET['query'] : '');
if($search) $prev = $dir;

// a place to store all errors and successes
$errors = array();
$success = array();

// apply all the actions that have occured
if(isset($_FILES['upload']['name'])) {
	$ext = getExt($_FILES['upload']['name']);
	if(isset($allowed[$ext])) {
		$filename = newName($dir, urldecode($_FILES['upload']['name']));
		if(@move_uploaded_file($_FILES['upload']['tmp_name'], BASE_DIR.$dir.$filename) && file_exists(BASE_DIR.$dir.$filename)) $success[] = "Successfully uploaded file <em>{$filename}</em>";
		else $errors[] = $lang_mng['mng_err1'];
	}
	else $errors[] = $lang_mng['mng_err2'];
}
elseif(isset($_GET['save'])) {
	$page = stripslashes($_POST['page']);
	//$page = $_POST['page'];
	if(isset($_POST['tabs'])) $page = str_replace('    ', "\t", $page);
	if(is_writable(BASE_DIR.$dir.$file)) {
		$fd = @fopen(BASE_DIR.$dir.$file, 'w');
		if($fd) {
			if(@fwrite($fd, $page)) $success[] = $lang_mng['mng_saved'];
			else $errors[] = $lang_mng['mng_err3'];
			@fclose($fd);
		}
		else $errors[] = $lang_mng['mng_err4'];
	}
	else $errors[] = $lang_mng['mng_err5'];
}
elseif(isset($_GET['type']) && isset($_GET['create'])) {
	$create = $_GET['create'];
	$type = $_GET['type'];
	if($type == 'auto') {
		if(getExt($create) == '') $type = 'dir';
		elseif(preg_match('/^(https?|ftps?):\/\//', $create)) {
			$type = 'url';
			$url = $create;
			$create = explode('/', $url);
			$create = newName($dir, $create[count($create)-1]);
		}
		else $type = 'file';
	}

	if(!file_exists(BASE_DIR.$dir.$create)) {
		if($type == 'file') {
			$ext = getExt($create);
			if(isset($allowed[$ext])) {
				if(@touch(BASE_DIR.$dir.$create)) $success[] = $lang_mng['mng_created'];
				else $errors[] = $lang_mng['mng_err6'];
			}
			else $errors[] = $lang_mng['mng_err7'];
		}
		elseif($type == 'dir') {
			if(@mkdir(BASE_DIR.$dir.$create)) $success[] = $lang_mng['mng_dir_created'];
			else $errors[] = $lang_mng['mng_err8'];
		}
		elseif($type == 'url') {
			$ext = getExt($create);
			if(isset($allowed[$ext])) {
				$fd = @fopen($url, 'r');
				if($fd) {
					$download = '';
					while(!feof($fd)) $download .= @fread($fd, 4096);
					@fclose($fd);

					@touch(BASE_DIR.$dir.$create);
					$fd = @fopen(BASE_DIR.$dir.$create, 'w');
					if($fd) {
						if(@fwrite($fd, $download)) $success[] = $lang_mng['mng_downloaded'];
						else $errors[] = $lang_mng['mng_err9'];
					}
					else $errors[] = $lang_mng['mng_err10'];
				}
				else $errors[] = $lang_mng['mng_err11'];
			}
			else $errors[] = $lang_mng['mng_err12'];
		}
	}
	else $errors[] = $lang_mng['mng_err13'];
}
elseif(isset($_GET['delete'])) {
	if(is_dir(BASE_DIR."{$dir}/{$file}")) {
		if(@rmdir(BASE_DIR.$dir.$file)) $success[] = $lang_mng['mng_dir_deleted'];
		else $errors[] = $lang_mng['mng_err14'];
	}
	else {
		if(@unlink(BASE_DIR.$dir.$file)) $success[] = $lang_mng['mng_deleted'];
		else $errors[] = $lang_mng['mng_err15'];
	}
}
elseif(isset($_GET['rename']) && isset($_GET['newname'])) {
	$newname = stripslashes($_GET['newname']);

	// make sure that is the new name is also changing directories, that the new dir is within the allow BASEa
	$failed = false;
	if(($pos = strrpos($newname, '/')) !== false) {
		$tmp = substr($newname, 0, $pos);
		$real = realpath(BASE_DIR);
		$failed = strncmp($real, realpath(BASE_DIR.$dir.$tmp), strlen($real));
	}

	if(!$failed) {
		if(isset($allowed[getExt($newname)]) || is_dir(BASE_DIR.$dir.$file)) {
			if(@rename(BASE_DIR.$dir.$file, BASE_DIR.$dir.$newname)) $success[] = $lang_mng['mng_renamed'];
			else $errors[] = $lang_mng['mng_err16'];
		}
		else $errors[] = $lang_mng['mng_err17'];
	}
	else $errors[] = $lang_mng['mng_err18'];
}
elseif(isset($_GET['copy'])) {
	$new = newName($dir, $file, '_copy');
	if(copy(BASE_DIR.$dir.$file, BASE_DIR.$dir.$new)) $success[] = $lang_mng['mng_copied'];
	else $errors[] = $lang_mng['mng_err19'];
}
elseif(isset($_GET['resize'])) {
	$dim = getimagesize(BASE_DIR.$dir.$file);
	$w = (isset($_GET['width']) ? (int)$_GET['width'] : 0);
	if(isset($_GET['constrain'])) {
		$factor = $w / $dim[0];
		$h = $dim[1] * $factor;
	}
	else $h = (isset($_GET['height']) ? (int)$_GET['height'] : 0);

	if($w && $h) {
		if(renderImage(BASE_DIR.$dir.$file, BASE_DIR.$dir.$file, 0, 0, $w, $h, $dim[0], $dim[1])) $success[] = $lang_mng['mng_img_resized'];
		else $errors[] = $lang_mng['mng_err20'];
	}
	else $errors[] = $lang_mng['mng_err21'];
}
elseif(isset($_GET['crop'])) {
	if(isset($image[$ext])) {
		$out = newName($dir, $file, '_crop');

		if(isset($_GET['x1']) && isset($_GET['y1']) && isset($_GET['x2']) && isset($_GET['y2']) && isset($_GET['factor'])) {
			$factor = $_GET['factor'];
			$x1 = $_GET['x1'] * $factor;
			$y1 = $_GET['y1'] * $factor;
			$x2 = $_GET['x2'] * $factor;
			$y2 = $_GET['y2'] * $factor;

			$w = $x2 - $x1;
			$h = $y2 - $y1;

			if(renderImage(BASE_DIR.$dir.$file, BASE_DIR.$dir.$out, $x1, $y1, $w, $h, $w, $h)) $success[] = $lang_mng['mng_img_cropped'];
			else $errors[] = $lang_mng['mng_err22'];
		}
		else $errors[] = $lang_mng['mng_err23'];
	}
	else $errors[] = $lang_mng['mng_err24'];
}
elseif(isset($_GET['extract'])) {
	if($ext == 'zip') {
		$result = unzip($dir, $file, $allowed);
		if($result[0] > 0) $success[] = $lang_mng['mng_zip_extracted1'].$result[0].$lang_mng['mng_zip_extracted2'].$result[2].$lang_mng['mng_zip_extracted3'];
		else $errors[] = $lang_mng['mng_err25'].$result[1].$lang_mng['mng_err26'];
	}
	else $errors[] = $lang_mng['mng_err27'];
}
elseif(isset($_GET['download'])) {
	$filename = BASE_DIR.$dir.$file;
	if(file_exists($filename)) {
		header("Pragma: public"); // required
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Cache-Control: private", false); // required for certain browsers
		header("Content-disposition: attachment; filename=\"{$file}\"");
		header("Content-Type: {$ext}");
		header("Content-Transfer-Encoding: binary");
		header("Content-Length: ".filesize($filename));
		readfile($filename);
		die();
	}
}
elseif(isset($_GET['empty'])) {
	if(emptydir($dir.$file)) $success[] = $lang_mng['mng_dir_deleted'];
	else $errors[] = $lang_mng['mng_err14'];
}
elseif(isset($_POST['zip']) && file_exists('zip.class.php') && isset($_POST['files'])) {
	require('zip.class.php');
	$name = newName($dir, 'archive.zip');
	$zip = new zipfile($name, BASE_DIR.$dir, $_POST['files']);
	$success[] = $lang_mng['mng_zip_created'];
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml10/DTD/xhtml10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<title>MyManager</title>
	<meta http-equiv="content-type" content="charset=iso-8859-1"/>
	<link rel="stylesheet" href="style.css"/>
	<script type="text/javascript">function checkDelete() { return confirm("Are you sure you wish to delete this item?"); }</script>
</head>
<body>
<?php
if($action == 'help') {
	echo "<h1>".$lang_mng['mng_help1']."<a href=\"?dir={$dir}\">{$disp_back}</a></h1>\n";
	echo "<div>\n";
	echo "\t<h2>".$lang_mng['mng_help2']."</h2>\n";
	echo "\t{$disp_edit} - ".$lang_mng['mng_help3']."<br/>\n";
	echo "\t{$disp_delete} - ".$lang_mng['mng_help4']."<br/>\n";
	echo "\t{$disp_rename} - ".$lang_mng['mng_help5']."<br/>\n";
	echo "\t{$disp_copy} - ".$lang_mng['mng_help6']."<br/>\n";
	echo "\t{$disp_source} - ".$lang_mng['mng_help7']."<br/>\n";
	echo "\t{$disp_validate} - ".$lang_mng['mng_help8']."<br/>\n";
	echo "\t{$disp_extract} - ".$lang_mng['mng_help9']."<br/>\n";
	echo "\t{$disp_play} - ".$lang_mng['mng_help10']."<br/>\n";
	echo "\t{$disp_image} - ".$lang_mng['mng_help11']."<br/>\n";
	echo "\t{$disp_download} - ".$lang_mng['mng_help12']."<br/>\n";
	echo "\t{$disp_open} - ".$lang_mng['mng_help13']."<br/>\n";
	echo "\t{$disp_empty} - ".$lang_mng['mng_help14']."<br/><br/>\n";

	echo "\t<h2>".$lang_mng['mng_help15']."</h2>\n";
	echo "\t{$disp_home} - ".$lang_mng['mng_help16']."<br/>\n";
	echo "\t{$disp_refresh} - ".$lang_mng['mng_help17']."<br/>\n";
	echo "\t{$disp_up} - ".$lang_mng['mng_help18']."<br/>\n";
	echo "\t{$disp_help} - ".$lang_mng['mng_help19']."<br/>\n";
	echo "\t{$disp_back} - ".$lang_mng['mng_help20']."<br/><br/>\n";

	echo "\t<h2>".$lang_mng['mng_help21']."</h2>\n";
	echo "\t<img src=\"{$disp_zip}\" alt=\"\"/> Zip - ".$lang_mng['mng_help22']."<br/><br/>\n";

	echo "\t<h2>".$lang_mng['mng_help23']."</h2>\n";
	echo "\t{$disp_upload} Upload - ".$lang_mng['mng_help24']."<br/>\n";
	echo "\t{$disp_create} Create - ".$lang_mng['mng_help25']."<br/>\n";
	echo "\t{$disp_search} Search - ".$lang_mng['mng_help26']."<br/>\n";
	echo "</div>\n";
}
elseif($action == 'source' && isset($sources[$ext])) {
	echo "<h1>".$lang_mng['mng_cnt1']."/{$dir}{$file} <a href=\"?dir={$dir}\">{$disp_back}</a></h1>\n";
	if($ext == 'php') echo highlight_file(BASE_DIR.$dir.$file, true);
	else echo str_replace("\t", '&nbsp; &nbsp;', str_replace("\n", "<br/>\n", htmlentities(file_get_contents(BASE_DIR.$dir.$file))));
	echo "\n";
}
elseif($action == 'edit' && isset($edit[$ext])) {
	echo "<h1>".$lang_mng['mng_cnt2']."/{$dir}{$file} <a href=\"?dir={$dir}\">{$disp_back}</a></h1>\n";
	echo "<form method=\"post\" action=\"?dir={$dir}&file={$file}&save=true\">\n";
	echo "\t<textarea name=\"page\" cols=\"100\" rows=\"30\" wrap=\"off\">";
	echo htmlentities(file_get_contents(BASE_DIR.$dir.$file));
	echo "</textarea><br/>\n";
	echo "\t<label for=\"tabs\"><input type=\"checkbox\" name=\"tabs\" value=\"1\" id=\"tabs\"/>".$lang_mng['mng_cnt3']."</label><br/>\n";
	echo "\t<input type=\"submit\" value=\"Save\"/> <input type=\"reset\"/> <a href=\"?dir={$dir}\">{$disp_back}</a>\n";
	echo "</form>\n";
}
elseif($action == 'image' && isset($image[$ext])) {
	echo "<h1>".$lang_mng['mng_cnt4']."/{$dir}{$file} <a href=\"?dir={$dir}\">{$disp_back}</a></h1>\n";

	$crop = file_exists('crop.js');
	if($crop) echo "<script type=\"text/javascript\" src=\"crop.js\"></script>\n";

	$dim = getimagesize(BASE_DIR.$dir.$file);
	$factor = getImageFactor($dim[0], $dim[1]);
	echo "<form method=\"get\" action=\"\"/><div>\n";
	echo "\t<input type=\"hidden\" name=\"dir\" value=\"{$dir}\"/>\n";
	echo "\t<input type=\"hidden\" name=\"file\" value=\"{$file}\"/>\n";
	echo "\t<input type=\"hidden\" name=\"resize\" value=\"1\"/>\n";
	echo "\tWidth: <input name=\"width\" size=\"4\" value=\"".$dim[0]."\"/>\n";
	echo "\tHeight: <input name=\"height\" id=\"height\" size=\"4\" value=\"".$dim[1]."\" disabled=\"disabled\"/><br/>\n";
	echo "\t<label for=\"constrain\"><input type=\"checkbox\" name=\"constrain\" value=\"1\" id=\"constrain\" checked=\"checked\" onclick=\"document.getElementById('height').disabled=this.checked;\"/>".$lang_mng['mng_cnt5']."</label>\n";
	echo "\t<input type=\"submit\" value=\"Resize\"/>\n";
	echo "</div></form>\n";

	if($crop) {
		echo "<form method=\"get\" action=\"\"/><div>\n";
		echo "\t<input type=\"hidden\" name=\"dir\" value=\"{$dir}\"/>\n";
		echo "\t<input type=\"hidden\" name=\"file\" value=\"{$file}\"/>\n";
		echo "\t<input type=\"hidden\" name=\"crop\" value=\"1\"/>\n";
		echo "\t<input type=\"hidden\" name=\"x1\" id=\"x1\"/>\n";
		echo "\t<input type=\"hidden\" name=\"y1\" id=\"y1\"/>\n";
		echo "\t<input type=\"hidden\" name=\"x2\" id=\"x2\"/>\n";
		echo "\t<input type=\"hidden\" name=\"y2\" id=\"y2\"/>\n";
		echo "\t<input type=\"hidden\" name=\"factor\" value=\"{$factor}\"/>\n";
		echo "\t<input type=\"submit\" id=\"button\" value=\"Crop\" disabled=\"disabled\"/>".$lang_mng['mng_cnt6']."\n";
		echo "</div></form>\n";
		echo "<div id=\"box\" style=\"background-image:url('i/area.gif');position:absolute;visibility:hidden;width:0px;height:0px;border:1px solid #006;z-index:500\"></div>\n";
	}

	echo "<img src=\"".BASE_DIR."{$dir}{$file}\" alt=\"\"".($crop ? ' id="pic" style="position:relative" onmousedown="crop(event);"' : '')." width=\"".($dim[0] / $factor).'" height="'.($dim[1] / $factor)."\"/><br/>\n";
	echo "<div>\n";

	$exif = 0;
	if(function_exists('exif_read_data')) $exif = @exif_read_data(BASE_DIR.$dir.$file);
	if($exif) {
		if(isset($exif['Make'])) echo "\t".$lang_mng['mng_cnt7'].": ".$exif['Make']." ".$exif['Model']."<br/>\n";
		if(isset($exif['FileDateTime'])) echo "\t".$lang_mng['mng_cnt8'].": ".date($date_format, $exif['FileDateTime'])."<br/>\n";
		elseif(isset($exif['DateTime'])) echo "\t".$lang_mng['mng_cnt8'].": ".$exif['DateTime']."<br/>\n";
		if(isset($exif['COMPUTED']['ApertureFNumber'])) echo "\t".$lang_mng['mng_cnt9'].": ".$exif['COMPUTED']['ApertureFNumber']."<br/>\n";
		if(isset($exif['ExposureTime'])) {
			$tmp = explode("/", $exif['ExposureTime']);
			echo "\t".$lang_mng['mng_cnt10'].": ".number_format($tmp[0] / $tmp[1] * 1000, 2)." milliseconds";
			if(isset($exif['ISOSpeedRatings'])) echo " (".$exif['ISOSpeedRatings']." speed)";
			echo "<br/>\n";
		}
		if(isset($exif['FocalLength'])) {
			$tmp = explode("/", $exif['FocalLength']);
			echo "\t".$lang_mng['mng_cnt11'].": ".number_format(floor($tmp[0]/$tmp[1]), 0)." mm<br/>\n";
		}
	}
	echo "\t".$lang_mng['mng_cnt12'].": ".$dim[0].'x'.$dim[1]."<br/>\n";
	echo "\t".$lang_mng['mng_cnt13'].": ".getSize(filesize(BASE_DIR.$dir.$file))."\n";
	echo "</div>\n";
}
else {
	if($search) echo "<h1>".$lang_mng['mng_cnt14']."<a href=\"?dir={$dir}\">{$disp_back}</a></h1>\n";
	else echo "<h2>".$lang_mng['mng_cnt15'].": /{$dir}</h2>\n";
?>
<div class="menu">
	<div class="left">
	<form action="?dir=<?php echo $dir; ?>" enctype="multipart/form-data" method="post"><div>
		<? echo $lang_mng['mng_cnt16']; ?>:<br/><input type="file" name="upload"/>
		<input type="hidden" name="action" value="upload"/><?php echo $disp_upload."\n"; ?>
	</div></form><br/>
	</div> <!-- left -->
	<div class="right">
	<form action="?" method="get"><div>
		<? echo $lang_mng['mng_cnt17']; ?>:<br/>
		<input size="30" name="query" value="<?php echo str_replace('"', '&quot;', $query); ?>"/>
		<input type="hidden" name="dir" value="<?php echo $dir; ?>"/><?php echo $disp_search."\n"; ?>
	</div></form><br/>
	<form action="?" method="get"><div>
		<? echo $lang_mng['mng_cnt18']; ?>:<br/>
		<label for="auto"><input type="radio" name="type" checked="checked" value="auto" id="auto"/><? echo $lang_mng['mng_cnt19']; ?></label>
		<label for="newdir"><input type="radio" name="type" value="dir" id="newdir"/><? echo $lang_mng['mng_cnt20']; ?></label>
		<label for="newfile"><input type="radio" name="type" value="file" id="newfile"/><? echo $lang_mng['mng_cnt21']; ?></label><br/>
		<input size="30" name="create"/>
		<input type="hidden" name="dir" value="<?php echo $dir; ?>"/><?php echo $disp_create."\n"; ?>
	</div></form><br/>
	</div> <!-- right -->
	<div class="center">
		<a href="?dir=<?php echo $prev; ?>"><?php echo $disp_up; ?></a>
		<a href="?dir=<?php echo $dir; ?>"><?php echo $disp_refresh; ?></a>
		<a href="?"><?php echo $disp_home; ?></a>
		<a href="?dir=<?php echo $dir; ?>&amp;action=help"><?php echo $disp_help; ?></a>
	</div><br/>
<?php
	// display all the errors and successes
	$count = count($errors);
	if($count > 0) {
		echo "\t<div class=\"error\">{$disp_error}";
		for($i = 0; $i < $count; $i++) {
			echo $errors[$i];
			if($i < $count - 1) echo '<br/>';
		}
		echo "</div>\n";
	}

	$count = count($success);
	if($count > 0 || $search) {
		echo "\t<div class=\"success\">{$disp_success}";
		for($i = 0; $i < $count; $i++) {
			echo $success[$i];
			if($i < $count - 1) echo '<br/>';
		}
		echo "</div>\n";
	}

	$rename = ($action == 'rename');
	$checkboxes = !$search && !$rename && file_exists('zip.class.php');

	echo "</div>\n\t";
	if($checkboxes) echo "<form method=\"post\" action=\"?dir={$dir}\">";
	echo "<div class=\"content\">\n";

	$dirs = array();
	$files = array();

	if($search && ($query != '')) {
		$links = array($dir);
		while(count($links) > 0) {
			$entry = array_shift($links);
			$list = scandir(BASE_DIR.$entry);
			unset($list[0], $list[1]);
			foreach($list as $item) {
				$found = (strpos($item, $query) !== false);
				if(is_dir(BASE_DIR.$entry.$item)) {
					$links[] = $entry.$item.'/';
					if($found) $dirs[] = $entry.$item;
				}
				elseif($found) $files[] = $entry.$item;
			}
		}
	}
	else {
		$all = scandir(BASE_DIR.$dir);
		unset($all[0], $all[1]); // remove . and ..

		foreach($all as $entry) {
			if(is_dir(BASE_DIR.$dir.$entry)) $dirs[] = $entry;
			else $files[] = $entry;
		}
	}

	$count = count($files) + count($dirs);
	$total = 0;

	/*
	// this is the base link for the W3C validation, TODO: better way...?
	ereg("(/.*)/", $PHP_SELF, $self);
	//TODO: to be replaced by preg_match ??
	$self = $self[1];
	$w3c = "http://".$_SERVER['HTTP_HOST']."{$self}/".BASE_DIR;
	*/
	$w3c = $_SERVER['HTTP_REFERER'].BASE_DIR;

	$x = 1;
	echo "\t<table cellpadding=\"2\" cellspacing=\"0\">\n";
	echo "\t\t<tr class=\"title\">\n";
	echo "\t\t\t<td style=\"width:16px\">".($checkboxes ? "<input type=\"image\" src=\"{$disp_zip}\" name=\"zip\" value=\"1\"/>" : '&nbsp;')."</td>\n";
	echo "\t\t\t<td style=\"width:325px\">".$lang_mng['mng_cnt22']."</td>\n";
	echo "\t\t\t<td style=\"width:160px\">".$lang_mng['mng_cnt23']."</td>\n";
	echo "\t\t\t<td class=\"right\" style=\"width:150px\">".$lang_mng['mng_cnt24']."</td>\n";
	echo "\t\t</tr>";
	if($dir != '') {
		echo '<tr class="row'.($x%2)."\">\n";
		echo "\t\t\t<td>&nbsp;</td>\n";
		echo "\t\t\t<td><a href=\"?dir={$prev}\"><img src=\"exts/{$dir_img}\" alt=\"\"/>..</a></td>\n";
		echo "\t\t\t<td>&nbsp;</td>\n";
		echo "\t\t\t<td class=\"right\">".date($date_format, filemtime(BASE_DIR.$dir.'../'))."</td>\n";
		echo "\t\t</tr>";
		$x++;
	}

	foreach($dirs as $name) {
		if($search && ($pos = strrpos($name, '/')) !== false) {
			$dir = substr($name, 0, $pos);
			$name = substr($name, $pos+1);
		}

		$lname = rawurlencode($name);
		$current = ($file == $name);
		$size = getDirCount($dir.$name);

		echo '<tr class="row'.($x%2)."\">\n";
		echo "\t\t\t<td>".($checkboxes ? "<input type=\"checkbox\" name=\"files[]\" value=\"{$lname}\"/>" : '&nbsp;')."</td>\n";
		echo "\t\t\t<td>";
		if($rename && $current) {
			echo "<form method=\"get\" action=\"\">\n";
			echo "\t\t\t\t<a name=\"rename\"></a>\n";
			echo "\t\t\t\t<input type=\"hidden\" name=\"rename\" value=\"1\"/>\n";
			echo "\t\t\t\t<input type=\"hidden\" name=\"file\" value=\"{$name}\"/>\n";
			echo "\t\t\t\t<input type=\"hidden\" name=\"dir\" value=\"{$dir}\"/>\n";
			echo "\t\t\t\t<input name=\"newname\" value=\"{$name}\" size=\"30\"/>\n";
			echo "\t\t\t\t<input type=\"submit\" value=\"Rename\"/>\n";
			echo "\t\t\t</form>";
		}
		else echo "<a href=\"?dir={$dir}{$name}\"><img src=\"exts/{$dir_img}\" alt=\"\"/> {$name}</a> ({$size} files)";
		echo "</td>\n";
		echo "\t\t\t<td>\n";
		if(is_writable(BASE_DIR.$dir.$name)) {
			echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;action=rename#rename\">{$disp_rename}</a>\n";
			if($size == 0) echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;delete=1\" onclick=\"return checkDelete()\">{$disp_delete}</a>\n";
			else echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;empty=1\" onclick=\"checkDelete()\">{$disp_empty}</a>\n";
		}
		else echo '&nbsp;';
		echo "\t\t\t</td>\n";
		echo "\t\t\t<td class=\"right\">".date($date_format, filemtime(BASE_DIR.$dir.$name))."</td>\n";
		echo "\t\t</tr>";
		$x++;
	}

	foreach($files as $name) {
		if($search && ($pos = strrpos($name, '/')) !== false) {
			$dir = substr($name, 0, $pos+1);
			$name = substr($name, $pos+1);
		}

		$lname = rawurlencode($name);
		$ext = getExt($name);
		$current = ($file == $name);

		echo '<tr class="row'.($x%2)."\">\n";
		echo "\t\t\t<td>".($checkboxes ? "<input type=\"checkbox\" name=\"files[]\" value=\"{$lname}\"/>" : '&nbsp;')."</td>\n";
		echo "\t\t\t<td>";
		if($rename && $current) {
			echo "<form method=\"get\" action=\"\">\n";
			echo "\t\t\t\t<a name=\"rename\"></a>\n";
			echo "\t\t\t\t<input type=\"hidden\" name=\"rename\" value=\"1\"/>\n";
			echo "\t\t\t\t<input type=\"hidden\" name=\"file\" value=\"{$name}\"/>\n";
			echo "\t\t\t\t<input type=\"hidden\" name=\"dir\" value=\"{$dir}\"/>\n";
			echo "\t\t\t\t<input name=\"newname\" value=\"{$name}\" size=\"30\"/>\n";
			echo "\t\t\t\t<input type=\"submit\" value=\"Rename\"/>\n";
			echo "\t\t\t</form>";
		}
		else {
			echo '<a';
			if(!isset($allowed[$ext])) echo ' class="banned"';
			echo ' href="'.BASE_DIR."{$dir}{$name}\">";
			if(file_exists("exts/{$ext}.gif")) echo "<img src=\"exts/{$ext}.gif\" alt=\"\"/> ";
			echo "{$name}</a>";
			$size = filesize(BASE_DIR.$dir.$name);
			$total += $size;
			echo ' ('.getSize($size).')';
		}
		echo "</td>\n\t\t\t<td>\n";
		if(is_writable(BASE_DIR.$dir.$name)) {
			if(isset($edit[$ext])) echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;action=edit\">{$disp_edit}</a>\n";
			echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;action=rename#rename\">{$disp_rename}</a>\n";
			echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;delete=1\" onclick=\"return checkDelete()\">{$disp_delete}</a>\n";
		}
		echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;copy=1\">{$disp_copy}</a>\n";

		if($ext == 'zip' && function_exists('zip_open')) echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;extract=1\">{$disp_extract}</a>\n";
		if(isset($sources[$ext])) echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;action=source\">{$disp_source}</a>\n";

		if(isset($html[$ext])) echo "\t\t\t\t<a href=\"{$html_validator}{$w3c}{$dir}{$lname}\">{$disp_validate}</a>\n";
		elseif(isset($css[$ext])) echo "\t\t\t\t<a href=\"{$css_validator}{$w3c}{$dir}{$lname}\">{$disp_validate}</a>\n";

		if(isset($mp3[$ext]) && file_exists('i/player.swf')) {
		  	if(isset($_GET['play']) && $current) echo "\t\t\t\t<object type=\"application/x-shockwave-flash\" data=\"i/player.swf?song_url=".BASE_DIR."{$dir}{$lname}&amp;autoplay=true\" width=\"17\" height=\"17\"></object>\n";
			else echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;play=1\">{$disp_play}</a>\n";
	 	}

		if(isset($image[$ext])) echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;action=image\">{$disp_image}</a>\n";
		if(isset($download[$ext])) echo "\t\t\t\t<a href=\"?dir={$dir}&amp;file={$lname}&amp;download=1\">{$disp_download}</a>\n";

		if($search) echo "\t\t\t\t<a href=\"?dir={$dir}\">{$disp_open}</a>\n";

		echo "\t\t\t</td>\n";
		echo "\t\t\t<td class=\"right\">".date($date_format, filemtime(BASE_DIR.$dir.$name))."</td>\n";
		echo "\t\t</tr>";
		$x++;
	}

	echo "<tr class=\"title\">\n";
	echo "\t\t\t<td>&nbsp;</td>\n";
	echo "\t\t\t<td class=\"right\" colspan=\"3\">{$count} ".$lang_mng['mng_cnt25']." - ".count($dirs)." ".$lang_mng['mng_cnt26']." - ".count($files)." ".$lang_mng['mng_cnt27']." - ".getSize($total)."</td>\n";
	echo "\t\t</tr>\n";
	echo "\t</table>\n";
	echo "</div>";
	if($checkboxes) "</form>";
	echo "\n";
}
?>
</body>
</html>
