<?php
/**
 * This Class module provides the DB interface of the
 * jrCMS core (usable in plugins as well).
 * The class definition is empty, which means all methods/functions 
 * are derived. The class is used as switch between different
 * implementations of databases like MySQL or MsSQL 
 *
 * Conventions:
 * ===========
 * a) Structure
 *		+---------------------+
 *		|    Application      |
 *		|(called via Ajax/JS) |
 *		+---------------------+
 *							V
 *		+---------------------+
 *		|  Application Class  |
 *		+---------------------+
 *							V
 *		+---------------------+
 *		|  DB Interface Class |
 *		|(MySQL/MsSQL Switch) |
 *		+---------------------+
 *							V
 *		+---------------------+
 *		|   SQL Query Class   |
 *		+---------------------+
 *							V
 *		+---------------------+
 *		|    DB Driver Class  |
 *		+---------------------+
 *
 * b) Each following Class will have an Interface Class
 *
 * @package jrCMS: DB interface
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: cDbInterface.php 607 2011-09-20 05:58:51Z jensraabe $ 
 * 
 * @copyright Copyright (c) 2011, Jens Raabe
 * license: MIT-style license, see jrcms.js
 */
  
	if (CONFIG::dbms == 'mysql') {
		class DBInterface extends MySQL_Queries{
			//empty Definition, all methods/functions derived
		}
	} else {
		class DBInterface extends MsSql_Queries{
			// empty definition
		}
	}
?>