<?php
/**
 * This Class module provides all functions needed for help functionality
 * 
 * @package: JRCMS
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @version $Id: cJrcmsHelp.php 607 2011-09-20 05:58:51Z jensraabe $
 *
 * @copyright Copyright (c) 2010, Jens Raabe (MIT)
 * license: MIT-style license, see jrcms.js
 */

require_once($_SERVER['DOCUMENT_ROOT'].CONFIG::srcPath.'/src/'.'iJrcmsHelp.php');

/**
 * @class JRHELP
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @copyright Copyright (c) 2010, Jens Raabe (MIT)
 */ 
//class JRCMSHELP implements iJrCmsHelp{
class JRCMSHELP extends JRCMS implements iJrcmsHelp{
	
	CONST VERSION			= '$Revision: 607 $';
	CONST AUTHOR			= 'Jens Raabe';
	CONST PACKAGE			= 'jrCMS';
	CONST LAST_CH			= '$Date: 2011-09-20 07:58:51 +0200 (Di, 20 Sep 2011) $';

	// do nothing at start
	public function __construct(){
		
	}

// ------------------------------
// Utilities
// ------------------------------
	

	private function read_help_file($filepath, $filename) {
		
		$filename = $filepath.'/'.$filename;
		
		if (floatval(phpversion()) >= 4.3) {
        	$fData = file_get_contents($filename);
    	} else {
        	if (!file_exists($filename)) return False; //-3
        	$handle = fopen($filename, 'r');
        	if (!$handle) return False;	//-2

        	$fData = '';
        	while(!feof($handle))
            	$fData .= fread($handle, filesize($filename));
        	fclose($handle);
    	}
        	
    	return $fData;
	}	
	
// ------------------------------

	private function save_help_file($filepath, $filename, $cnt) {
		
		$filename = $filepath.'/'.$filename;
		
		if (floatval(phpversion()) >= 4.3) {
        	$fData = file_put_contents($filename, $cnt);
    	}else {
        	$handle = fopen($filename, 'w');
        	if (!$handle) return False;	//-2
			if (!fwrite($handle, $cnt)) return False;
        	fclose($handle);
    	}
    	return True;
	}	

// ------------------------------
	
	private function get_plugin_help_text_xml($plugin) {
		
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['ul'])) {$ul = $_GET['ul'];} else {if(isset($_POST['ul'])) {$ul = $_POST['ul'];} else {$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');}}
		$sb = null;
		
		//build the path
		$rp = $_SERVER['DOCUMENT_ROOT'].$_SESSION["srcPath"].'/src/plugins/'.strtolower($plugin).'/help';
		//determine the filename (language)
		$fn = strtolower($plugin).'.'.$_SESSION["language"].'.html';

		//read the file content
		if(($cnt = $this->read_help_file($rp, $fn)) !== False) {
			$cnt = utf8_decode($cnt);
			if ($this->write_access($id, $ul, 'write', CONFIG::webmasterLevel)) {
				//provide the retrieved content with buttons
				$sb = $this->conv_task_html('std',
						array(3 => "jrCMS.saveHelpDoc({plugin:'".$plugin."', a:'saveHelpDoc'});return false;"));
				//build up the xinha area		
				//TODO: deactivate the save button of xinha
				$cnt = 	'<form id="to_submit" name="to_submit" method="post" action="">'.
						'<textarea id="myXinhaTextarea" name="myXinhaTextarea" rows="0" cols="0" style="width: 100%">'.
						$cnt.
						'<input type="hidden" name="plugin" id="plugin" value="'.$plugin.'">'.
						'<input type="hidden" name="a" id="a" value="save_help_doc">'.
						'</form>';
			}
		//provide at least a failure text
		} else {
			$cnt = '<script type="text/javascript">alert("No Help data available!");</script>';				
		}	
		return $this->resp_xml($this->resp_cont_xml($cnt,$sb,NULL));
			
	}	
		
// ------------------------------
	
	private function save_plugin_help_text($plugin) {
		
		global $lang_php;
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['ul'])) {$ul = $_GET['ul'];} else {if(isset($_POST['ul'])) {$ul = $_POST['ul'];} else {$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');}}
		if(isset($_POST['cont'])) {$cnt = $_POST['cont'];} else {$cnt=NULL;}
		
		//build the path
		$rp = $_SERVER['DOCUMENT_ROOT'].$_SESSION["srcPath"].'/src/plugins/'.strtolower($plugin).'/help';
		//determine the filename (language)
		$fn = strtolower($plugin).'.'.$_SESSION["language"].'.html';

		//write the file content
		if(($result = $this->save_help_file($rp, $fn, str_replace('%#', '&#', $cnt))) !== False) {
				return '<script type="text/javascript">var check = "saved"; alert("'.$lang_php['data_updated'].'");</script>';
		} else {
				return '<script type="text/javascript">var check = failure; alert("'.$lang_php['data_update_failure'].'");</script>';
		}
	}
	
// ------------------------------
	
	public function get_help_doc() {
		
		if(isset($_GET['plugin'])) {$plugin = $_GET['plugin'];} else {if(isset($_POST['plugin'])) {$plugin = $_POST['plugin'];} else {$plugin=NULL;}}
		
		if(isset($plugin)) return $this->get_plugin_help_text_xml($plugin);
		
	}
	
// ------------------------------
	
	public function save_help_doc() {
		
		if(isset($_GET['plugin'])) {$plugin = $_GET['plugin'];} else {if(isset($_POST['plugin'])) {$plugin = $_POST['plugin'];} else {$plugin=NULL;}}
		
		if(isset($plugin)) return $this->save_plugin_help_text($plugin);
		
	}
	
}
?>