<?php
/**
 * This interface class module ensures the correct usage of the
 * jrcms core functions
 *
 * @package jrCMS: JRCMS
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: iJrcms.php 607 2011-09-20 05:58:51Z jensraabe $
 *  
 * @copyright Copyright (c) 2011, Jens Raabe
 * license: MIT-style license, see jrcms.js
 */

//defines all methods/functions to be provided by the class
interface iJrcms {

	public function resp_xml($contArray, $menuArray=NULL, $stylesArray=NULL);
	public function array_to_xml($dataset);
	public function resp_cont_xml($contHtml, $ctrlHtml=NULL, $rightContHtml=NULL, $dataArray=NULL);
	public function resp_menu_xmlelem($menuHtml, $menuDiv='divVMenu');
	public function resp_styles_xmlelem($cssData);
	public function conv_task_html($selTaskList, $taskActions = Null, $taskType = 'icon', $iconpath = NULL);
	public function conv_tasks($taskList, $taskActions = Null, $taskType = 'icon', $iconpath = NULL);
	public function get_menu($rspType = 'html', $menuDiv = NULL, $divHMenu = False);
	public function get_menu_ids();
	public function get_content($rspType = 'html', $loadEditor=False);
	public function get_content_for_node($act=NULL);
	public function get_raw_content_data($id, $sel=NULL);
	public function get_right_content_html();
//	public function save_content();
	public function get_styles();
	public function get_login_logout_html($act=NULL);
	public function perf_login();
	public function perf_logout();
	public function set_password_perf_login();
	public function get_userlevel();
	public function get_lang();
	public function set_lang();
	public function get_language_file();
	public function backup();
	public function pre_load_images();
	public function update_xtp_table();
	public function get_about();
	public function dialog_element($valueName, $value, $valueGroup='set', $valueDialogMethod = 'input', $valueValidator = 'required');
	public function dialog_header($refName, $value, $action=Null);

//	public function get_user($uid = -1, $ul_only = NULL, $start = NULL, $limit = 1, $filter = NULL);
//	public function get_user_no();
//	public function insert_user($name, $pass, $ul = '000');
//	public function update_user($uid, $name = NULL, $pass = NULL, $ul = NULL);
//	public function del_user($uid);
////	public function get_user_id($name);
////	public function login($name, $pass);
////	public function logout();
//	public function logged_in();
//	public function get_userlevels($is_user=True);
////	public function get_userlevel_role($ul);
////	public function get_user_timestamp();
////	public function set_user_timestamp();
////	public function clean_user_sessions($username=NULL);
}
?>