<?php
/**
 * This interface class module ensures the correct usage of the
 * jrcms API
 *
 * @package jrCMS: Class JRCMSAPI
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: iJrcmsApi.php 607 2011-09-20 05:58:51Z jensraabe $
 *  
 * @copyright Copyright (c) 2011, Jens Raabe
 * license: MIT-style license, see jrcms.js
 */

//defines all methods/functions to be provided by the class
interface iJrcmsApi {
	
	public function array2Xml($dataset);
	public function convertTaskList($selTaskList, $taskActions = Null, $taskType = 'icon', $iconpath = NULL);
	public function convertOwnTaskList($taskList, $taskActions = Null, $taskType = 'icon', $iconpath = NULL, $nodeId = NULL);
	public function getContent($rspType = 'html', $loadEditor=False);
	public function getRawContentData($id, $sel=NULL);
	public function updateContent($id, $content, $cid);
	public function getRightContent();
	public function getContentAndButtons($contHtml, $ctrlHtml=NULL, $rightContHtml=NULL, $dataArray=NULL);
	public function getLanguage();	
	public function getMenu($rspType='html', $menuDiv=NULL, $divHMenu = False);
	public function getOwnMenu($menuHtml, $menuDiv='divVMenu');
	public function getMenuRoot($menuDiv, $label);
	public function getMessageContainer($contArray, $menuArray=NULL, $stylesArray=NULL);
	public function getStyles();
	public function getUserlevel();
	public function getUserlevelList();
	public function getUser($uid, $start = NULL, $limit = 1, $filter=NULL, $ul_only = NULL);
	public function getUserList($start = NULL, $limit = 1, $filter=NULL);
	public function getUserNumber($filter=NULL);
	public function insertUser($name, $pass, $ul = NULL);
	public function updateUser($uid, $name = NULL, $pass = NULL, $ul = NULL);
	public function deleteUser($uid);
	public function isUserLoggedIn();
	public function insertMenuItem($label,$parentLabel,$menuDiv,$xtp);
	public function insertProcedure($procName, $classId, $type, $comment=NULL);
	public function getLoginLogoutHtml($act=NULL);
	public function sqlQS($value, $type);									//utiliy to quote strings
	public function getSingleValueFromDb($columns = NULL, $tables = NULL, $where = "1", $ext = NULL, $debug=NULL);
	public function insertSingleValueInDb($table = NULL, $columns = NULL, $values = NULL, $insertId = False, $debug=NULL);
	public function insertPostedValuesInDb($table = NULL, $numValueArr = NULL, $insertId = False, $debug=NULL);
	public function replaceSingleValueInDb($table = NULL, $columns = NULL, $values = NULL, $insertId = False);
	public function updateSingleValueOfDb($tables = NULL, $values=NULL, $where = "1", $ext = NULL);
	public function deleteSingleValueOfDb($columns="*", $tables = NULL, $where = "1", $ext = NULL);
	public function getArrayFromDb($columns = NULL, $tables = NULL, $where = "1", $start = NULL, $rows = NULL, $id = NULL, $ext = NULL, $debug=NULL);
	public function createTable($table, $columns, $type='MyISAM');
	public function alterTable($table, $columns);
	public function checkTable($table);
	public function checkAccessRight($id, $ul, $acc='read', $ulOfNode=NULL, $aclSel=NULL);
	public function getAccesslevelList();
	public function ctcReserveTable($table, $eId);
	public function ctcLockTable($table, $eId);
	public function ctcCheckAndLockTable($table, $eId);
	public function ctcUnlockTable($table, $eId);
	public function dialogElement($valueName, $value, $valueGroup='set', $valueDialogMethod = 'input', $valueValidator = 'none');
	public function dialogHeader($refName, $value, $action=Null);	
}
?>