<?php
/**
 * This interface class module ensures the correct usage of different
 * menu classes as well as access to methods
 *
 * @package jrCMS: Class MENU
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: iMenu.php 607 2011-09-20 05:58:51Z jensraabe $
 *  
 * @copyright Copyright (c) 2011, Jens Raabe
 * license: MIT-style license, see jrcms.js
 */

//defines all methods/functions to be provided by the class
interface iMenu {

	public function get_proc_types_and_procs($userlevel='000', $type=NULL);
	public function insert_procedure($procName, $classId, $type, $comment=NULL);
	public function get_ulevel_of_node($id);
	public function write_access($id, $ul, $acc='read', $ulOfNode=NULL, $aclSel=NULL);
	public function get_menu_brunch($brunchId=-1, $menuDiv=NULL, $rootId=NULL, $userlevel=NULL, $getRoot=FALSE);
	public function get_menu_html($brunchId = -1, $menuDiv = 'div', $rootId = NULL, $userlevel = NULL, $cmpMode = false);
	public function get_menu_item_data($id, $label=NULL, $menuDiv = 'div', $userLevel = '000');
	public function get_menu_root($menuDiv='div', $id = NULL, $label = NULL);
	public function get_menu_parent_id($id, $menuDiv);
	public function get_menu_path_html($id, $menuDiv);
	public function insert_menu_root($rootId = 0, $menuDiv='div');
	public function insert_menu_node($nodeName, $parentId = NULL, $rootId = 0, $menuDiv='div');
	public function insert_menu_item($label, $parentLabel, $menuDiv = NULL, $subdivs = NULL, $xtp = NULL);
	public function insert_sub_menu_root($menuDiv, $rootId, $subdivs = NULL);
	public function delete_menu_node($id, $rootId, $menuDiv = NULL);
	public function move_menu_node($id, $rootId=NULL, $menuDiv=NULL, $direction);
	public function update_menu_node($id, $rootId = NULL, $menuDiv = NULL, $ul = NULL, $label = NULL, $xtpId = NULL );
	public function get_menu_node_content($id = -1, $sel = NULL);
	public function update_menu_node_content($id, $content=NULL);
	public function get_menu_style_id($id);
	public function get_content_html($id, $ul, $loadEditor=False);
	public function updateContentHtml($id, $content, $cid);
	public function get_std_tasks_html($id, $ul, $showEditorTask = False);
	public function get_menu_styles_html($id);   //Deprecated
	public function get_style_data($cssid);
	public function insert_style_data($cssd=NULL, $mkey=NULL, $mdesc=NULL);
	public function update_style_data($cssid, $cssd=NULL, $mkey=NULL, $mdesc=NULL);
	public function get_special_action_data($said);
	public function insert_special_action_data($sact=NULL);
	public function update_special_action_data($said, $sact=NULL);
	
	public function get_user($uid = -1, $ul_only = NULL, $start = NULL, $limit = 1, $filter = NULL);
	public function get_user_no();
	public function insert_user($name, $pass, $ul = '000');
	public function update_user($uid, $name = NULL, $pass = NULL, $ul = NULL);
	public function del_user($uid);
	public function get_user_id($name);
	public function login($name, $pass);
	public function logout();
	public function logged_in();
	public function get_userlevels($is_user = True);
	public function get_userlevel_role($ul);
//	public function get_user_timestamp();
//	public function set_user_timestamp();
	public function clean_user_sessions($username=NULL);

}
?>