<?php
/**
 * This interface class module ensures the correct usage of different
 * driver classes
 *
 * @package jrCMS: SQL Driver
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: iSqlDriver.php 374 2010-11-14 19:16:15Z jensraabe $ 
 *
 * @copyright Copyright (c) 2008,2009 Jens Raabe
 * license: MIT-style license, see jrcms.js
 */

//defines all methods/functions to be provided by the class
interface iSql_Driver {

	public function sql_qs($value, $type);									//utiliy to quote strings
	public function db_bind();
	public function db_query($qstring, $count = '', $update = '');
	public function db_num_rows($qstring);
	public function db_affected_rows($qstring); 					//replaces db_update()
	public function db_result($qquery, $count = FALSE);
	public function db_insert($insert_string, $lastID = NULL);
	public function db_backup(); 													//replaces backupDB()
	public function db_run_stored_procedure($sp = NULL, $param_list = null);
	public function db_get_error();

}
?>