<?php
/**
 * This interface class module ensures the correct usage of different
 * query classes
 *
 * @package jrCMS: SQL Driver
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: iSqlQueries.php 561 2011-07-25 08:32:14Z ctna0371 $ 
 *
 * @copyright Copyright (c) 2008,2009, Jens Raabe
 * license: MIT-style license, see jrcms.js
 */

//defines all methods/functions to be provided by the class
interface iSql_Queries {

	public function show_tables_sql($suffix = NULL);
	public function check_table($sql_table);
	public function check_column($sql_table, $column);
	public function get_array($columns = NULL, $tables = NULL, $where = "1", $start = NULL, $rows = NULL, $id = NULL, $ext = NULL, $distinct = False, $debug = NULL);
	public function get_single_value($column = NULL, $tables = NULL, $where = "1", $ext = NULL, $distinct = False, $debug=NULL);
	public function create_table($table = NULL, $columns = NULL, $type='MyISAM');
	public function alter_table($table = NULL, $columns = NULL);
	public function insert($table = NULL, $columns = NULL, $values = NULL, $insertId = False, $debug=NULL);
	public function replace($table = NULL, $columns = NULL, $values = NULL, $insertId = False);
	public function update_single_value($tables = NULL, $values=NULL, $where = "1", $ext = NULL);
	public function delete_single_value($columns = "*", $tables = NULL, $where = "1", $ext = NULL);
	public function get_menu_tree_array($rootID=NULL, $userLevel=NULL, $menuDiv=NULL, $brunchID=NULL, $getRoot=False);
	public function get_menu_item_ids($label, $userLevel='000', $menuDiv='divVMenu');
	public function ctc_reserve_table($table, $eId);
	public function ctc_lock_table($table, $eId, $accType='locked');
	public function ctc_check_table($table, $eId);		
	public function ctc_unlock_table($table, $eId);
	public function ctc_clean_table($UserSession=NULL);
	public function run_stored_proc($spName, $params=NULL);
}
?>