<?php
/**
 * This module processes all tasks regarding Menu and User
 *
 * @package jrCMS
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: jrcms.php 607 2011-09-20 05:58:51Z jensraabe $ 
 * 
 * @copyright Copyright (c) 2011 Jens Raabe
 * license: MIT-style license, see jrcms.js
 */
 
// set some headers values
header("Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . " GMT" ); 
header("Content-Type: text/plain; charset=utf-8");
header("Connection: close");
// set header
session_cache_limiter( 'nocache' ); //Expires, Cache-Control, Pragma
// start session
session_start(); 
// usage of classes
require_once('../conf/cConfig.php');
CONFIG::loadLanguage();
CONFIG::loadClasses();
CONFIG::loadScripts();
// retrieve parameter
if(isset($_GET['a'])) {$act = $_GET['a'];} else {if(isset($_POST['a'])) {$act = $_POST['a'];} else {$act=NULL;}}
$j = new JRCMS();
$api = new JRCMSAPI();

// ############## MAIN ##############

if (isset($act)) {
	switch ($act) {
	case "gacnt":
		// get content as Html string, used for preview tasks
		$e = $api->getMessageContainer($api->getContent('xml',False));
		break;
	case "getcnt":
	case "getcntEditor":
		// get content, menu and css as XML
		$e = $api->getMessageContainer($api->getContent('xml',($act == "getcntEditor"))
										,$api->getMenu('xml')
										,$api->getStyles());
		break;
	case "getcntNode":
		// get content, menu and css as XML
		$e = $j->get_content_for_node($act);
		break;
//	case "sacnt":
//		// save content and provide saved content as Html
//		$e = $j->save_content();
//		break;
	case "getMnuId":
		//get special menu id content ###DEPRICATED##
		$e = $j->get_menu_ids();
		break;
	case "gacss":
		//get css and additional data
		$e= $api->getStyles();
		break;
	case "backup":
		// backup the whole DB
		$e = $j->backup();
		break;
	case "chgpw":
	case "gin":
	case "gindiv":
		// get login mask
		$e = $j->get_login_logout_html($act);
		break;
	case "in":
		// login
		$e = $j->perf_login();
		break;
	case "out":
		//logout
		$e = $j->perf_logout();
		break;
	case "supw":
		//login and change PW
		$e = $j->set_password_perf_login();
		break;
	case "setLang":
		//set language XML
		$e = $j->set_lang();
		$e = '';
		break;
	case "pldimg":
		//preload images XML
		$e = $j->pre_load_images();
		break;
	case "updateXtpTable":
		//preload images
		$e = $j->update_xtp_table();
		break;
	case "getAbout":
		//retrieve the about text
		$e = $j->get_about();
		break;
	case "getLangFile":
		//retrieve the language file for js
		$e = $j->get_language_file();
		break;		
	case "getHelpDoc":
		//retrieve an help file
		$h = new JRCMSHELP();
		$e = $h->get_help_doc();
		$h = NULL;
		break;
	case "saveHelpDoc":
		//retrieve an help file
		$h = new JRCMSHELP();
		$e = $h->save_help_doc();
		$h = NULL;
		break;
	default: 
		print_r("jrcms.php with wrong action called!!");
	}

} else {

	print_r("jrcms.php with wrong parameter called!!");
	
}
$j = NULL;
//sleep(2); // for simulation only
echo $e;
flush(); // send really out all stuff
?>