<?php
/**
 * This module initializes a basic setup of menu
 *
 * @package jrCMS
 * @author Clemens Schultz
 * @version $Id: jrcmsinit.php 607 2011-09-20 05:58:51Z jensraabe $
 *  
 * @copyright Copyright (c) 2011 Jens Raabe & Clemens Schultz
 * license: MIT-style license, see jrcms.js
 */

function init_tbl_cnt($table) {
	$query = new DBInterface();
	if($query->show_tables_sql($table) === FALSE) {
		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name' => 'cid', 'type' => 'int', 'null' => FALSE,	'auto_inc' => TRUE,
				'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'content ID');
		$columns[1] = array('name' => 'content', 'type' => 'text', 'null' => TRUE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'content as link or HTML');

		if (($result = $query->create_table($table, $columns)) !== FALSE) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "content", "'<center><h1>&nbsp;</h1><p><br />Please use the menu.</p></center>'", FALSE);
			$result &= $query->insert($table, "content", "'<h1>That&#39;s a start page</h1>'", FALSE);
			$result &= $query->insert($table, "content", "'./content/empty.html'", FALSE);
			$result &= $query->insert($table, "content", "'none'", FALSE);
			$result &= $query->insert($table, "content", "'none'", FALSE);
			$result &= $query->insert($table, "content", "'./src/assets/mng/mng.php'", FALSE);
			$result &= $query->insert($table, "content", "'<h2>Default Menu entries</h2>useable outside of the menu structure'", FALSE);
			$result &= $query->insert($table, "content", "'<h2>(german) Impressum</h2>\r\n<p align=justify></p>\r\n<table cellspacing=0 cellpadding=0 border=0>
			\r\n<tbody>\r\n<tr>\r\n<td align=left width=200 valign=top>jrCMS<br /><br />Berlin</td>\r\n<td align=left valign=top>Email: webmaster 
			<a href=mailto:webmaster@raabe-berlin.de><img border=0 src=src/images/mail.gif alt=Mail /></a><br />Internet: www.raabe-berlin.de</td>\r\n
			</tr>\r\n<tr>\r\n<td height=20 colspan=2><img height=19 width=19 src=src/images/spacer.gif /></td>\r\n</tr>\r\n<tr>\r\n<td align=left valign=top>
			Gestaltung:</td> \r\n<td align=left valign=top><a href=http://www.raabe-berlin.de/>Jens Raabe</a>, Berlin</td>\r\n</tr>\r\n<tr> \r\n
			<td align=left valign=top>Techn. Umsetzung: </td> \r\n<td align=left valign=top><a href=http://www.raabe-berlin.de/>Jens Raabe</a>, Berlin
			</td> \r\n</tr> \r\n</tbody> \r\n  </table> \r\n  <p><strong>Haftungsausschluss</strong>:</p> \r\n  <p><u>Haftung f&#252;r Inhalte</u><br />
			</p>\r\n<div align=justify>Die Inhalte unserer Seiten wurden mit gr&#246;&#223;ter Sorgfalt erstellt. F&#252;r die Richtigkeit,
			Vollst&#228;ndigkeit und Aktualit&#228;t der Inhalte k&#246;nnen wir jedoch keine Gew&#228;hr &#252;bernehmen.<br />Als Diensteanbieter
			sind wir gem&#228;&#223; &#167; 7 Abs.1 TMG f&#252;r eigene Inhalte auf diesen Seiten nach den allgemeinen Gesetzen verantwortlich. 
			Nach &#167;&#167; 8 bis 10 TMG sind wir als Diensteanbieter jedoch nicht verpflichtet, &#252;bermittelte oder gespeicherte fremde Informationen 
			zu &#252;berwachen oder nach Umst&#228;nden zu forschen, die auf eine rechtswidrige T&#228;tigkeit hinweisen. Verpflichtungen zur Entfernung 
			oder Sperrung der Nutzung von Informationen nach den allgemeinen Gesetzen bleiben hiervon unber&#252;hrt. Eine diesbez&#252;gliche Haftung 
			ist jedoch erst ab dem Zeitpunkt der Kenntnis einer konkreten Rechtsverletzung m&#246;glich. Bei bekannt werden von entsprechenden 
			Rechtsverletzungen werden wir diese Inhalte umgehend entfernen.<br /></div> \r\n  <p><br /><u>Haftung f&#252;r Links</u><br /></p> \r\n  
			<div align=justify>Unser Angebot enth&#228;lt Links zu externen Webseiten Dritter, auf deren Inhalte wir keinen Einfluss haben. Deshalb 
			k&#246;nnen wir f&#252;r diese fremden Inhalte auch keine Gew&#228;hr &#252;bernehmen. F&#252;r die Inhalte der verlinkten Seiten ist 
			stets der jeweilige Anbieter oder Betreiber der Seiten verantwortlich. Die verlinkten Seiten wurden zum Zeitpunkt der Verlinkung auf 
			m&#246;gliche Rechtsverst&#246;&#223;e &#252;berpr&#252;ft. Rechtswidrige Inhalte waren zum Zeitpunkt der Verlinkung nicht erkennbar. Eine 
			permanente inhaltliche Kontrolle der verlinkten Seiten ist jedoch ohne konkrete Anhaltspunkte einer Rechtsverletzung nicht zumutbar. Bei 
			bekannt werden von Rechtsverletzungen werden wir derartige Links umgehend entfernen.<br /></div> \r\n  <p><br /><u>Urheberrecht</u><br />
			</p> \r\n  <div align=justify>Die durch die Seitenbetreiber erstellten Inhalte und Werke auf diesen Seiten unterliegen dem deutschen 
			Urheberrecht. Beitr&#228;ge Dritter sind als solche gekennzeichnet. Die Vervielf&#228;ltigung, Bearbeitung, Verbreitung und jede Art der 
			Verwertung au&#223;erhalb der Grenzen des Urheberrechtes bed&#252;rfen der schriftlichen Zustimmung des jeweiligen Autors bzw. Erstellers. 
			Downloads und Kopien dieser Seite sind nur f&#252;r den privaten, nicht kommerziellen Gebrauch gestattet.<br />Die Betreiber der Seiten sind 
			bem&#252;ht, stets die Urheberrechte anderer zu beachten bzw. auf selbst erstellte sowie lizenzfreie Werke zur&#252;ckzugreifen.<br />
			</div> \r\n  <p><br /><u>Datenschutz</u><br /></p> \r\n  <div align=justify>Soweit auf unseren Seiten personenbezogene Daten (beispielsweise 
			Name, Anschrift oder eMail&#45;Adressen) erhoben werden, erfolgt dies soweit m&#246;glich stets auf freiwilliger Basis. Die Nutzung der 
			Angebote und Dienste ist, soweit m&#246;glich, stets ohne Angabe personenbezogener Daten m&#246;glich.<br />Wir weisen darauf hin, dass die 
			Daten&#252;bertragung im Internet (z.B. bei der Kommunikation per E&#45;Mail) Sicherheitsl&#252;cken aufweisen kann. Ein l&#252;ckenloser 
			Schutz der Daten vor dem Zugriff durch Dritte ist nicht m&#246;glich.<br />Der Nutzung von im Rahmen der Impressumspflicht ver&#246;ffentlichten 
			Kontaktdaten durch Dritte zur &#220;bersendung von nicht ausdr&#252;cklich angeforderter Werbung und Informationsmaterialien wird 
			hiermit ausdr&#252;cklich widersprochen. Die Betreiber der Seiten behalten sich ausdr&#252;cklich rechtliche Schritte im Falle der 
			unverlangten Zusendung von Werbeinformationen, etwa durch Spam&#45;Mails, vor.<br /></div> \r\n  <p><br />Quelle: eRecht24.de &#45; 
			Rechtsberatung von Anwalt S&#246;ren Siebert<br /></p>'", FALSE);
			$result &= $query->insert($table, "content", "'<h2>Contact</h2><p></p>Email: webmaster <a href=mailto:webmaster@raabe-berlin.de><img border=0 src=src/images/mail.gif alt=Mail /></a><br />Internet: www.raabe-berlin.de'", FALSE);
			$result &= $query->insert($table, "content", "'<h2>Contact</h2><p></p>Email: webmaster <a href=mailto:webmaster@raabe-berlin.de><img border=0 src=src/images/mail.gif alt=Mail /></a><br />Internet: www.raabe-berlin.de'", FALSE);
			$result &= $query->insert($table, "content", "'sitemap.html'", FALSE);
			$result &= $query->insert($table, "content", "'Styles have to be maintained in DB directly'", FALSE);
			
			return $result;
		} else
			return FALSE; // create_table() failed
	} else
		return TRUE; // table allready exists
}

function init_tbl_gData($table) {
	$query = new DBInterface();
	
	if($query->show_tables_sql($table) === FALSE) {

		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name' => 'gid', 'type' => 'int', 'null' => FALSE, 'auto_inc'=> TRUE,
			'key' => TRUE, 'unique' => FALSE, 'default'	=> NULL, 'comment' => 'ID');
		$columns[1] = array('name' => 'lang', 'type' => 'varchar(3)', 'null' => FALSE, 'auto_inc' => FALSE,
		   'key' => FALSE, 'unique' => FALSE, 'default' => 'en', 'comment' => 'language');
		$columns[2] = array('name' => 'htaccess', 'type' => 'text', 'null' => TRUE, 'auto_inc' => FALSE,
		   'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'htaccess');
		$columns[3] = array('name' => 'about', 'type' => 'text', 'null' => TRUE, 'auto_inc' => FALSE,
			'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'copyright notices');
		$columns[4] = array('name' => 'version', 'type' => 'varchar(15)', 'null' => FALSE, 'auto_inc' => FALSE, 
			'unique' => TRUE, 'default' => 'V0.3.0', 'comment' => 'Version of imacs DB schema');
		$columns[5] = array('name' => 'getUserProf', 'type' => 'varchar(120)', 'null' => TRUE, 'auto_inc' => FALSE, 
			'unique' => FALSE, 'default' => Null, 'comment' => 'Interface for User Profile Data');
		$columns[6] = array('name' => 'getUserProfSrc', 'type' => 'varchar(240)', 'null' => TRUE, 'auto_inc' => FALSE, 
			'unique' => FALSE, 'default' => Null, 'comment' => 'filename of Interface for User Profile Data');
		
		if (($result = $query->create_table($table, $columns)) !== FALSE) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "lang, htaccess, about", "'de', '# kein stoebern im Verzeichnis\nOptions -Indexes\n # HTML fr individuelle Fehleranzeige\n ErrorDocument 404 <html><head><title>Seite nicht vorhanden</title></head><body>\n <h1>Fehler 404</h1>\n <p>Die angeforderte URL kann nicht gefunden werden.</p>\n <p>Probieren Sie es bitte erneut mit einem Aufruf der\n <a href=\"".CONFIG::protocol.'://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath."\">Testpage</a></p>\n </body></html>',
			'<h1 class=\"about\">imacs</h1><p class=\"about\">The <b>i</b>nnovative <b>Ma</b>nagement of <b>C</b>ontent<b>s</b> web application is powered by the open source
			project <b>imacs</b> which is a light Content Management System on base of the mootools frame. The plugin concept provides several functions
			like as the web editor Xinha and could be enhanced by own plugins as well.</p>
			<p class=\"about\">The <b>imacs</b> is available under MIT license, with only one restriction to have a copy right notice to the <b>imacs</b> project
			on top of you application and/or using the about function of the core.</p>'",FALSE);
			
			return $result;
		} else 
			return FALSE; // create_table() failed		
	} else 
		return TRUE; // table already exist
}

function init_tbl_menu($table) {
	global $lang_php;
	
	$query = new DBInterface();
	
	if($query->show_tables_sql($table) === FALSE) {

		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name'	=> 'id', 'type' => 'int', 'null' => FALSE, 'auto_inc' => TRUE, 
					'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'ID');
		$columns[1] = array('name' => 'parentId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE, 
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment' => 'id parent');
		$columns[2] = array('name'	=> 'rootId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'id of horizontal menu');
		$columns[3] = array('name'	=> 'label', 'type' => 'varchar(100)', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '', 'comment'	=> 'label');
		$columns[4] = array('name'	=> 'lft', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'left id');
		$columns[5] = array('name'	=> 'rgt', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'right id');
		$columns[6] = array('name'	=> 'htmlDiv', 'type' => 'varchar(16)', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => 'div', 'comment'	=> 'element of div');
		$columns[7] = array('name'	=> 'ulid', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'user level id');
		$columns[8] = array('name'	=> 'cssid', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'styles id');
		$columns[9] = array('name'	=> 'lang', 'type' => 'varchar(3)', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => 'en', 'comment'	=> 'Language');
		$columns[10] = array('name'	=> 'cid', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '1', 'comment'	=> 'contend id');
		$columns[11] = array('name'	=> 'xtpID', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '3', 'comment'	=> 'type proc id');
		$columns[12] = array('name'	=> 'said', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '1', 'comment'	=> 'special action id');
								
		if (($result = $query->create_table($table, $columns)) !== FALSE) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"0, 1, 'ROOT', 1, 6, 'divHMenu', 1, 0, '".CONFIG::lang."', 1, 1, 1", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"1, 1, 'Home', 2, 3, 'divHMenu', 9, 1, '".CONFIG::lang."', 1, 3, 1", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"1, 1, '".$lang_php['entry_page']."', 4, 5, 'divHMenu', 9, 2, '".CONFIG::lang."', 2, 3, 2", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"0, 3, 'ROOT', 1, 24, 'divVMenu', 1, 0, '".CONFIG::lang."', 1, 1, 1", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"0, 3, 'ROOT', 1, 2, 'divRMenu', 1, 0, '".CONFIG::lang."', 1, 1, 1", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"0, 3, 'ROOT', 1, 2, 'divRContent', 1, 0, '".CONFIG::lang."', 1, 1, 1", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"4, 3, '".$lang_php['maintenance']."', 2, 9, 'divVMenu', 4, 3, '".CONFIG::lang."', 3, 4, 3", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"7, 3, '".$lang_php['menu']."', 3, 4, 'divVMenu', 8, 4, '".CONFIG::lang."', 4, 5, 4", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"7, 3, '".$lang_php['u_user']."', 5, 6, 'divVMenu', 7, 5, '".CONFIG::lang."', 5, 7, 5", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"7, 3, '".$lang_php['file_mgm']."', 7, 8, 'divVMenu', 4, 6, '".CONFIG::lang."', 6, 1, 6", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"4, 3, '".$lang_php['options']."', 10, 21, 'divVMenu', 8, 7, '".CONFIG::lang."', 7, 3, 7", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"11, 3, '".$lang_php['impressum']."', 11, 12, 'divVMenu', 8, 8, '".CONFIG::lang."', 8, 3, 8", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"11, 3, '".$lang_php['contact']."', 13, 14, 'divVMenu', 8, 9, '".CONFIG::lang."', 9, 3, 9", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"11, 3, '".$lang_php['webmaster']."', 15, 16, 'divVMenu', 8, 10, '".CONFIG::lang."', 10, 3, 10", FALSE);
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"11, 3, '".$lang_php['sitemap']."', 17, 18, 'divVMenu', 8, 11, '".CONFIG::lang."', 11, 1, 11", FALSE);
//occupies two styles entries to be set in DB directly
			$result &= $query->insert($table, "parentId, rootId, label, lft, rgt, htmlDiv, ulid, cssid, lang, cid, xtpID, said",
				"11, 3, '".$lang_php['window_size']."', 19, 20, 'divVMenu', 8, 12, '".CONFIG::lang."', 12, 9, 12", FALSE);
//next free cssid = 14
			
			return $result;
		} else 
			return FALSE; // create_table() failed		
	} else 
		return TRUE; // table already exist
}

function init_tbl_proc($table) {
	$query = new DBInterface();
	
	if($query->show_tables_sql(CONFIG::sql_tbl_proc) === FALSE) {

		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name'	=> 'procId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => TRUE, 
					'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'procedure id');
		$columns[1] = array('name' => 'procName', 'type' => 'varchar(50)', 'null' => FALSE, 'auto_inc' => FALSE, 
					'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'procedure name');
		$columns[2] = array('name'	=> 'classId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'class id');
		$columns[3] = array('name'	=> 'comment', 'type' => 'varchar(120)', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'comment');

		if (($result = $query->create_table($table, $columns)) !== FALSE) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "procName, classId, comment",
															"'jrCMS.getContent', 1001, 'generic routine to process content (former: jrContent.get)'", FALSE);
			$result &= $query->insert($table, "procName, classId, comment",
															"'jrCMS.getContent', 1001, 'entry routine to process a menu item(former: jrMenu.get)'", FALSE);
			$result &= $query->insert($table, "procName, classId, comment",
															"'jrCmsMenu.getMenuContent', 2302, 'entry routine to maintain the menu'", FALSE);
			$result &= $query->insert($table, "procName, classId, comment",
															"'jrCMS.getLogin', 1004, 'login mask'", FALSE);
			$result &= $query->insert($table, "procName, classId, comment",
															"'jrCmsUser.getUserLst', 2501, 'entry routine to maintain a user'", FALSE);
			$result &= $query->insert($table, "procName, classId, comment",
															"'jrCMS.reloadPage', 1011, 'reload the page'", FALSE);
			$result &= $query->insert($table, "procName, classId, comment",
															"'jrCMS.chgWindowSize', 1013, 'Change Window Size'", FALSE);
			return $result;
		} else 
			return FALSE; // create_table() failed		
	} else 
		return TRUE; // table already exist
}

function init_tbl_pTypes($table) {
	$query = new DBInterface();
	
	if($query->show_tables_sql(CONFIG::sql_tbl_pTypes) === FALSE) {

		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name'	=> 'pTypId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => TRUE, 
					'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'procedure type id');
		$columns[1] = array('name' => 'type', 'type' => 'varchar(10)', 'null' => FALSE, 'auto_inc' => FALSE, 
					'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'type name');
		$columns[2] = array('name'	=> 'ulid', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'user level id');
		$columns[3] = array('name'	=> 'comment', 'type' => 'varchar(120)', 'null' => FALSE, 'auto_inc' => FALSE,
					'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment'	=> 'comment');
								
		if (($result = $query->create_table($table, $columns)) !== FALSE) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "type, ulid, comment",
															"'js', 4, 'call a classic java script routine'", FALSE);
			$result &= $query->insert($table, "type, ulid, comment",
															"'ajax', 1, 'call a java script for AJAX'", FALSE);
			$result &= $query->insert($table, "type, ulid, comment",
															"'apage', 1, 'call a java script for AJAX'", FALSE);
			$result &= $query->insert($table, "type, ulid, comment",
															"'alink', 1, 'call a java script for AJAX'", FALSE);
			$result &= $query->insert($table, "type, ulid, comment",
															"'aeditor', 1, 'call a java script for AJAX'", FALSE);
			return $result;
		} else 
			return FALSE; // create_table() failed		
	} else 
		return TRUE; // table already exist
}

function init_tbl_sact($table) {
	$query = new DBInterface();
	
	if($query->show_tables_sql($table) === FALSE) {
		
		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name' => 'said', 'type' => 'int', 'null' => FALSE,	'auto_inc' => TRUE,
				'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'special action ID');
		$columns[1] = array('name' => 'sact', 'type' => 'varchar(250)', 'null' => TRUE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'special action');

		if (($result = $query->create_table($table, $columns)) !== FALSE) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			$result &= $query->insert($table, "sact", "'none'", FALSE);
			
			return $result;
		} else 
			return FALSE; // create_table() failed		
	} else 
		return TRUE; // table already exist
}

function init_tbl_styles($table) {
	$query = new DBInterface();
	
	if($query->show_tables_sql($table) === FALSE) {
		
		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name' => 'cssid', 'type' => 'int', 'null' => FALSE,	'auto_inc' => TRUE,
				'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'styles ID');
		$columns[1] = array('name' => 'mnu_css', 'type' => 'text', 'null' => TRUE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'mnu_css');
		$columns[2] = array('name' => 'mkey', 'type' => 'varchar(250)', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'mnu_css');
		$columns[3] = array('name' => 'mdesc', 'type' => 'text', 'null' => TRUE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'mdesc');
		
		if ($result = $query->create_table($table, $columns)) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', 'Home', 'Home'", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', 'Entry Page', 'Entry Page'", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', 'Entry Page, Maintenance', 'Maintenance'", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', 'Entry Page, Maintenance, Menu', 'Maintenace of Menu'", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', 'Entry Page, Maintenance, User', 'User Maintenance'", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', 'Entry Page, Maintenance, File Manager', 'File Manager'", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', '', ''", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', '', ''", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', '', ''", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', '', ''", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'#divHeader{background-image: url(./images/prlheader.png);}', '', ''", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'.layout{width:1216px;}.col-right{width:982px;}.col-content-left{width:747px;}.col-footer{width:1212px;}#divWindowSize{background-image: url(./src/images/fullscreen-minimize.gif);}', 'Style switch', 'Window up'", FALSE);
			$result &= $query->insert($table, "mnu_css, mkey, mdesc",
				 "'.layout{width:931px;}.col-right{width:697px;}.col-content-left{width:462px;}.col-footer{width:927px;}#divWindowSize{background-image: url(./src/images/fullscreen-maximize.gif);}', 'Style switch', 'Window down'", FALSE);
			
			return $result;
		} else 
			return FALSE; // create_table() failed		
	} else 
		return TRUE; // table already exist
}

function init_tbl_user($table) {
	$query = new DBInterface();
	
	if($query->show_tables_sql($table) === FALSE) {
		
		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name' => 'uid', 'type' => 'int', 'null' => FALSE,	'auto_inc' => TRUE,
				'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'user ID');
		$columns[1] = array('name' => 'UserName', 'type' => 'varchar(30)', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => TRUE, 'default' => 'none', 'comment' => 'user name');
		$columns[2] = array('name' => 'UserPass', 'type' => 'varchar(32)', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'user pwd');
		$columns[3] = array('name' => 'UserSession', 'type' => 'varchar(32)', 'null' => TRUE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'session');
		$columns[4] = array('name' => 'ulid', 'type' => 'smallint', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment' => 'user level id');
				
		if ($result = $query->create_table($table, $columns)) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "UserName, UserPass, UserSession, ulid", "'member', '202cb962ac59075b964b07152d234b70', NULL, 2", FALSE);
			$result &= $query->insert($table, "UserName, UserPass, UserSession, ulid", "'coach', '202cb962ac59075b964b07152d234b70', NULL, 3", FALSE);
			$result &= $query->insert($table, "UserName, UserPass, UserSession, ulid", "'admin', '202cb962ac59075b964b07152d234b70', NULL, 6", FALSE);
			$result &= $query->insert($table, "UserName, UserPass, UserSession, ulid", "'webmaster', '202cb962ac59075b964b07152d234b70', NULL, 8", FALSE);
			
			return $result;
		} else 
			return FALSE; // create_table() failed
	} else 
		return TRUE; // table allready exists		// create empty table
}

function init_tbl_ul($table) {
	global $lang_php;
	$query = new DBInterface();
	
	if($query->show_tables_sql($table) === FALSE) {
		
		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name' => 'ulid', 'type' => 'int', 'null' => FALSE,	'auto_inc' => TRUE,
				'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'user level ID');
		$columns[1] = array('name' => 'ul', 'type' => 'varchar(3)', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment' => 'user level');
		$columns[2] = array('name' => 'description', 'type' => 'varchar(150)', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'description');
		$columns[3] = array('name' => 'is_user', 'type' => 'tinyint', 'null' => FALSE, 'auto_inc' => FALSE, 
				'key' => FALSE, 'unique' => FALSE, 'default' => 1, 'comment' => 'User level of user or elements');
		
		if (($result = $query->create_table($table, $columns)) !== FALSE) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "ul, description", "'000', '".$lang_php['us_generic_user']."'", FALSE);
			$result &= $query->insert($table, "ul, description", "'100', '100 (rwc) ".$lang_php['us_std_member']."'", FALSE);
			$result &= $query->insert($table, "ul, description", "'111', '111 (rwc) ".$lang_php['us_std_member'].", write'", FALSE);
			$result &= $query->insert($table, "ul, description", "'200', '200 (rwc) ".$lang_php['us_admin_1'].", no write access'", FALSE);
			$result &= $query->insert($table, "ul, description", "'222', '222 (rwc) ".$lang_php['us_admin_1'].", write access'", FALSE);
			$result &= $query->insert($table, "ul, description", "'300', '300 (rwc) ".$lang_php['us_admin_2'].", no write access'", FALSE);
			$result &= $query->insert($table, "ul, description", "'333', '333 (rwc) ".$lang_php['us_admin_2'].", write access'", FALSE);
			$result &= $query->insert($table, "ul, description", "'".CONFIG::webmasterLevel."', '".CONFIG::webmasterLevel." (rwc) ".$lang_php['webmaster']."'", FALSE);
			$result &= $query->insert($table, "ul, description", "'0".substr(CONFIG::webmasterLevel,1)."', '0".substr(CONFIG::webmasterLevel,1)." (rwc) ".$lang_php['webmaster']." write, read all'", FALSE);
			$result &= $query->insert($table, "ul, description", "'1".substr(CONFIG::webmasterLevel,1)."', '1".substr(CONFIG::webmasterLevel,1)." (rwc) ".$lang_php['webmaster']." write, read ".$lang_php['us_std_member']."'", FALSE);
			$result &= $query->insert($table, "ul, description", "'2".substr(CONFIG::webmasterLevel,1)."', '2".substr(CONFIG::webmasterLevel,1)." (rwc) ".$lang_php['webmaster']." write, read ".$lang_php['us_admin_1']."'", FALSE);
			$result &= $query->insert($table, "ul, description", "'3".substr(CONFIG::webmasterLevel,1)."', '3".substr(CONFIG::webmasterLevel,1)." (rwc) ".$lang_php['webmaster']." write, read ".$lang_php['us_admin_2']."'", FALSE);
			
			return $result;
		} else 
			return FALSE; // create_table() failed		
	} else 
		return TRUE; // table already exist
}

function init_tbl_xTP($table) {
	$query = new DBInterface();
	
	if($query->show_tables_sql($table) === FALSE) {
		
		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name' => 'xtpID', 'type' => 'int', 'null' => FALSE,	'auto_inc' => TRUE,
				'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'xtpID');
		$columns[1] = array('name' => 'pTypId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => '5', 'comment' => 'pTypId');
		$columns[2] = array('name' => 'procId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => '1', 'comment' => 'procId');
		$columns[3] = array('name' => 'comment', 'type' => 'varchar(120)', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => '5', 'comment' => 'comment');
		
		if (($result = $query->create_table($table, $columns)) !== FALSE) {
			// write initial data, unfortunately I didn't find any bulk INSERT statement for SQL Server 2000
			$result &= $query->insert($table, "pTypId, procId, comment",
				"3, 1, 'get content as internal page (Ajax)'", FALSE);
			$result &= $query->insert($table, "pTypId, procId, comment",
				"4, 1, 'get content as external link (Ajax)'", FALSE);
			$result &= $query->insert($table, "pTypId, procId, comment",
				"5, 1, 'get content (Ajax)'", FALSE);
			$result &= $query->insert($table, "pTypId, procId, comment",
				"2, 2, 'process vertical menu by Ajax'", FALSE);
			$result &= $query->insert($table, "pTypId, procId, comment",
				"2, 3, 'maintain vertical menu by Ajax'", FALSE);
			$result &= $query->insert($table, "pTypId, procId, comment",
				"2, 4, 'login'", FALSE);
			$result &= $query->insert($table, "pTypId, procId, comment",
				"2, 5, 'maintain user by Ajax'", FALSE);
			$result &= $query->insert($table, "pTypId, procId, comment",
				"1, 6, 'start from scratch'", FALSE);
			$result &= $query->insert($table, "pTypId, procId, comment",
				"2, 7, 'Window Size'", FALSE);
			
			return $result;
		} else 
			return FALSE; // create_table() failed		
	} else 
		return TRUE; // table already exist
}

function init_tbl_ctc($table) {
	$query = new DBInterface();
	
	if($query->show_tables_sql($table) === FALSE) {
		
		// create empty table by filling array
		$columns = array();
		$columns[0] = array('name' => 'ctcId', 'type' => 'int', 'null' => FALSE,	'auto_inc' => TRUE,
				'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'ctcId');
		$columns[1] = array('name' => 'tableAndId', 'type' => 'varchar(255)', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'table name and id');
		$columns[2] = array('name' => 'UserSession', 'type' => 'varchar(32)', 'null' => TRUE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'session');
		$columns[3] = array('name' => 'accType', 'type' => 'varchar(20)', 'null' => FALSE, 'auto_inc' => FALSE,
				'key' => FALSE, 'unique' => FALSE, 'default' => '5', 'comment' => 'access type');

		return $query->create_table($table, $columns, 'InnoDB');
	} else 
		return TRUE; // table already exist
}
		
function init_db() {
	global $lang_php;
	$result = init_tbl_cnt(CONFIG::sql_tbl_cnt);
	$result = ($result)?(init_tbl_gData(CONFIG::sql_tbl_gData)):($result);
	$result = ($result)?(init_tbl_menu(CONFIG::sql_tbl_menu)):($result);
	$result = ($result)?(init_tbl_proc(CONFIG::sql_tbl_proc)):($result);
	$result = ($result)?(init_tbl_pTypes(CONFIG::sql_tbl_pTypes)):($result);
	$result = ($result)?(init_tbl_sact(CONFIG::sql_tbl_sact)):($result);
	$result = ($result)?(init_tbl_styles(CONFIG::sql_tbl_styles)):($result);
	$result = ($result)?(init_tbl_user(CONFIG::sql_tbl_user)):($result);
	$result = ($result)?(init_tbl_ul(CONFIG::sql_tbl_ul)):($result);
	$result = ($result)?(init_tbl_xTP(CONFIG::sql_tbl_xTP)):($result);
	$result = ($result)?(init_tbl_ctc(CONFIG::sql_tbl_ctc)):($result);
	return $result;
}

function upgrade_db() {

	//1. upgrade, check for version element in general data
	$query = new DBInterface();
	$result = True;
	if($query->check_column(CONFIG::sql_tbl_gData, 'version') !== True) {
		$columns = array();
		$columns[0] = array('alter' => 'ADD', 'name' => 'version', 'type' => 'varchar(15)', 'null' => FALSE, 'auto_inc' => FALSE, 'unique' => TRUE, 'default' => 'V0.3.0', 'comment' => 'Version of imacs DB schema');
		$result &= $query->alter_table(CONFIG::sql_tbl_gData, $columns);
	}
	$version = $query->get_single_value("g.version", CONFIG::sql_tbl_gData." AS g", 1);
	$version = (isset($version) && is_array($version)) ? $version[0]['version'] : '';
	
	//ensure presence of concurrency transaction control table
	$result = init_tbl_ctc(CONFIG::sql_tbl_ctc);
	
	//'V0.1.2':
	//set updates and changes of DB, but do not forgot updating of version itself
	if($query->check_column(CONFIG::sql_tbl_user, 'time_stamp') !== True) {
		$myTimeStamp = date("Y-m-d H:i:s");
		$columns = array();
		$columns[0] = array('alter' => 'ADD', 'name' => 'time_stamp', 'type' => 'datetime', 'null' => TRUE, 'auto_inc' => FALSE, 'unique' => FALSE, 'default' => ''.$myTimeStamp.'', 'comment' => 'Time of last action');
		$result &= $query->alter_table(CONFIG::sql_tbl_user, $columns);
	}
	if($query->check_column(CONFIG::sql_tbl_gData, 'getUserProf') !== True) {
		$columns = array();
		$columns[0] = array('alter' => 'ADD', 'name' => 'getUserProf', 'type' => 'varchar(120)', 'null' => TRUE, 'auto_inc' => FALSE, 'unique' => FALSE, 'default' => Null, 'comment' => 'Interface for User Profile Data');
		$columns[1] = array('alter' => 'ADD', 'name' => 'getUserProfSrc', 'type' => 'varchar(240)', 'null' => TRUE, 'auto_inc' => FALSE, 'unique' => FALSE, 'default' => Null, 'comment' => 'filename of Interface for User Profile Data');
		$result &= $query->alter_table(CONFIG::sql_tbl_gData, $columns);
	}
	//'V0.3.0':
	//set updates and changes of DB, but do not forgot updating of version itself
	if($query->check_column(CONFIG::sql_tbl_ul, 'is_user') !== True) {
		$columns = array();
		$columns[0] = array('alter' => 'ADD', 'name' => 'is_user', 'type' => 'tinyint', 'null' => FALSE, 'auto_inc' => FALSE, 'unique' => FALSE, 'default' => 1, 'comment' => 'User level of user or elements');
		$result &= $query->alter_table(CONFIG::sql_tbl_ul, $columns);
	}
	
	return $result;
}
?>