<?php
/**
 * This module processes all tasks regarding Editor
 *
 * @package: JRCMS
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @version $Id: jrcmseditor.php 501 2011-04-10 17:37:00Z jensraabe $
 *
 * @copyright Copyright (c) 2009, Jens Raabe (MIT)
 * license: MIT-style license, see jrcms.js
 */
 
// set some headers values
header("Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . " GMT" ); 
header("Content-Type: text/plain; charset=utf-8");
header("Connection: close");
// set header
session_cache_limiter( 'nocache' ); //Expires, Cache-Control, Pragma
// start session
session_start(); 
// usage of classes
require_once('../../../conf/cConfig.php');
CONFIG::loadLanguage();
//language support of plugin
require_once(('lang/lang.'.$_SESSION["language"]));
$lang_php = array_merge($lang_e, $lang_php);
CONFIG::loadClasses();
CONFIG::loadScripts();
// retrieve parameter
if(isset($_GET['a'])) {$act = $_GET['a'];} else {if(isset($_POST['a'])) {$act = $_POST['a'];} else {$act=NULL;}}

	// ------------------------------

	/**
	 * @access private
	 * @param none
	 * @return string (HTML)
	 * @author Jens Raabe <jens@raabe-berlin.de>
	 * 
	 * This function writes the given data in the DB
	 */
	 
	function sacnt(){
		
		global $lang_php;

		try{
			$api = new JRCMSAPI();
			$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
			if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=1;}}
			if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
			if(isset($_GET['cid'])) {$cid = $_GET['cid'];} else {if(isset($_POST['cid'])) {$cid = $_POST['cid'];} else {$cid=NULL;}}
			if(isset($_POST['cont'])) {$content = $_POST['cont'];} else {$content=NULL;}

			// if no content ID is provided this has to be 
			// determined first at least for CTC
			if(isset($cid) || ($result = $api->getRawContentData($id, 'c.cid')) !== FALSE){
				$cid = isset($cid)?$cid:$result[0]['cid'];
				// Optimistic transaction is processed inside MENU class
				$result = $api->updateContent($id, str_replace('%#', '&#', $content), $cid);
				
			}
//			
//			
//			
//			// Transaction started by Edit Task
//			// CTC: CHECK OPTIMISTIC TRANSACTION - LOCK
//			if($api->ctcCheckAndLockTable(CONFIG::sql_tbl_cnt, $id)) {
//			
//				// string to be saved
//				if(!isset($cid)) {
//					//by using regular menu function
//					$result = $api->updateContent($id, str_replace('%#', '&#', $content));
//				} else
//					//by direct access to content
//					$result = $api->updateSingleValueOfDb(
//										CONFIG::sql_tbl_cnt." AS c",
//										"c.content ='".(string)str_replace('%#', '&#', $content)."'",
//										"c.cid = ".$cid);
//			}
//			// CTC: CLOSE OPTIMISTIC TRANSACTION - UNLOCK
//			$api->ctcUnlockTable(CONFIG::sql_tbl_cnt, $id);
//			// CTC: RESERVE THE ENTRY AGAIN 
//			// because the editor is still active.
//			$api->ctcReserveTable(CONFIG::sql_tbl_cnt, $id);
//			
			//api no longer needed
			$api = NULL;
			
			if( $result === TRUE)
				return '<script type="text/javascript">var check = "saved"; alert("'.$lang_php['data_updated'].'");</script>';
			else
				return '<script type="text/javascript">var check = "failure"; alert("'.$lang_php['data_update_failure'].'");</script>';

		}catch (MyException $e) {
			$e->log();
			return "Wrong content possible!";
		}
	}
	
// ---------------
	
	function getInternalLink(){
		
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		try{
			$api = new JRCMSAPI();
			
			$data = $api->getArrayFromDb("m.id, m.rootId as root, m.cssid, m.label",
										CONFIG::sql_tbl_menu." AS m  
										INNER JOIN ".CONFIG::sql_tbl_ul." ON ".CONFIG::sql_tbl_ul.".ulid=m.ulid",
										"m.label NOT LIKE 'ROOT' 
										AND LEFT(".CONFIG::sql_tbl_ul.".ul,1) <= ".(substr($ul,0,1))." ORDER BY m.label ASC");									

			$dataset = Array( 'jr_linkProc' => 'jrCMS.getContentForNode'
							 ,'jr_linkList' => $data);
			return $api->array2Xml($dataset);				 
			
		}catch (MyException $e) {
			$e->log();
			return "Wrong content possible!";
		}
	}	
	
// ---------------
	
	function unlockEditorContent(){
		
		global $lang_php;

		try{
			$api = new JRCMSAPI();
			if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
			// CTC: CLOSE OPTIMISTIC TRANSACTION - UNLOCK
			$api->ctcUnlockTable(CONFIG::sql_tbl_cnt, $id);
			//api no longer needed
			$api = NULL;
			return true;

		}catch (MyException $e) {
			$e->log();
			return "Unlock failure!";
		}
	}
	

// ############## MAIN ##############
// calling functions of jrcmseditor.php

if (isset($act)) {
	switch ($act) {
	case "sacnt":
		// save content 
		$strHtml = sacnt();
		echo $strHtml;
		break;
	case "getInternalLink":
		//  
		$xml = getInternalLink();
		echo $xml;
		break;
	case "unlockEditorContent":
		//
		$strHtml = unlockEditorContent();
		echo $strHtml;
		break;
	default: 
		print_r("jrcmseditor.php with wrong action called!!");
	}

} else {

	print_r("jrcmseditor.php with wrong parameter called!!");
	
}

flush(); // send really out all stuff
?>