<?php
/**
 * This module processes all tasks regarding schedule / event plan
 *
 * @package jrCmsEventPlanner
 * @author Jens Raabe <jens@raabe-berlin.de
 *  
 * @copyright Copyright (c) 2010 Jens Raabe
 * license: MIT-style license, see jrcms.js
 */
 
// set some headers values
header("Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . " GMT" ); 
header("Content-Type: text/plain; charset=utf-8");
header("Connection: close");
// set header
session_cache_limiter( 'nocache' ); //Expires, Cache-Control, Pragma
// start session
session_start(); 
// usage of classes
require_once('../../../conf/cConfig.php');
// need utilities
require_once('../../jrcmsutilities.php');
//global language values
CONFIG::loadLanguage();
//language support of plugin
require_once(('lang/lang.'.$_SESSION["language"]));
$lang_php = array_merge($lang_s, $lang_php);
CONFIG::loadClasses();
CONFIG::loadScripts();
//retrieve parameter
if(isset($_GET['a'])) {$act = $_GET['a'];} else {if(isset($_POST['a'])) {$act = $_POST['a'];} else {$act=NULL;}}
define("sql_tbl_eventplan", 'web_eventplan');

// ------------------------------
// Utilities
// ------------------------------

	/**
	 * the title string of event string will be transfered
	 * 
	 * @access public
	 * @param string	report text
	 * @param int		length of title text (default 120 character)
	 */
	function eventTitleString($event, $introLength=120) {
		
		$allowable_tags = "<b><i>";
		$str = strip_tags( $event, $allowable_tags );
		$str = substr ($str , 0 , $introLength );
		return $str.'</b>';
		
	}
	
	// ------------------------------
	
	/**
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function getEventContentArray($api, $eventData, $writeacc=FALSE, $dlgdata=NULL ){

		global $lang_php;
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['eplid'])) {$eplid = $_GET['eplid'];} else {if(isset($_POST['eplid'])) {$eplid = $_POST['eplid'];} else {$eplid=0;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		
		$uploadDir= 'http://'.$_SERVER['HTTP_HOST'].CONFIG::docPath;
		if(!$writeacc){
			//read (w/o editor and no buttons)
			//but build header data of event
			$strHtml = '<div id="singleEvent">';
			if(isset($eventData[0]['event'])) $strHtml.= '<h1 class="singeEventTitle">'.$eventData[0]['event'].'</h1>';
			if(isset($eventData[0]['subtitle']) && $eventData[0]['subtitle'] != 'none') 
				$strHtml.= '<span class="singeEventTitle">'.$eventData[0]['subtitle'].'</span><br />';
			$strHtml.= '<span class="singeEventDate">'.dateDDMM($eventData[0]['begin']);
			if (isset($eventData[0]['end'])) {
				$strHtml.= ' - '.dateDDMM($eventData[0]['end']);
			}
			$strHtml.= '</span><br />';
			if (isset($eventData[0]['content']) && !empty($eventData[0]['content'])) {
				if (isset($eventData[0]['org']) && $eventData[0]['org'] != 'none') {
					$strHtml.= '<span class="singeEventOrg">'.utf8_decode($eventData[0]['org']).'</span><br />';
				}
				if (isset($eventData[0]['link']) && $eventData[0]['link'] != 'none') {
					$str = $uploadDir.'/'.$eventData[0]['link'];
					$strHtml.= '<a class="singeEventHref" href="'.$str.'" target="_blank">'.$lang_php['s_flyer'].'</a>';
				}
			}
			$strHtml.= '</div>';
			$strHtml.= utf8_decode($eventData[0]['content']);
			
			return $api->getContentAndButtons( $strHtml,
						(!$api->checkAccessRight($id, $ul, 'write')?NULL:
			 			$api->convertTaskList('std',
							array(
								1 => "jrCmsEventPlanner.processEvent({root:".$root.",id:".$id.",div:'".$div."',eplid:".$eplid.", a:'editSingleEvent'});return false;"
								),
							(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon')))),
						$api->getRightContent(),
						$dlgdata);
			
		} else {
			// CTC: START OPTIMISTIC TRANSACTION - RESERVE
			// we use the content ID like as in the MENU class and the content table
			$api->ctcReserveTable(CONFIG::sql_tbl_cnt, $eventData[0]['cid']);								
			
			//write (w/- editor and delete/back button)
			return $api->getContentAndButtons(
						'<form id="to_submit" name="to_submit" method="post" action="" />
						<input type="hidden" name="root" id="root" value="'.$root.'" />
						<input type="hidden" name="id" id="id" value="'.$id.'" />
						<input type="hidden" name="div" id="div" value="'.$div.'" />
						<input type="hidden" name="eplid" id="eplid" value="'.$eplid.'" />
						<input type="hidden" name="cid" id="cid" value="'.$eventData[0]['cid'].'" />
						<input type="hidden" name="a" id="a" value="sacnt" />
						<textarea id="myXinhaEventarea" name="myXinhaEventarea" rows="0" cols="0" 
						style="position:relative; width:100%">'.$eventData[0]['content'].'</textarea></form>',
						$api->convertTaskList('std',
							array(
								10 => "jrCmsEventPlanner.getHelpDoc();return false;"),
							(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))),
						$api->getRightContent(),
						$dlgdata);
		}				
	}

	// ------------------------------
	/**
 	* event list
 	* 
 	* @access public
 	* @param string 
 	* @return string
 	*/
	function popUpEventList($api, $totalevents, $eventlst, $mth, $y, $writeacc=False, $app=FALSE){
		
		global $lang_php;
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['etl'])) {$etl = $_GET['etl'];} else {if(isset($_POST['etl'])) {$etl = $_POST['etl'];} else {$etl=120;}}
		if(isset($_GET['page'])) {$page = $_GET['page'];} else {if(isset($_POST['page'])) {$page = $_POST['page'];} else {$page=1;}}
		if(isset($_GET['page'])) {$_GET['total'] = $totalevents; $jr_eventlst = json_encode($_GET);} else {$_POST['total'] = $totalevents; $jr_eventlst = json_encode($_POST);}
		
		$strHtml = '<script type="text/javascript">var jr_eventparam = '.$jr_eventlst.';</script>';
		if(!$app) {
			$strHtml.= (isset($lang_php['s_events']) && $lang_php['s_events']!='')?('<h1 class="eventListHeader">'.$lang_php['s_events'].'</h1>'):'';
			$strHtml.= (isset($lang_php['s_events']) && $lang_php['s_events']!='')?('<div class="eventListHeader">'.$lang_php['s_event_hint'].'</div>'):'';
		} else
			$strHtml.= (isset($lang_php['s_event_appheader']) && $lang_php['s_event_appheader']!='')?('<div class="eventAppListHeader">'.$lang_php['s_event_appheader'].'</div>'):'';
		$strHtml.= '<div id="eventListFrame"'.($app?' class="eventapp"':'').'>';
		if(!$app) {
			$strHtml.= '<form id="eventListForm" name="eventListForm" action="">';
			$strHtml.= '<input type="hidden" id="root" name="root" value="'.$root.'" />';
			$strHtml.= '<input type="hidden" id="id" name="id" value="'.$id.'" />';
			$strHtml.= '<input type="hidden" id="cssid" name="cssid" value="'.$cssid.'" />';
			$strHtml.= '<input type="hidden" id="div" name="div" value="'.$div.'" />';
		}
		if(is_array($eventlst) && !empty($eventlst)) {
			$strHtml.= '<table border="0">';
			foreach ($eventlst as &$event){
				//#row
				$strHtml.= '<tr>';
				//##col:multiselect
				if ($writeacc){
					$strHtml.= '<td class="eventListCheckbox">';
					$strHtml.= '<input type="checkbox" name="chklist" value="'.$event['eplid'].'" />';
					$strHtml.= '</td>';
				}			
				//##col:date
				$strHtml.= '<td class="eventListDate'.($app?" eventListDateApp":"").'" ><span>'.dateDDMM($event['begin']);
				if (isset($event['end'])) {
					$strHtml.= ' - '.dateDDMM($event['end']).'</td>';
				} else {
					$strHtml.= '</span></td>';
				}		
				//##col:event
				$strHtml.= '<td class="eventListOvw'.($app?" eventListOvwApp":"").'">';
				$strHtml.= (strlen($event['content']) > 4)
							? ('<span onClick="jrCmsEventPlanner.processEvent({root:'.$root.',id:'.$id.',cssid:'.$cssid.',div:\''.$div.'\',eplid:'.$event['eplid'].',a:\'getPreviewSingleEvent\',el:this}); return false;">'.
							   eventTitleString(utf8_decode($event['event']),$etl).' <span class="eventmore">'.$lang_php['s_more'].'</span></span>')
							: eventTitleString(utf8_decode($event['event']),$etl);   
				$strHtml.= '</td>';
				$strHtml.= '</tr>';
			}
			$strHtml.= '</table>';
		} else {
			$strHtml.= '&nbsp;<br /><h2>'.$lang_php['s_no_event'].'</h2>';
		}
		$strHtml.= (!$app)?'</form></div>':'</div>';
		return $strHtml;
	
	}	
		
	// ------------------------------
	/**
 	* event list
 	* 
 	* @access public
 	* @param string 
 	* @return string
 	*/
	function popUpEventAppHtml($api, $eventlst, $nextno){
		
		global $lang_php;
		
		return popUpEventList($api, $nextno, $eventlst, 0, 0, False, True);
		
	}
	
	// ------------------------------
	/**
 	* event list
 	* 
 	* @access public
 	* @param string 
 	* @return string
 	*/
	function popUpEventListXml($api, $totalevents, $eventlst, $mth, $y, $writeacc=False){
	
		global $lang_php;
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}

		// provide XML container
		$xmlStr = $api->getMessageContainer(
						$api->getContentAndButtons( popUpEventList($api, $totalevents, $eventlst, $mth, $y, $writeacc),
							(($writeacc)?($api->convertTaskList('std',
										array(
										0 => "jrCmsEventPlanner.processEvent({root:".$root.",id:".$id.",div:'".$div."', a:'createEvent'});return false;"
										,1 => "jrCmsEventPlanner.processEvent({root:".$root.",id:".$id.",div:'".$div."', a:'editSingleEvent'});return false;"
										,2 => "jrCmsEventPlanner.processEvent({root:".$root.",id:".$id.",div:'".$div."', a:'getPreviewSingleEvent'});return false;"
										,4 => "jrCmsEventPlanner.processEvent({root:".$root.",id:".$id.",div:'".$div."', a:'deleteEvent'});return false;"
										,7 => "jrCmsEventPlanner.processEvent({root:".$root.",id:".$id.",div:'".$div."', a:'copyEvents'});return false;"
										,10 => "jrCmsEventPlanner.getHelpDoc();return false;"
										),
										(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))))
									: NULL),
						$api->getRightContent()),
						$api->getMenu('xml'),
						$api->getStyles());

		return $xmlStr;
	}
	
	// ------------------------------
	
	/**
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function getEventConfData($api, $eplid){
		
		try{
			//retrieve the config data
			$result = getEventDB($api, $eplid);
			if(is_array($result) && !empty($result)) {
				//delete content
				$result[0]['content'] = NULL;
				if(!isset($result[0]['end'])) $result[0]['end'] = '';
				//access rights
				$ar = $api->checkAccessRight($eplid, (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000'), 'write', CONFIG::webmasterLevel);
				foreach($result[0] as $key => $value){
					if (isset($value)) {
						switch($key) {
							case "ulText":	//not necessary
							case "l": 		//label not necessary
							case "eplid": 	//provided as header
								break;	
							case "link":
								$eventDialogData[] = $api->dialogElement($key, ((isset($value)&&$value!='none') ? $value : ''), 'eventDialog', 'select:jrCmsEventPlanner');
								break;
							case "subtitle":
							case "org":
								$eventDialogData[] = $api->dialogElement($key, ((isset($value)&&$value!='none') ? $value : ''), 'eventDialog');
								break;
							case "ulid":
								$eventDialogData[] = $api->dialogElement($key, $value, 'eventDialog', 'select:jrCmsEventPlanner', 'required');
								break;		
							case "event":
								$eventDialogData[] = $api->dialogElement($key, $value, 'eventDialog', 'input', 'required');
								break;		
							case "end":
								$eventDialogData[] = $api->dialogElement($key, $value, 'eventDialog', 'input:jrCmsEventPlanner', 'validate-date');
								break;
							case "begin":
								$eventDialogData[] = $api->dialogElement($key, $value, 'eventDialog', 'input:jrCmsEventPlanner', 'validate-date');
								break;
							case "masterId":
								$eventDialogData[] = ($ar 
													 ? $api->dialogElement($key, intval($value), 'eventDialog', 'select:jrCmsEventPlanner')
													 : $api->dialogElement($key, intval($value), 'eventDialog', 'hidden'));
								break;
							default:	
								if((intval($value) != 0) && (strpos($value, '%')===False)) 
									$eventDialogData[] = $api->dialogElement($key, intval($value), 'eventDialog', 'hidden');
								else
									$eventDialogData[] = $api->dialogElement($key, $value, 'eventDialog', 'hidden');
						}
					}
				}
			} else {
				$eventDialogData = Array();
			} 
			//dialog dataset
			$dataset = array(
							'header' => $api->dialogHeader('eplid', $eplid),
						 	'data' => $eventDialogData);
			return $dataset;
	
		}catch(MyException $e){
			$e->log();
			return "[jrcmseventplanner.getEventConfData] failure!";		
		}
	} //getEventConfData
	
// ------------------------------
// Database routines
// ------------------------------

	//web_eventplan
	// eplid		int		Event plan ID
	// id			int		Reference to anchor content id (menu id)
	// cid			int		Reference to own content (description) id
	// ulid			int		Reference to userlevel id
	// masterId, 	int		Master menu Id
	// begin		date	Begin Date of event
	// end			date 	(opt) End Date of event
	// event		varchar(240)	event
	// link			varchar(120)	(opt) link
	// org			varchar(120)	(opt) responsible
	// subtitle		varchar(240)	subtitle of event
	/**
	 * The event will be stored like as a normal content but there is a corresponding 
	 * configuration set in table 'web_eventplan'. The conten Id of the menu entry is used as
	 * anchor only.
	 * 
	 * @access private
	 * @return data
	 */
	function getEventListDB($api, $id=0, $mth=0, $y=NULL, $epAllId=NULL, $start=NULL, $limit=NULL, $sortOrder='ASC') {
		
		$userLevel = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		try{
			
			// determine month or year list
			$timestamp = time();
			$date1 = (!isset($y))?(date("Y",$timestamp)):($y);
			$date2 = (!isset($y))?(date("Y",$timestamp)):($y);
			if ($mth == 0) {
  				// whole year
				$date1.= "-01-01";
				$date2.= "-12-31";
			} else {
				// a month only
				$mth = sprintf("%02d",$mth);
				$date1.= '-'.$mth.'-01';
				$date2.= ($mth == 12)?('-12-31'):('-'.($mth+1).'-01');
			}	

		return (isset($epAllId) && $id == $epAllId)
				//all reports sorted by begin date and event where the subquery returns the publishing list
					? ($api->getArrayFromDb('ep.event, ep.subtitle, ep.begin, ep.end, ep.org, ep.link, ep.eplid, c.content, m.label, u.ul',
										'`'.sql_tbl_eventplan.'` AS ep
										 INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON ep.cid = c.cid
										 INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = ep.id
										 INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid = ep.ulid',
										'ep.eplid IN(SELECT ep.eplid FROM `'.sql_tbl_eventplan.'` AS ep
										 INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid = ep.ulid
						 				 WHERE (ep.masterId = '.(int)$epAllId.' OR ep.id = '.(int)$id.') AND
						 				 (ep.begin BETWEEN '.sql_quoted(replaceChar($date1),'CHAR').' AND '.sql_quoted(replaceChar($date2),'CHAR').') AND
						 				 LEFT(u.ul,1) <= '.(substr($userLevel,0,1)).'
						 				 ORDER BY ep.begin '.$sortOrder.')',
										$start, $limit, NULL,
										'ORDER BY ep.begin '.$sortOrder))
				
				//only the events of 'id' has to be provided
					: ($api->getArrayFromDb('ep.event, ep.subtitle, ep.begin, ep.end, ep.org, ep.link, ep.eplid, c.content, m.label as l, u.ul',
										'`'.sql_tbl_eventplan.'` AS ep
										 INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON ep.cid = c.cid
										 INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = ep.id
										 INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid = ep.ulid',
										'ep.id = '.$id.' AND
						 				(ep.begin BETWEEN '.sql_quoted(replaceChar($date1),'CHAR').' AND '.sql_quoted(replaceChar($date2),'CHAR').') AND
						 				LEFT(u.ul,1) <= '.(substr($userLevel,0,1)),
										$start, $limit, NULL,
										'ORDER BY ep.begin '.$sortOrder));
			
		}catch (MyException $e) {
			$e->log();
			return False;
		}
	}

	/**
	 * Like as getEventListDB this routine retrieve the next events only
	 * 
	 * @access private
	 * @return data
	 */
	function getNextEventListDB($api, $limit ) {
		
		$userLevel = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		$sortOrder = 'ASC';
		try{
			
			// determine month or year list
			$timestamp = time();
			$date1 = (!isset($y))?(date("Y-m-d",$timestamp)):($y);
			$date2 = (!isset($y))?(date("Y-12-31",$timestamp)):($y);

			return $api->getArrayFromDb('ep.event, ep.subtitle, ep.begin, ep.end, ep.org, ep.link, ep.eplid, c.content, m.label, u.ul',
										'`'.sql_tbl_eventplan.'` AS ep
										 INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON ep.cid = c.cid
										 INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = ep.id
										 INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid = ep.ulid',
										'ep.eplid IN(SELECT ep.eplid FROM `'.sql_tbl_eventplan.'` AS ep
										 INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid = ep.ulid
						 				 WHERE (ep.begin BETWEEN '.sql_quoted(replaceChar($date1),'CHAR').' AND '.sql_quoted(replaceChar($date2),'CHAR').') AND
						 				 LEFT(u.ul,1) <= '.(substr($userLevel,0,1)).'
						 				 ORDER BY ep.begin '.$sortOrder.')',
										 NULL, $limit, NULL,
										'ORDER BY ep.begin '.$sortOrder);
			
		}catch (MyException $e) {
			$e->log();
			return False;
		}
	}
	
	// ------------------------------
	/**
	 * 
	 * @access private
	 * @return data
	 */
	function getEventDB($api, $eplid=0) {

		try{
			//SELECT ep.begin, ep.end, ep.event, ep.subtitle, ep.org, ep.link, c.content, u.ul
			//FROM `web_eventplan` AS ep
			//INNER JOIN `web_content` AS c ON ep.cid = c.cid
			//INNER JOIN `web_menu` AS m ON m.id = ep.id
			//INNER JOIN `web_UserLevel` AS u ON u.ulid = ep.ulid
			//WHERE ep.eplid = $eplid
			return $api->getSingleValueFromDb('ep.event, ep.subtitle, ep.begin, ep.end, ep.org, ep.link, ep.masterId, ep.eplid, 
												ep.id, ep.cid, ep.ulid, c.content, m.label as l, u.ul, u.description as ulText',
												'`'.sql_tbl_eventplan.'` AS ep
										 		INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON ep.cid = c.cid
										 		INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = ep.id
										 		INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid = ep.ulid',
												'ep.eplid = '.$eplid);
		}catch (MyException $e) {
			$e->log();
			return False;
		}
	}

	
	// ------------------------------
	/**
	 * 
	 * @access private
	 * @return data
	 */
	function getEventsLinkDB($api, $y=Null ) {
		//function to alter the directory array
		function alterDir(&$item, $key){
			$labelLength = 20;
			$item['label'] = strip_tags(removeTagsWContent($item['label'], 'script'));
			$item['label'] = strlen($item['label']) < $labelLength ? $item['label'] : substr ($item['label'] , 0 , (stripos($item['label'],' ',$labelLength) !== False ? stripos($item['label'],' ',$labelLength) : NULL));
		}

		// determine month or year list
		$timestamp = time();
		$date1 = ((!isset($y))?(date("Y",$timestamp)):($y))."-01-01";
		$date2 = ((!isset($y))?(date("Y",$timestamp)):($y))."-12-31";

		$result = $api->getArrayFromDb('m.id, m.cssid, m.rootId as root, m.htmlDiv as `div`, 
										ep.event as label, ep.eplid, \'getPreviewSingleEvent\' AS a' ,
										'`'.sql_tbl_eventplan.'` AS ep
										 INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = ep.id
										 INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid = ep.ulid',
										 'ep.begin BETWEEN '.sql_quoted(replaceChar($date1),'CHAR').' AND '.sql_quoted(replaceChar($date2),'CHAR'));
		array_walk($result, 'alterDir');
		return $result;
			
	}
	
	// ------------------------------
	/**
 	 * create event
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */
	
	function createEventDB($api, $id, $masterId=NULL) {

		global $lang_php;
		//1) create a new content entry
		if(($cid = $api->insertSingleValueInDb('`'.CONFIG::sql_tbl_cnt.'`',
												'content', 
												"'".addslashes($lang_php['s_event_init'])."'", True)) !== False) {
			//2) create a new report entry
			//web_eventplan
			// eplid		int		Event plan ID
			// id			int		Reference to anchor content id (menu id)
			// cid			int		Reference to own content (description) id
			// ulid			int		Reference to userlevel id
			// masterId, 	int		Master menu Id
			// begin		date	Begin Date of event
			// event		varchar(240)	event
			
			//due to compatibility reasons with other SQL databases datetime format 
			//is used instead of the MYSQL timestamp format
			$myTimeStamp = date("Y-m-d H:i:s");
			if(($_GET['eplid'] = $api->insertSingleValueInDb('`'.sql_tbl_eventplan.'`',
													'id, cid, ulid, masterId, begin, event',
													(int)$id."
													,".(int)$cid."
													,1
													,".(isset($masterId)?((int)$masterId):0)."
													,'".(string)$myTimeStamp."'
													,'".addslashes($lang_php['s_event_init'])."'", True)) !== False){
				return $cid;													
			} else {
				$_GET['eplid'] = NULL;
				$api->deleteSingleValueOfDb('c.*','`'.CONFIG::sql_tbl_cnt.'` AS c',	'c.cid = '.(int)$cid	);
			}
		}													
  		return False; 									
  	} // createEventDB
	
	// ------------------------------
	/**
 	 * delete report
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function deleteEventDB($api, $eplid) {
		
		if(($result = $api->getSingleValueFromDb('ep.cid', '`'.sql_tbl_eventplan.'` AS ep', 'ep.eplid = '.(int)$eplid)) !== False) {
			//1 delete the content
			// CTC: START PESSIMISTIC TRANSACTION - LOCK
			$cid = (int)$result[0]['cid'];
			if( $api->ctcLockTable(CONFIG::sql_tbl_cnt, $cid) &&
			   ($result=$api->deleteSingleValueOfDb('c.*','`'.CONFIG::sql_tbl_cnt.'` AS c',	'c.cid = '.$cid)) !== False) {
				//2 delete the report entry
				$result = $api->deleteSingleValueOfDb('ep.*','`'.sql_tbl_eventplan.'` AS ep',	'ep.eplid = '.(int)$eplid);
				// CTC: FINISH PESSIMISTIC TRANSACTION	
				$api->ctcUnlockTable(CONFIG::sql_tbl_cnt, $cid);
				return $result;
			}
		}
		return False;
	} // deleteEventDB
  	
	// ------------------------------
	/**
 	 * update event conf data
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function updateEventConfDB($api, $eplid, $event, $subtitle, $begin, $end, $org, $link, $ulid, $masterId) {
		
		if(isset($eplid) && isset($event)) {
			if(($result = getEventDB($api, $eplid)) !== False) {
				// Transaction was started by Edit Task (see getEventContentArray)
				// CTC: CHECK OPTIMISTIC TRANSACTION - LOCK
				$cid = $result[0]['cid'];
				if($api->ctcCheckAndLockTable(CONFIG::sql_tbl_cnt, $cid)) {
					// write the content			
// Clemens 2001.08.11: replaced due to compatibility to MsSql
//					$result = $api->updateSingleValueOfDb('`'.sql_tbl_eventplan.'` AS ep',
//														"event = '".$event."'
//														,subtitle = '".$subtitle."'
//														,begin = '".$begin."'
//														".(isset($end)?",end = '".$end."'":"")."
//														,org = '".$org."'
//														,link = '".$link."'
//														,ulid = ".(int)$ulid."
//														,masterId = ".(int)$masterId,
//														'ep.eplid ='.$eplid);
					$result = $api->updateSingleValueOfDb(sql_tbl_eventplan,
														"event = '".$event."'
														,subtitle = '".$subtitle."'
														,begin = '".$begin."'
														".(isset($end)?",end = '".$end."'":"")."
														,org = '".$org."'
														,link = '".$link."'
														,ulid = ".(int)$ulid."
														,masterId = ".(int)$masterId,
														'eplid ='.$eplid);
					// CTC: CLOSE OPTIMISTIC TRANSACTION - UNLOCK 	
					$result &= $api->ctcUnlockTable(CONFIG::sql_tbl_cnt, $cid);
					// CTC: RESERVE THE ENTRY AGAIN
					// because the editor should be still active and
					// due to the optimistic method this as no negative
					// impact on further actions
					$result &= $api->ctcReserveTable(CONFIG::sql_tbl_cnt, $cid);

					return (boolean)$result;
					
				}
			}	
		}
		return false;
		
	} // updateEventConfDB
	
	
	// ------------------------------
	/**
 	 * update event content data
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */
	
	function updateEventContentDB($api, $eplid, $content) {
		
		if(isset($eplid) && isset($content)) 
			if(($result = getEventDB($api, $eplid)) !== False)
				// CTC is internal used, see MENU
				if($api->updateContent(NULL, $content, $result[0]['cid']) !== False)
					return True;
			
		return False;
	}

	// ------------------------------
	/**
 	 * retrieve all available menu items
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function getEventMenuItemsDB($api) {
		
		if(isset($_GET['all'])) {$all = $_GET['all'];} else {if(isset($_POST['all'])) {$all = $_POST['all'];} else {$all=1;}}
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		$ul = ($all==1)?CONFIG::webmasterLevel:$ul;
		
		try{
			//1) retrieve the xtpId
			// SELECT x.xtpID
			// FROM CONFIG::sql_tbl_xTP AS x
			// INNER JOIN CONFIG::sql_tbl_proc AS p ON p.procId=x.procId
			// WHERE p.procId LIKE 'jrCmsEventPlanner.getEventPlan'
			if(($result = $api->getSingleValueFromDb('x.xtpID',
											'`'.CONFIG::sql_tbl_xTP.'` AS x
											INNER JOIN `'.CONFIG::sql_tbl_proc.'` AS p ON p.procId=x.procId',
											'p.procName LIKE \'jrCmsEventPlanner.getEventPlan\'')) !== False) 
			
				// SELECT m.id, m.label
				// FROM CONFIG::sql_tbl_menu AS m
				// INNER JOIN CONFIG::sql_tbl_ul AS u ON u.ulid=m.ulid
				// WHERE m.label NOT LIKE 'ROOT' AND
				// LEFT(u.ul,1) <= (substr($ul,0,1))
				// ORDER BY m.label
				return	$api->getArrayFromDb('m.id, m.label',
											'`'.CONFIG::sql_tbl_menu.'` AS m
											 INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid=m.ulid',
							 				 'm.label NOT LIKE \'ROOT\' AND 
							 				 LEFT(u.ul,1) <= '.(substr($ul,0,1)).' AND
							 				 m.xtpID = '.$result[0]['xtpID'],
											 NULL, NULL, NULL,
											 'ORDER BY m.label ASC');
			
			return Null;
			
		}catch (MyException $e) {
			$e->log();
			return False;
		}
				
	} // getEventMenuItemsDB
	
// ------------------------------
// Task routines
// ------------------------------

	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function getEventPlan($api, $nextonly=false){
		
		global $lang_php;
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['epaid'])) {$epAllId = $_GET['epaid'];} else {if(isset($_POST['epaid'])) {$epAllId = $_POST['epaid'];} else {$epAllId=NULL;}}
		if(isset($_GET['mth'])) {$mth = $_GET['mth'];} else {if(isset($_POST['mth'])) {$mth = $_POST['mth'];} else {$mth=(int)date("n");}}
		if(isset($_GET['y'])) {$y = $_GET['y'];} else {if(isset($_POST['y'])) {$y = $_POST['y'];} else {$y=NULL;}}
		if(isset($_GET['epso'])) {$epSortOrder = $_GET['epso'];} else {if(isset($_POST['epso'])) {$epSortOrder = $_POST['epso'];} else {$epSortOrder='ASC';}}
		if(isset($_GET['page'])) {$page = $_GET['page'];} else {if(isset($_POST['page'])) {$page = $_POST['page'];} else {$page=1;}}
		if(isset($_GET['perpage'])) {$perpage = $_GET['perpage'];} else {if(isset($_POST['perpage'])) {$perpage = $_POST['perpage'];} else {$perpage=10;}}
		if(isset($_GET['nextno'])) {$nextno = $_GET['nextno'];} else {if(isset($_POST['nextno'])) {$nextno = $_POST['nextno'];} else {$nextno=2;}}
		
		$mth = ($mth > 12)?(12):(($mth<0)?((int)date("n")):($mth));
		$timestamp = time();
		$y = (!isset($y))?(date("Y",$timestamp)):($y);
		
		try{
			//******** Report List ***********
			//1 ensure presence of table
			if($ul == CONFIG::webmasterLevel && ($api->checkTable(sql_tbl_eventplan) !== True)){
				require_once('jrcmseventplannerinit.php');
				if(!initEventPlanerDb())
					throw new MyException('jrcmseventplanner.getEventPlan DB wrong initialized!');
			}
			//2 pagination
			$n = ( $page -1 ) * $perpage;
			$totalreports = count(getEventListDB($api, $id, $mth, $y, $epAllId));
			//3 retrive the events
			$eventlst = (!$nextonly
						 ? getEventListDB($api, $id, $mth, $y, $epAllId, $n, $perpage, $epSortOrder)
						 : getNextEventListDB($api, $nextno ));
			
			//4 retrieve overview of events as XML container
			return (!$nextonly
					? popUpEventListXml($api, $totalreports, $eventlst, $mth, $y, $api->checkAccessRight($id, $ul, 'write'))
					: popUpEventAppHtml($api, $eventlst, $nextno));
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmseventplanner.getEventPlan] failure!";	
		}
	} //getEventPlan

	// ------------------------------
	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function getSingleEvent($api, $act=NULL){
		
		global $lang_php;
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['eplid'])) {$eplid = $_GET['eplid'];} else {if(isset($_POST['eplid'])) {$eplid = $_POST['eplid'];} else {$eplid=0;}}
		
		try{
			if(($result=getEventDB($api, $eplid))!==FALSE) {
				
				if(!$api->checkAccessRight($id, $ul, 'write') || (isset($act) && $act == 'getPreviewSingleEvent')) {
					return $api->getMessageContainer(
							getEventContentArray($api, 
							                     $result,
							                     FALSE),
							NULL, NULL);
				} else {
					return $api->getMessageContainer(
							getEventContentArray($api,
							                     $result, 
							                     TRUE, 
							                     getEventConfData($api, $eplid)),
							NULL, NULL);
				}
			} else {
				throw new MyException('getEventDB failed!');
			}
		
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.getSingleReport] failure!";		
		}
	} //getSingleReport
	
// ------------------------------
	
	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function createEvent($api){
		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['epaid'])) {$epAllId = $_GET['epaid'];} else {if(isset($_POST['epaid'])) {$epAllId = $_POST['epaid'];} else {$epAllId=NULL;}}
						
		try{
			
			if(($result = createEventDB($api, $id, $epAllId)) !== False)
				//the generated 'eplid' is set as $_GET['eplid'] inside of the DB routine
				return getSingleEvent($api,'getSingleEvent');
			else
				return $api->getMessageContainer(
						getReportContentXml($api, $lang_php['r_create_event_failure'], 0, FALSE),
						NULL, NULL);
		
		}catch(MyException $e){
			$e->log();
			return "[jrcmseventplanner.createEvent] failure!";		
		}
	} //createEvent
	
	// ------------------------------
	
	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function deleteEvent($api){
		
		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['eplid'])) {$eplid = $_GET['eplid'];} else {if(isset($_POST['eplid'])) {$eplid = $_POST['eplid'];} else {$eplid=NULL;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		try{
			
			if(isset($eplid)){
				if(($result = deleteEventDB($api, $eplid)) !== False)
					return getEventPlan($api);
				else
					return $api->getMessageContainer(
						getReportContentXml($api, $lang_php['s_delete_event_failure'], 0, FALSE),
						NULL, NULL);
			} else {
				throw new MyException('Wrong parameter supplied!');
			}
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmseventplanner.deleteEvent] failure!";		
		}
	}
	
	// ------------------------------
	
	/**
 	 * save event conf data 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function saveEventData($api){

		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['eplid'])) {$eplid = $_GET['eplid'];} else {if(isset($_POST['eplid'])) {$eplid = $_POST['eplid'];} else {$eplid=NULL;}}
		if(isset($_GET['event'])) {$event = $_GET['event'];} else {if(isset($_POST['event'])) {$event = $_POST['event'];} else {$event=NULL;}}
		if(isset($_GET['subtitle'])) {$subtitle = $_GET['subtitle'];} else {if(isset($_POST['subtitle'])) {$subtitle = $_POST['subtitle'];} else {$subtitle='none';}}
		if(isset($_GET['org'])) {$org = $_GET['org'];} else {if(isset($_POST['org'])) {$org = $_POST['org'];} else {$org='none';}}
		if(isset($_GET['link'])) {$link = $_GET['link'];} else {if(isset($_POST['link'])) {$link = $_POST['link'];} else {$link='none';}}
		if(isset($_GET['begin'])) {$begin = $_GET['begin'];} else {if(isset($_POST['begin'])) {$begin = $_POST['begin'];} else {$begin=NULL;}}
		if(isset($_GET['end'])) {$end = $_GET['end'];} else {if(isset($_POST['end'])) {$end = $_POST['end'];} else {$end=NULL;}}
		if(isset($_GET['ulid'])) {$ulid = $_GET['ulid'];} else {if(isset($_POST['ulid'])) {$ulid = $_POST['ulid'];} else {$ulid=1;}}
		if(isset($_GET['masterId'])) {$masterId = $_GET['masterId'];} else {if(isset($_POST['masterId'])) {$masterId = $_POST['masterId'];} else {$masterId=NULL;}}
		try{
			if($org == '') $org='none';
			if($link == '') $link='none';
			if($end == '') $end=NULL;
			
			//currently the thumbnail could be updated only
			if(($result = updateEventConfDB($api, $eplid, 
											str_replace('%#', '&#',$event), 
											str_replace('%#', '&#',$subtitle), 
											$begin, $end, 
											str_replace('%#', '&#',$org),
											$link, $ulid, $masterId)) !== False)
				return '<script type="text/javascript">alert("'.$lang_php['s_data_updated'].'");</script>';
			else
				return '<script type="text/javascript">alert("'.$lang_php['s_data_update_failure'].'");</script>';
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmseventplanner.saveEventData] failure!";		
		}
	}

	// ------------------------------
	
	function copyEvents($api) {
		
		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['eplid'])) {$eplid = $_GET['eplid'];} else {if(isset($_POST['eplid'])) {$eplid = $_POST['eplid'];} else {$eplid=NULL;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['epaid'])) {$epAllId = $_GET['epaid'];} else {if(isset($_POST['epaid'])) {$epAllId = $_POST['epaid'];} else {$epAllId=NULL;}}
		
		try{
			
			if(($result=getEventDB($api, $eplid))!==FALSE) 
				//take the same values and create the entry for next year
				if(($result2 = createEventDB($api, $id, $epAllId)) !== False)
					//the generated 'eplid' is set as $_GET['eplid'] inside of the DB routine
					if(($result3 = updateEventConfDB($api, $_GET['eplid'], 
											$result[0]['event'], 
											$result[0]['subtitle'],
											((int)substr($result[0]['begin'],0,4)+1).substr($result[0]['begin'],4), 
											(isset($result[0]['end']))?((int)substr($result[0]['end'],0,4)+1).substr($result[0]['end'],4):NULL, 
											$result[0]['org'],
											$result[0]['link'],
											$result[0]['ulid'],
											$result[0]['masterId'])) !== False) 
						//copy content
						if(updateEventContentDB($api,$_GET['eplid'],$result[0]['content']) !== False)
							return getEventPlan($api);
			
			return $api->getMessageContainer(
							getReportContentXml($api, $lang_php['s_data_copy_failure'], 0, FALSE),
							NULL, NULL);
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmseventplanner.deleteEvent] failure!";		
		}
	}
	
	// ------------------------------
	
	/**
 	 * get event flyer 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getEventFlyer($api){

		//function to alter the directory array
		function alterDir(&$item, $key){
			$item = Array('src' => str_replace($_SERVER['DOCUMENT_ROOT'].CONFIG::docPath.'/','',$item));
		}
		//we use the image utility to find files
		$filesArray = list_jpg_files($_SERVER['DOCUMENT_ROOT'].CONFIG::docPath.CONFIG::uploadDIR, False, $pattern="(\.pdf$)|(\.jpeg$)|(\.html$)");
		array_walk($filesArray, 'alterDir');
		$dataset = Array('jr_eventFlyer' => $filesArray);
		return $api->array2Xml($dataset);				
	}

	// ------------------------------
	
	/**
 	 * get user level list 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getUserLevelList($api){

		If(($result=$api->getAccesslevelList()) === False) {
			$result = Array();
		}
		$dataset = Array('jr_eventUserLevel' => $result);
		return $api->array2Xml($dataset);				
	}
	
	// ------------------------------
	/**
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getInternalLink($api){
	
		$data = getEventsLinkDB($api);
		$dataset = Array('jr_linkProc' => 'jrCmsEventPlanner.processEvent'
						,'jr_linkList' => $data);
		return $api->array2Xml($dataset);				
	}

	/**
 	 * get report master Id 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getMenuItems($api){
	
		if(($result = getEventMenuItemsDB($api)) !== False) {
			return (!empty($result))
					? ($api->array2Xml(Array('jr_eventMenuItems'=>$result)))
					: ($api->array2Xml(Array('jr_eventMenuItems'=> '')));
		}
		return "[jrcmseventplanner.getMenuItems] failure!";
		
	}
	
// ############ MAIN #############
$api = new JRCMSAPI();
if (isset($act)) {
	switch ($act) {
		case "getEventPlan":
			// retrieves all data and provide a xml container
			$e = getEventPlan($api);
			break;
		case "getEventPlanApp":
			// retrieves all data and provide a xml container
			$e = getEventPlan($api, TRUE);
			break;
		case "getSingleEvent":
		case "getPreviewSingleEvent":
			// retrieve a report and provide a xml container
			// CTC OPTIMISTIC - RESERVE for write access
			$e = getSingleEvent($api, $act);
			break;
		case "createEvent":
			// first create and internal getSingleEvent
			// CTC - not needed
			$e = createEvent($api);
			break;	
		case "deleteEvent":
			// first delete and internal getEventPlan
			// CTC OPTIMISTIC METHOD - complete sequence
			$e = deleteEvent($api);
			break;	
		case "saveEventData":
			// save the event data
			// CTC OPTIMISTIC METHOD - CHECK / RESERVE again
			$e = saveEventData($api);
			break;
		case "copyEvents":
			// save the event data
			// CTC - not needed
			$e = copyEvents($api);
			break;
			
		case "getEventFlyer":
			// retrieve event flyer XML
			$e = getEventFlyer($api);
			break;	
		case "getUserLevelList":
			// retrieve event flyer XML
			$e = getUserLevelList($api);
			break;	
		case "getInternalLink":
			// XML 
			$e = getInternalLink($api);
			break;
		case "getMenuItems":
			// XML 
			$e = getMenuItems($api);
			break;
		default: 	
			print_r("jrcmseventplanner.php with wrong parameter called!!");
	}
} else {
	print_r("jrcmseventplanner.php with wrong parameter called!!");
}
$api = NULL;
echo $e;
flush(); // send really out all stuff
?>