<?php
/**
 * This module initializes the database used by the jrCmsEventPlanner
 *
 * @package jrCMS: jrCmsEventPlanner
 * @author Jens Raabe
 *  
 * @copyright Copyright (c) 2010,2010 Jens Raabe
 * Permission is hereby granted, free of charge, to any person 
 * obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included 
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR 
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

function initProcedure($api){
	//TODO:as first try we use fix values
	return $api->insertProcedure('jrCmsEventPlanner.getEventPlan',3401,'ajax','Entry routine of schedule/event plan');
}

function initEventPlanerTbl($api){

	$columns = array();
	$columns[0] = array('name' => 'eplid', 'type' => 'int', 'null' => FALSE, 'auto_inc' => TRUE, 'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'Event plan ID');
	$columns[1] = array('name' => 'id', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'Reference to content id (menu id)');
	$columns[2] = array('name' => 'cid', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => TRUE, 'default' => NULL, 'comment' => 'Reference to own content (description) id');
	$columns[3] = array('name' => 'masterId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment' => 'Master menu Id');
	$columns[4] = array('name' => 'ulid', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => '1', 'comment'	=> 'User level id');
	$columns[5] = array('name' => 'begin', 'type' => 'date', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => '1914-01-01', 'comment' => 'Begin Date of event');
	$columns[6] = array('name' => 'end', 'type' => 'date', 'null' => TRUE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => '(opt) End Date of event');
	$columns[7] = array('name' => 'event', 'type' => 'varchar(240)', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'event');
	$columns[8] = array('name' => 'link', 'type' => 'varchar(120)', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => '(opt) link');
	$columns[9] = array('name' => 'org', 'type' => 'varchar(120)', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => '(opt) responsible');
	$columns[10] = array('name' => 'subtitle', 'type' => 'varchar(240)', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'subtitle of event');
//	$columns[10] = array('name' => 'category', 'type' => 'varchar(50)', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => 'all', 'comment' => '');
	
	return $api->createTable(sql_tbl_eventplan, $columns);
}


function initEventPlanerDb() {
	$api = new JRCMSAPI();
	
	$result = initProcedure($api);
	//print_r(' initProcedure: '.$result.'<br>');
	$result &= initEventPlanerTbl($api);
	//print_r(' initEventPlanerTbl: '.$result.'<br>');
	
	$api = NULL;
	return (!isset($result) || $result === False)?False:True;
}

?>