<?php
/**
 * This module demonstrates the usage of the JRCMSAPI for plugins
 *
 * @package JRCMS
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @version $Id: jrcmsexample.php 604 2011-09-17 20:24:32Z jensraabe $
 *  
 * @copyright Copyright (c) 2008,2009 Jens Raabe (MIT)
 * 
 * Permission is hereby granted, free of charge, to any person 
 * obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included 
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR 
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
 
//Send some headers to keep the user's browser from caching the response.
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT" ); 
header("Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . "GMT" ); 
header("Cache-Control: no-cache, must-revalidate" ); 
header("Pragma: no-cache" );
header("Content-Type: text/plain; charset=utf-8");
header("Connection: close");
 
// start session
session_start(); 
// usage of classes
require_once('../../../conf/cConfig.php');
CONFIG::loadConfig();
// retrieve the only global parameter
if(isset($_GET['a'])) {$act = $_GET['a'];} else {if(isset($_POST['a'])) {$act = $_POST['a'];} else {$act=NULL;}}

// ------------------------------
// Utilities
// ------------------------------
	
// ------------------------------
// Database routines
// ------------------------------

	/**#@+
	 * This function write a DB entry by using posted dialog entries.
	 * For differentiation between numeric and string values, all
	 * numeric keys could be idendified by an array.
	 *
	 * @access 	public
	 * @param	string db query: table(s) evtl. incl. JOINS
	 * @param 	array: defining numeric keys
	 * @param	boolean response db instance id (False/True)
	 * @return	boolean
	 */

//	public function insertPostedValuesInDb($table = NULL, $numValueArr = NULL, $insertId = False, $debug=NULL){
	function insertPostedValuesInDb($table = NULL, $numValueArr = NULL, $insertId = False, $debug=NULL){
		$cstr=''; $vstr='';
		foreach($_POST as $key => $value){
			$cstr.= ",".$key;
			$vstr.= (isset($numValueArr) && in_array($key, $numValueArr))
					? (",".(int)$value)
					: (",'".htmlentities((string)$value, ENT_QUOTES)."'");
		}
		
	return 'SQL:<br /> columns: '.substr($cstr,1).'<br />  values: '.substr($vstr,1);	
//		return $this->cms->insert($table, substr($cstr,1), substr($vstr,1), $insertId, $debug);
	}	


// ------------------------------
// Task routines
// ------------------------------

	/**
 	 * example using the content and button/icon functions of the API
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return HTML string
 	 */
	function example($api){
		
		/**
		 * @var	array	global used language array
		 */
		global $lang_php;
		/**
		 * @var	string	contains the actual userlevel, which is hold in a session variable
		 */
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		/**
		 * major control data (id, root, cssid, div)
		 */
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=1;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}

		/**
		 * A user plugin should ensure existing of own database tables, typicable checked by an admin task
		 * We prove the access right by using an own userlevel '444' instead of the level defined of $id
		 * but nevertheless the $id mus t be provided
		 */
		if($api->checkAccessRight($id, $ul, 'write', '444')){
			$result = $api->getMenuRoot('divRMenu', NULL, 'Example');
			if(empty($result)) {
				require_once('jrcmsexampleinit.php');
				if(!init_example_db()) return "DB wrong initialized!";
			}
		}
		
		/**
		 * @var	string	simulates any content
		 */
		$strHtml = '<h1>Result of any routine</h1>';
		$strHtml.= '<h2>e.g. Test Formular</h2>';
		$strHtml.= '<table><tbody>';
		$strHtml.= '<tr>';
		$strHtml.= '<td width="100px">';
		$strHtml.= '<input type="button" name="Start" value="Dialog" onclick="jrCmsExample.testDialog(); return false" /><br />';
		$strHtml.= '<input type="button" name="Start" value="Save Dialog" onclick="jrCmsExample.testSaveDialog(); return false" /><br />';
		$strHtml.= '<input type="button" name="Start" value="DlgFrame Top" onclick="jrCmsExample.testDialogTop(); return false" /><br />';
		$strHtml.= '<input type="button" name="Start" value="DlgFrame Left" onclick="jrCmsExample.testDialogLeft(); return false" /><br />';
		$strHtml.= '<input type="button" name="Start" value="DlgFrame Right" onclick="jrCmsExample.testDialogRight(); return false" /><br />';
		$strHtml.= '<input type="button" name="Start" value="DlgFrame Editor" onclick="jrCmsExample.testDialogEditor(); return false" /><br />';
		$strHtml.= '<input type="button" name="Start" value="DlgFrame Accordion" onclick="jrCmsExample.testDialogAccordionEditor(); return false" />';
		$strHtml.= '<input type="button" name="Start" value="Dialog & Buttons" onclick="jrCmsExample.testDialogWithContentAndButtons(); return false" />';
		$strHtml.= '<input type="button" name="Start" value="DlgFrame SubDialog" onclick="jrCmsExample.testDialogTopSubDlg(); return false" /><br />';
		$strHtml.= '<input type="button" name="Start" value="Dialog w/- dyn Select" onclick="jrCmsExample.testDynDialog(); return false" />';
		$strHtml.= '<input type="button" name="Start" value="Menu" onclick="jrCmsExample.testMenu(); return false" />';
		$strHtml.= '</td>';
		$strHtml.= '<td width="320px" heigth="200px">';
		$strHtml.= '<div id="divOutput"> </div>';
		$strHtml.= '</td>';
		$strHtml.= '</tr>';
		$strHtml.= '<tr>';
		$strHtml.= '<td colspan=2>';
		$strHtml.= '<h3>Save Result:</h3>';
		$strHtml.= '<div id="divSaveResult"> </div>';
		$strHtml.= '</td>';
		$strHtml.= '</tr>';
		$strHtml.= '</tbody></table>';
		
		return $api->getContentAndButtons($strHtml,
				/**
				 * provide a task list if necessary.
				 */ 
				$api->convertTaskList('std',
				//activate the task icon #8 of standard tasks with the a reload script
				array(8 => "jrCMS.reloadPage();return false;"),
				(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))), NULL);
	}

	/**
 	 * example for dialog structure 'testDialog'
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return XML
 	 */
	function example_testDialog($api){

		$content = Array();
		$str = "<p>Styles have to be defined based on the wrapping element, <br />";
		$str.= "please have a lock in jrcmsexample.css</p>"; 
		$content[] = $api->dialogElement("intro",$str,"set1:jrCmsExample","text","none");
		$content[] = $api->dialogElement("title","title-man","set1:jrCmsExample","select:jrCmsExample","required");
		$content[] = $api->dialogElement("firstname","Max","set1:jrCmsExample","input","disabled");
		$content[] = $api->dialogElement("secondname","Mustermann","set1:jrCmsExample","hidden");
		$content[] = $api->dialogElement("born","02/28/2000","set1:jrCmsExample","input","required validate-date");
		$content[] = $api->dialogElement("password","123","set3","input:jrCmsExample","required");
		$dataset = array('header' => $api->dialogHeader('uid', 1, 'save'),
						 'data' => $content);
		
// several other data formats		
//		print_r($dataset);		
//		$dataset = Array('img' => Array(
//            		0 => array('src' => './src/images/prlspinner_big.gif')
//            		,1 => array('src' => './src/images/prlspinner_light.gif')
//            		,2 => array('src' => './src/images/_prlspinner_big2.gif')
//            		,3 => array('src' => './src/images/_prlspinner_small.gif')
//            		,10 => array('src' => './src/images/prlheader.png')
//        			));
//		print_r($dataset);	
//		$dataset = array(
//		    "hoge" => 123,
//		    "foo" => 456,
//		    "bar" => 789,
//		    "aaa" => array(
//		        "abc" => 111,
//		        "bcd" => 222,
//		        "cde" => 333
//		    ),
//		    "bbb" => array(
//		        "def" => array(
//		            "efg" => false
//		        )
//		    )
//		);		
//		print_r($dataset);	
//		$dataset = Array(
//			'jr_imgShowData' => Array (
//				'images' => Array(
//					"11_034_2010_0409_192646aa.jpg" => Array (
//						"caption" => "11_034_2010_0409_192646aa")
//				)
//			)
//		);
//		print_r($dataset);	
		
		return $api->array2Xml($dataset);
	}
	
	/**
 	 * example for dialog structure 'testDialogTop'
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return JSON
 	 */
	function example_testDialogTop($api){

		$content = Array();
		$str = "<p>Predefined styles are used, please have a lock in jrcmsexample.css<br />";
		$str.= "This example is tagged to the parent element 'divOutput' and saves all open formulars.</p>"; 
		$content[] = $api->dialogElement("intro",$str,"set1:jrCmsExample","text","none");
		$content[] = $api->dialogElement("mobile","0110 111111","set2","input","validate-digits required");
		$content[] = $api->dialogElement("mail","max.mustermann@test.de","set2","input","validate-email");
		$content[] = $api->dialogElement("remark","{}","set2","textarea","none");
		$content[] = $api->dialogElement("remark","<em>italic text by HTML</em>","set2","textarea","disabled");
		$content[] = $api->dialogElement("accept","yes","set2","input:jrCmsExample","required");
		$content[] = $api->dialogElement("select","no","set2","input:jrCmsExample","required");
		$dataset = array('header' => $api->dialogHeader('uid', 1, 'save'),
						 'data' => $content);
		
//		return json_encode($dataset);
		return $api->array2Xml($dataset);
	}
	
	/**
 	 * example for dialog structure 'testDialogTopSubDlg'
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return JSON
 	 */
	function example_testDialogTopSubDlg($api){

		$content = Array();
		$str = "<p>Predefined styles are used, please have a lock in jrcmsexample.css<br />";
		$str.= "This example is tagged to the parent element 'divOutput' and saves all open formulars.</p>"; 
		$content[] = $api->dialogElement("intro",$str,"set1:jrCmsExample","text","none");
		$content[] = $api->dialogElement("mycalendar","02/28/2000","set2","calendar:jrCmsExample","required validate-date");
		$content[] = $api->dialogElement("mygrid","1","set2","subDialog:jrCmsExample");
		$dataset = array('header' => $api->dialogHeader('uid', 1, 'save'),
						 'data' => $content);
		
		return $api->array2Xml($dataset);
	}
	
	
	/**
 	 * example for dialog structure 'testDynDialog'
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return JSON
 	 */
	function example_testDynDialog($api){

		$content = Array();
		$str = "<p>Predefined styles are used, please have a lock in jrcmsexample.css<br />";
		$str.= "This example is tagged to the parent element 'divOutput' and saves all open formulars.</p>"; 
		$content[] = $api->dialogElement("intro",$str,"set1:jrCmsExample","text","none");
		$content[] = $api->dialogElement("title_event","title-man","set1:jrCmsExample","select:jrCmsExample","required");
		$dataset = array('header' => $api->dialogHeader('uid', 1, 'save'),
						 'data' => $content);
		
//		return json_encode($dataset);
		return $api->array2Xml($dataset);
	}
	
	/**
 	 * example for dialog structure 'testDialogLeft'
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return JSON
 	 */
	function example_testDialogLeft($api){
		
		$content = Array();
		$str = "<p>Styles have to be defined based on the wrapping element (content:dlg), ";
		$str.= "please have a lock in jrcmsexample.css.<br />This example save this formular only.</p>";
		$content[] = $api->dialogElement("intro",$str,"set1:jrCmsExample","text","none");
		$content[] = $api->dialogElement("accOne","1. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat","set4","accordion","none");
		$content[] = $api->dialogElement("accTwo","2. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat","set4","accordion","disabled");
		$content[] = $api->dialogElement("accThree","3. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat","set4","accordion","none");
		$dataset = array('header' => $api->dialogHeader('uid', 1, 'save'),
						 'data' => $content);
		
		return json_encode($dataset);
	}

	/**
 	 * example for dialog structure 'testDialogRight'
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return HTML
 	 */
	function example_testDialogRight($api){
		
		$str = "<p>Styles have to be defined based on the wrapping element (content:dlg2), ";
		$str.= "please have a lock in jrcmsexample.css.</p>";
		$str.= "<p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat</p>";
				
		return $str;
	}

	/**
 	 * example for dialog structure 'testDialogEditor'
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return XML
 	 */
	function example_testDialogEditor($api){

		$content = Array();
		$content[] = $api->dialogElement("remarkXinha","any text","set1","textareaEditor","required");
				$dataset = array('header' => $api->dialogHeader('uid', 1, 'save'),
						 'data' => $content);
	
		return $api->array2Xml($dataset);
	}
		
	/**
 	 * example for dialog structure 'testDialogEditor'
 	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return XML
 	 */
	function example_testDialogAccordionEditor($api){

		$content = Array();
		$content[] = $api->dialogElement("accOneXinha","1. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat","set1","accordionEditor","required");
		$content[] = $api->dialogElement("accTwoXinha","2. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat","set1","accordionEditor");
				$dataset = array('header' => $api->dialogHeader('uid', 1, 'save'),
						 'data' => $content);
	
		return $api->array2Xml($dataset);
	}
	
	
	/**
	 * example for dialog with content, buttons
	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return XML
 	 */
	function example_testDialogWithContentAndButtons($api){
		
		//http://localhost/imacs/src/plugins/jrcmsexample/jrcmsexample.php?a=testDialogWithContentAndButtons
		if(isset($_GET['dlgopt'])) {$dlgopt = $_GET['dlgopt'];} else {if(isset($_POST['dlgopt'])) {$dlgopt = $_POST['dlgopt'];} else {$dlgopt=NULL;}}
		$content = Array();
		$content[] = $api->dialogElement("accOneXinha","1. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat","set1","accordionEditor","required");
		$content[] = $api->dialogElement("accTwoXinha","2. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat","set1","accordionEditor");
		$dataset = Array('header' => $api->dialogHeader('uid', 1, 'save'),
						 'data' => $content,
						 'dlgoptions' => $dlgopt);

		$contHtml ='<h1>Example with wrapping content, containing a div element for the dialog</h1><div id="myDialog"></div>'; 
		$rightContHtml ='<b>right content</b>';
		
		return $api->getMessageContainer(
					$api->getContentAndButtons(
						$contHtml,							// HTML content string
						$api->convertTaskList('std',		// Button list
							array(
								0 => "jrCmsExample.buttonFunction();return false;"
							)),
						$rightContHtml,						// optional right Content
						$dataset),							// dialog options
					Null,
					Null);
	}
	

	// ////////////////////////////////////////////////////////////////////////////////////////////////////
	// NEW MENU FUNCTIONALITY
	// ////////////////////////////////////////////////////////////////////////////////////////////////////

	
	function get_menu_array($brunchId = -1, $menuDiv = 'div', $rootId = NULL, $userlevel = NULL, $cmpMode = false){
		
		return Array();
		
	}
	
	/**
	 * example for new Menu functionality
	 * 
	 * {@source }
 	 * @param global
 	 * @access private
 	 * @return XML
 	 */
	function example_testMenu($api){

		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=1;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['ul'])) {$ul = $_GET['ul'];} else {if(isset($_POST['ul'])) {$ul = $_POST['ul'];} else {$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');}}
		if(isset($_GET['mt'])) {$menuType = ($_GET['mt']==1)?(True):(False);} else {if(isset($_POST['mt'])) {$menuType = ($_POST['mt']==1)?(True):(False);} else {$menuType=True;}}
		
		
		$arr = get_menu_array( -1, 'divVMenu', $root, $ul, $menuType);
		 
var_dump($arr);		
		
	}
	
	
/**
 * ############ MAIN #############
 * @package JRCMS
 * @subpackage Example
 */
$api = new JRCMSAPI();
if (isset($act)) {
	switch ($act) {
	case "action":
		$xml = $api->getMessageContainer(example($api), $api->getMenu('xml'), $api->getStyles());
		echo $xml;
		break;
	case "html":
		// get simple schedule via ajax
		$strHtml = example();
		echo $strHtml;
		break;
	case "testDialog":
		// XOL example
		$xml = example_testDialog($api);
 		echo $xml;
		break;
	case "testDialogTop":
		// JSON example
		$json = example_testDialogTop($api);
		echo $json;
 		break;
	case "testDialogTopSubDlg":
		// JSON example
		$xml = example_testDialogTopSubDlg($api);
		echo $xml;
 		break;
 	case "testDynDialog":
		// JSON example
		$json = example_testDynDialog($api);
		echo $json;
 		break;
 	case "testDialogLeft":
		// JSON example
		$json = example_testDialogLeft($api);
		echo $json;
		break;
	case "testDialogRight":
		// HTML example
		$strHtml = example_testDialogRight($api);
		echo $strHtml;
		break;
	case "testDialogEditor":
		// XOL example with Editor
		$xml = example_testDialogEditor($api);
		echo $xml;
		break;
	case "testDialogAccordionEditor":
		// XOL example with Editor/Accordion
		$xml = example_testDialogAccordionEditor($api);
		echo $xml;
		break;
	case "testDialogWithContentAndButtons":
		// XML example with Editor/Accordion and complete XML structure
		$xml = example_testDialogWithContentAndButtons($api);
		echo $xml;
		break;
	case "testMenu":
		// XML example for new Menu
		$xml = example_testMenu($api);
		echo $xml;
		break;
	default:
		//sleep(5);
		print '<script type="text/javascript">alert(\'finished, jrcmsexample.php\')</script><pre>'.
		insertPostedValuesInDb('xtable',array('uid')).'</pre>';
	}

} else {

	print_r("jrcmsexample.php with wrong parameter called!!");
	
}
$api = NULL;
flush(); // send really out all stuff
?>