<?php
/**
 * This module processes all tasks regarding Menu and User
 *
 * @package JRCMS
 * @author Jens Raabe <jens@raabe-berlin.de
 * @version $Id: jrcmsmenu.php 600 2011-09-13 11:04:40Z jensraabe $
 *  
 * @copyright Copyright (c) 2008,2009, Jens Raabe (MIT)
 * 
 * Permission is hereby granted, free of charge, to any person 
 * obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included 
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR 
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
 
// set some headers values
header("Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . " GMT" ); 
header("Content-Type: text/plain; charset=utf-8");
header("Connection: close");
// set header
session_cache_limiter( 'nocache' ); //Expires, Cache-Control, Pragma
// start session
session_start(); 
// usage of classes
require_once('../../../conf/cConfig.php');
//global language values
CONFIG::loadLanguage();
//language support of plugin
require_once(('lang/lang.'.$_SESSION["language"]));
$lang_php = array_merge($lang_mnu, $lang_php);
CONFIG::loadClasses();
CONFIG::loadScripts();
// retrieve parameter
if(isset($_GET['a'])) {$act = $_GET['a'];} else {if(isset($_POST['a'])) {$act = $_POST['a'];} else {$act=NULL;}}


// ------------------------------
// Database routines
// ------------------------------

	/**
 	 * Get general CMS Data
 	 * 
 	 * @param 
 	 * @access
 	 * @return html string
 	 */

	function getGeneralData() {
		$api = new JRCMSAPI();
		if($api->checkTable(CONFIG::sql_tbl_gData) === TRUE) {

			$result = $api->getSingleValueFromDb("gd.*", CONFIG::sql_tbl_gData." AS gd",
								((isset($_SESSION["language"]))?("gd.lang = '".$_SESSION["language"]."'"):("1")));

			return ((is_array($result))?($result):(False));
			
		}	
		return FALSE;
	} // getGeneralData

// ------------------------------
// General routines
// ------------------------------

	/**
 	 * provides item edit menu 
 	 * 
 	 * @param array $data, int $item_id 
 	 * @access private
 	 * @return html string
 	 */
	function editMenuItemValues($data, $menuDiv=NULL, $act=NULL){
		
		global $lang_php;
		$us = new USER();
		$j = new JRCMS();
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		$divConsts = Array(CONFIG::divHMenu, CONFIG::divVMenu, CONFIG::divRMenu, CONFIG::divPupMenu, CONFIG::divRContent);
		//Header
		$strHtml = '<p><b>'.$lang_php['mnu_mnt'].' - ';
		$strHtml.= (($act == 'insert_menu_item' || $act == 'insert_menu_node')?($lang_php['insert'].'</b>'):($lang_php['edit'].'</b> <small>('.$data[0]['id'].')</small>')).'<br />';
		//... where we are;
		$strHtml.= $j->get_menu_path_html((($act == 'insert_menu_item' || $act == 'insert_menu_node')?($data[0]['id']):($data[0]['id'])),$data[0]['htmlDiv']).'</p><br />';
		$strHtml.= '<form name="editMenuItemform" class="menuformular" action="">';
		$strHtml.= '<input type="hidden" id="ul" name="ul" value="'.$ul.'" />';
		//row 1
		$strHtml.= '<input type="hidden" id="ilabel_old" name="ilabel_old" value="'.$data[0]['label'].'" />';
		$strHtml.= '<label class="menuleftonly fll" for="ilabel">'.$lang_php['mnu_label'].' : </label>';
		$strHtml.= '<input class="menuleftonly nf" type="text" tabindex="1" maxLength="50" size="50" border="1" id="ilabel" name="ilabel" height="10" value="'.$data[0]['label'].'" /><br />';
		//$strHtml.= '&nbsp;<br />';
		//determine menu types
		if(isset($act) && ($act == 'insert_menu_item' || $act == 'insert_menu_node') && isset($menuDiv)){
			switch ($menuDiv){
				case CONFIG::divHMenu:
					//define main menu 'menu' and all other sub menus to be initialized (root element)
					$strHtml.= '<span style="visibility:hidden;"><label class="menuleftonly fll" for="menu">Init Roots:</label>';
					$strHtml.= '<input type="checkbox" class="chkbox" id="menu" value="'.CONFIG::divVMenu.'" checked="checked" />'.CONFIG::divVMenu.'  ';
					$strHtml.= '<input type="checkbox" class="chkbox" name="submenu" value="'.CONFIG::divRContent.'" checked="checked" />'.CONFIG::divRContent;
	    			$strHtml.= '</span><br />';
					break;
				case CONFIG::divVMenu:
					//define main menu 'menu' and all other sub menus to be initialized (root element)
					$strHtml.= '<span style="visibility:hidden;"><label class="menuleftonly fll" for="submenu">Init Roots:</label>';
					$strHtml.= '<input type="hidden" class="chkbox" id="menu" value="'.CONFIG::divVMenu.'" checked="checked" />';
					$strHtml.= '<input type="checkbox" class="chkbox" name="submenu" value="'.CONFIG::divRMenu.'" checked="checked" />'.CONFIG::divRMenu.'  ';
	    			$strHtml.= '<input type="checkbox" class="chkbox" name="submenu" value="'.CONFIG::divPupMenu.'" checked="checked" />'.CONFIG::divPupMenu.'  ';
	    			$strHtml.= '<input type="checkbox" class="chkbox" name="submenu" value="'.CONFIG::divRContent.'" checked="checked" />'.CONFIG::divRContent;
	    			$strHtml.= '</span><br />';
					//to ensure correct processing retrieve available roots for new element
					if(($divRoot = $j->get_menu_root('allRoots',$data[0]['root']))!==NULL && !empty($divRoot)){
						$strHtml.= '<label class="menuleftonly fll" for="newmenu">Item Type : </label>';
						foreach($divRoot as &$value) {
							if($value['htmlDiv']!= CONFIG::divRContent || ($value['htmlDiv']== CONFIG::divRContent && (count($j->get_menu_brunch(-1, $value['htmlDiv'], $data[0]['root'], '999'))<=0))){ 
								$strHtml.= '<input class="fll" type="radio" class="chkbox" name="newmenu" value="'.$value['htmlDiv'].'" />'.$value['htmlDiv'].'  ';
								$strHtml.= '<input type="hidden" name="'.$value['htmlDiv'].'" value="'.(($value['htmlDiv'] == CONFIG::divVMenu)?($data[0]['id']):($value['rootId'])).'" />';
							}
						}
	    				$strHtml.= '<span class="nf"></span><br />';
					}
					break;
				case 'specialMenus':
					//to ensure correct processing retrieve available roots for new element
					if(($divRoot = $j->get_menu_root('allRoots',$data[0]['root']))!==NULL && !empty($divRoot)){
						$strHtml.= '<label class="menuleftonly fll" for="newmenu">Node Type : </label>';
						foreach($divRoot as &$value) {
							if($value['htmlDiv']!= CONFIG::divRContent || ($value['htmlDiv']== CONFIG::divRContent && (count($j->get_menu_brunch(-1, $value['htmlDiv'], $data[0]['root'], '999'))<=0))){ 
								$strHtml.= '<input class="fll" type="checkbox" class="chkbox" name="newmenu" value="'.$value['htmlDiv'].'" />'.$value['htmlDiv'].'  ';
								$strHtml.= '<input type="hidden" name="'.$value['htmlDiv'].'" value="'.$value['rootId'].'" />';
							}
						}
	    				$strHtml.= '<span class="nf"></span><br />';
					}
					break;
				default:
					;
			}
		}
		$strHtml.= '<hr /><br />';
		//row 2
		$strHtml.= '<label class="menuleft fll" for="mnutype">'.$lang_php['mnu_type'].' : </label>';
		$strHtml.= '<select class="menuleft fll" id="mnutype" name="mnutype" onChange="jrCmsMenu.getProcedures({a:\'getProcedures\'}, this)">';
		$strHtml.= '<option value="0">--'.$lang_php['pselect'].'--</option>';
		$selType = NULL;
		if (($ptype = $j->get_proc_types_and_procs($ul)) !== FALSE) {
			foreach($ptype as &$value) {
				$strHtml.= '<option value="'.$value['type'].'"';
				if (isset($data) && is_array($data) && isset($data[0]['type'])) {
					if ($data[0]['type'] == $value['type']) {
						$strHtml.= ' selected="selected"';
						$selType = $value['type'];
					}
				}
				$strHtml.= '>'.$value['type'].'</option>';
			}
		}
		$strHtml.= '</select>';
		$strHtml.= '<input type="hidden" id="type_old" name="type_old" value="'.$data[0]['type'].'" />';
		$strHtml.= '<label class="menuright fll" for="proctype">'.$lang_php['mnu_proc'].' : </label>';
		$strHtml.= '<select class="menuright nf" id="proctype" name="proctype">';
		$strHtml.= '<option value="0">--'.$lang_php['pselect'].'--</option>';
		if (isset($selType)) {
			if (($proc = $j->get_proc_types_and_procs($ul, $selType)) !== FALSE && !empty($proc)) {
				foreach($proc as &$value) {
					$strHtml.= '<option value="'.$value['xtpID'].'"';
					if (isset($data) && is_array($data) && isset($data[0]['procName'])) {
						if ($data[0]['procName'] == $value['procName']) {
							$strHtml.= ' selected="selected"';
						}
					}
					$strHtml.= '>'.$value['procName'].'</option>';
				}
			}
		}
		$strHtml.= '</select>';
		$strHtml.= '<input type="hidden" id="proc_old" name="proc_old" value="'.$data[0]['procName'].'" /><br />';
		//row 3
		$strHtml.= '<label class="menuleftonly fll" for="saction">'.$lang_php['mnu_sact'].' : </label>';
		$strHtml.= '<input class="menuleftonly nf" type="text" tabindex="1" maxLength="250" size="50" border="1" id="saction" name="saction" height="10" value="'.$data[0]['sact'].'" /><br />';
		$strHtml.= '<input type="hidden" id="saction_id" name="saction_id" value="'.$data[0]['said'].'" />';
		$strHtml.= '<input type="hidden" id="saction_old" name="saction_old" value="'.$data[0]['sact'].'" />';
		$strHtml.= '&nbsp;<br />';
		//row 4
		$strHtml.= '<label class="menuleftonly fll" for="userlevel">'.$lang_php['u_level'].' : </label>';
		$strHtml.= '<select class="menuleftonly nf" id="userlevel" name="userlevel">';
		$strHtml.= '<option value="0">--'.$lang_php['pselect'].'--</option>';
		if (($ultyp = $us->get_userlevels(False)) !== FALSE) {
			foreach($ultyp as &$value) {
				// it would be better using the id =:-), but nevertheless
				$strHtml.= '<option value="'.$value['ul'].'"';
				if (isset($data) && is_array($data) && isset($data[0]['ul'])) {
					if ($data[0]['ul'] == $value['ul']) {
						$strHtml.= ' selected="selected"';
					}
				}
				$strHtml.= '>'.$value['description'].'</option>';
			}
		}
		$strHtml.= '</select>';
		//$strHtml.= '<input style="padding-left: 2px;" type="text" tabindex="4" maxLength="1" size="3" border="1" id="mul" name="mul" height="10" value="'.$data[0]['ul'].'" /></span><br />';
		$strHtml.= '<input type="hidden" id="mul_old" name="mul_old" value="'.$data[0]['ul'].'" />';
		$strHtml.= '&nbsp;<br />';
		//row package 5 for css and additional data
		$css_data = isset($data[0]['cssid'])?$j->get_style_data($data[0]['cssid']):NULL;
		$strHtml.= '<input type="hidden" id="cssid" name="cssid" value="'.$data[0]['cssid'].'" />';
		if(isset($css_data)){
			foreach ($css_data[0] as $key => $property) {
				if ($key != 'cssid') {
					switch ($key) {
					case 'mnu_css':
						$prop_dsp = $lang_php['mnu_css'];
						$strHtml.= '<label class="menuleftonly fll" for="mnu_css">'.$lang_php['mnu_css'].' : </label>';
						$str = (isset($property))?(utf8_decode($property)):("none");
						$strHtml.= '<textarea class="menuleftonly nf" tabindex="20" cols="77" rows="2" border="1" id="mnu_css" name="mnu_css"';
						$strHtml.= '>'.$str.'</textarea><br />';
						break;
					default:
						$property = (!isset($property) || $property == "none")?(""):($property);
						$prop_dsp = $key;
						$strHtml.= '<label class="menuleftonly fll" for="'.$prop_dsp.'">'.$prop_dsp.' : </label>';
						$strHtml.= '<input class="menuleftonly nf" type="text" tabindex="4" maxLength="250" size="3" border="1" id="'.$key.'" name="'.$key.'" height="10" value="'.$property.'" /><br />';
					}
				}
			}		
		}else{
			//provide at least an empty field
			$strHtml.= '<label class="menuleftonly fll" for="mnu_css">'.$lang_php['mnu_css'].' : </label>';
			$strHtml.= '<textarea class="menuleftonly nf" tabindex="20" cols="77" rows="3" border="1" id="mnu_css" name="mnu_css"';
			$strHtml.= '>none</textarea><br />';
		}
		//row 6
		$strHtml.= '<label class="menuleftonly fll" for="content">'.$lang_php['mnu_cont'].': </label>';
		$str = (isset($data[0]['content']))?(utf8_decode($data[0]['content'])):("none");
		$strHtml.= '<textarea class="menuleftonly nf" tabindex="20" cols="77" rows="1" border="1" id="content" name="content"';
		// prevent changes in content pages
		if ($data[0]['type'] == 'editor' || $data[0]['type'] == 'aeditor') {
			$strHtml.= 'readonly="readonly"';
		}
		$strHtml.= '>'.$str.'</textarea><br />';
		$strHtml.= '</form><br />';
			
		return $strHtml;
	} // editMenuItem


// ------------------------------

	/**
 	 * provides procedures of task types 
 	 * 
 	 * @param global
 	 * @access private
 	 * @return html string
 	 */

	function getProcedures(){

		global $lang_php;
		$m = new MENU();
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');

		if(isset($_GET['t'])) {$type = $_GET['t'];} else {if(isset($_POST['t'])) {$type = $_POST['t'];} else {$type='none';}}

		$strHtml = '<option value="0">--'.$lang_php['pselect'].'--</option>';
		if (isset($type)) {
			if (($proc = $m->get_proc_types_and_procs($ul, $type)) !== FALSE) {
				foreach($proc as &$value) {
					$strHtml.= '<option value="'.$value['xtpID'].'"';
					$strHtml.= '>'.$value['procName'].'</option>';
				}
			}
		}
		return $strHtml;
	} // get_procedures


// ------------------------------
// Menu
// ------------------------------

	/**
 	 * provides menu structure as Html list 
 	 * 
 	 * @param global
 	 * @access global
 	 * @return html string
 	 */
	function getMenuList(){
		
		global $lang_php;
		$j = new JRCMS();
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}

		$divArray = ($div=='specialMenus')
						?(array(CONFIG::divPupMenu, CONFIG::divRMenu, CONFIG::divRContent))
						:((($div==CONFIG::divVMenu && $id < 0)?(array($div, CONFIG::divRContent)):(array($div))));

		try{
			// retrieve all data of given parameter
			$strHtml = '<b>'.$lang_php['mnu_mnt'].'</b><br />&nbsp;<br />';
			$strHtml.= '<div id="divMenuList">';
			$strHtml.= '<div id="divScrollField"><ul>';
			foreach($divArray as &$htmlDiv) {
				$data = $j->get_menu_brunch($id, $htmlDiv, $root, $ul, TRUE);
				if(isset($data) && is_array($data) && !empty($data)) {
					foreach ($data as &$menu) {
						if( strcmp($menu['label'],"ROOT")!=0) {
							$strHtml.= ($menu['id']==$id)?('<li class="selectedMenuItem">'):('<li class="menuItem">');
							$strHtml.= '<span onclick="jrCmsMenu.getMaintButtons({root:'.$menu['rootId'].',id:'.$menu['id'].',cssid:'.$menu['cssid'].',a:\'getMaintButtons\',div:\''.$htmlDiv.'\'}); return false;">';
							$strHtml.= '<div class="mnuleft fll">'.strRepeat('&#160;&#160;',(int)$menu['LEVEL']*2).$menu['label'];
							$strHtml.= ($htmlDiv == CONFIG::divHMenu || $htmlDiv == CONFIG::divVMenu)?('</div><div class="nf"></div></span></li>'):('</div><div class="mnuright fll">&gt;'.$htmlDiv.'&lt;</div><div class="nf"></div></span></li>');
						}
					}
				}
			}
			$strHtml.= '</ul></div>';
			$strHtml.= '</div>';
			
			return $strHtml;
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmsmenu.getMenuList] failure!"; //TODO:		
		}
	} //getMenuList
	
// ------------------------------
	
	/**
 	 * provides menu structure as Html list 
 	 * 
 	 * @param global
 	 * @access global
 	 * @return html string
 	 */
	function getMaintButtons($parentOnly=False){
		global $lang_php;
		$j = new JRCMS();
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=1;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}

		try{
			//assigne language variables
			$edit=$lang_php['edit'];
			$del=$lang_php['del'];
			$up=$lang_php['mnu_move_up'];
			$down=$lang_php['mnu_move_dw'];
			$insert=$lang_php['insert'];
			$open="Open";
			//
			if($parentOnly){
				if($div!=CONFIG::divHMenu){ 
					$parentDiv = ($div!=CONFIG::divVMenu)?(CONFIG::divVMenu):(CONFIG::divHMenu);
					if(($data = $j->get_menu_parent_id($root,$div)) !== NULL) $proot = $data[0]['id'];
					else $proot = 1;

					//task: FOLDER UP = index 9
					$buttonlst = array( 8 => "jrCmsMenu.getMenuContent({".(($parentDiv == CONFIG::divHMenu)?("root:1,"):("root:".$proot.","))." id:-1,cssid:".$cssid.",a:'getMenuList',div:'".$parentDiv."'}); return false;");
				}	
				//determine root, i.e. parent ID
				if(($data = $j->get_menu_root($div,(($div==CONFIG::divVMenu ||$div=='specialMenus')?$root:NULL))) !== False) 
					$id = $data[0]['rootId'];			
				//task: NEW = index 0
				$buttonlstInsert = array( 0 => "jrCmsMenu.processMenuItem({root:".$root.",id:".$id.",a:'".(($div == 'specialMenus')?('insert_menu_item'):('insert_menu_node'))."',div:'".$div."'}); return false;");
				$buttonlst = isset($buttonlst) ? ($buttonlstInsert + $buttonlst) : $buttonlstInsert;
							
			} else {
				// retrieve all data of given parameter
				$data = $j->get_menu_item_data($id, NULL, '', $ul);
				if(isset($data) && is_array($data) && !empty($data)) {
					foreach ($data as &$menu) {
						if( strcmp($menu['label'],"ROOT")!=0 && $ul >= $menu['ul']) {

							$buttonlst = array( 
								//task: EDIT = index 1
								1 => "jrCmsMenu.processMenuItem({root:".$menu['rootId'].",id:".$menu['id'].",cssid:".$menu['cssid'].",a:'editMenuItem',div:'".$div."'}); return false;",
								//task: DELETE = index 3
								3 => "jrCmsMenu.processMenuItem({root:".$menu['rootId'].",id:".$menu['id'].",cssid:".$menu['cssid'].",a:'deleteMenuItem',div:'".$div."'}); return false;",
								//task: UP = index 5
								5 => "jrCmsMenu.processMenuItem({root:".$menu['rootId'].",id:".$menu['id'].",cssid:".$menu['cssid'].",a:'moveMenuItemUp',div:'".$div."'}); return false;",
								//task: DOWN = index 6
								6 => "jrCmsMenu.processMenuItem({root:".$menu['rootId'].",id:".$menu['id'].",cssid:".$menu['cssid'].",a:'moveMenuItemDown',div:'".$div."'}); return false;"
								);
							//check for open submenu
							if($menu['htmlDiv']!=CONFIG::divPupMenu && $menu['htmlDiv']!=CONFIG::divRMenu && 
								$menu['htmlDiv']!=CONFIG::divRContent){
								$subDiv = ($menu['htmlDiv']==CONFIG::divHMenu)?(CONFIG::divVMenu)
											:($menu['htmlDiv']==CONFIG::divVMenu ? ('specialMenus') : CONFIG::divHMenu);

								$buttonlstDw = array(
								//task: FOLDER DOWN = index 9
								9 => "jrCmsMenu.getMenuContent({root:".$menu['id'].",id:-1,cssid:".$menu['cssid'].",a:'getMenuList',div:'".$subDiv."'}); return false;"
								);
							}
							//check for open parent menu
							if($menu['htmlDiv']!=CONFIG::divHMenu){
								$parentDiv = ($menu['htmlDiv']!=CONFIG::divVMenu)?(CONFIG::divVMenu):(CONFIG::divHMenu);
								if(($data = $j->get_menu_parent_id($root,$parentDiv)) !== NULL) $proot = $data[0]['id'];
								else $proot = 1;

								$buttonlstUp = array(
								//task: FOLDER UP = index 8
								8 => "jrCmsMenu.getMenuContent({root:".$proot.", id:-1,cssid:".$menu['cssid'].",a:'getMenuList',div:'".$parentDiv."'}); return false;"
								);
							}
							//check for insert
							if($menu['htmlDiv']!=CONFIG::divRContent && $menu['htmlDiv']!=CONFIG::divHMenu){

								$buttonlstInsert = array(
								//task: NEW = index 0
								0 => "jrCmsMenu.processMenuItem({root:".$menu['rootId'].",id:".$menu['id'].",a:'".(($div == 'specialMenus')?('insert_menu_item'):('insert_menu_node'))."',div:'".$div."'}); return false;"
								); 
							}
							//sequence of buttons
							if(isset($buttonlstInsert))$buttonlst = $buttonlst + $buttonlstInsert;
							if(isset($buttonlstDw))$buttonlst = $buttonlst + $buttonlstDw;
							if(isset($buttonlstUp))$buttonlst = $buttonlst + $buttonlstUp;
						}
					}
				}
			}
			return isset($buttonlst)?($buttonlst):(NULL);
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmsmenu.getMaintButtons] failure!"; //TODO:
		}
	} //getMaintButtons
	
// ------------------------------

	/**
 	 * edit menu item 
 	 * 
 	 * @param global
 	 * @access global
 	 * @return html string
 	 */
	function editMenuItem(){

		global $lang_php;
		$j = new JRCMS(); 
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=0;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		$strHtml = '';		
		
		try{
			// retrieve item data
			$data = $j->get_menu_item_data($id, NULL, '', $ul);
			
			if (isset($data) && is_array($data)) {
	
				$strHtml = editMenuItemValues($data);
				
				$save = $lang_php['save'];
			}
			return $j->resp_cont_xml($strHtml,$j->conv_task_html('maint',
				($div != CONFIG::divRContent)
				? array( 2 => "jrCmsMenu.saveMenuItem({root:".$root.",id:".$id.",cssid:".$cssid.",a:'saveMenuItem',div:'".$div."'}); return false;")
				: array( 1 => "jrCMS.getContent({root:".$root.",id:".$id.",cssid:".$cssid.",div:'".$div."',a:'getcntEditor'}); return false;",
						 2 => "jrCmsMenu.saveMenuItem({root:".$root.",id:".$id.",cssid:".$cssid.",a:'saveMenuItem',div:'".$div."'}); return false;"),
				(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))		 
				));
		}catch (MyException $e) {
			$e->log();
			return "[jrcmsmenu.editMenuItem] failure!"; //TODO:		
		}
	} // editMenuItem

// ------------------------------

	/**
 	 * insert menu item dialog 
 	 * 
 	 * @param global
 	 * @access global
 	 * @return html string
 	 */
	function insert_menu_item($act){
		
		global $lang_php;
		$j = new JRCMS(); 
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=0;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		$save = $lang_php['save'];
		
		try{
			//simulate new entry
			$data = array( 0 => array (
						 "id" => $id
						,"root" => $root
						,"htmlDiv" => $div
						,"label" => ""
						,"ul" => "000"
						,"type" => NULL
						,"procName" => NULL
						,"sact" => ""
						,"said" => 0
						,"cssid" => NULL
						,"content" => ""));
						
			$strHtml = editMenuItemValues($data,$div,$act);		

			return $j->resp_cont_xml($strHtml,$j->conv_task_html('maint',
							array(2 => "jrCmsMenu.saveMenuItem({root:".$root.",id:".$id.",a:'createMenuItem',div:'".$div."'}); return false;"),
							(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))
							));
						
		}catch (MyException $e) {
			$e->log();
			return "[jrcmsmenu.insert_menu_item] failure!"; //TODO:		
		}
	} // insert_menu_item
	

	
// ------------------------------

	/**
 	 * create menu item 
 	 * 
 	 * @param global
 	 * @access global
 	 * @return html string
 	 */
	function createMenuItem(){
		
		$j = new JRCMS(); 
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=0;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['l'])) {$label = $_GET['l'];} else {if(isset($_POST['l'])) {$label = $_POST['l'];} else {$label=NULL;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['subdiv'])) {$subdiv = (string)$_GET['subdiv'];} else {if(isset($_POST['subdiv'])) {$subdiv = (string)$_POST['subdiv'];} else {$subdiv=NULL;}}
		if(isset($_GET['cont'])) {$content = $_GET['cont'];} else {if(isset($_POST['cont'])) {$content = $_POST['cont'];} else {$content=NULL;}}
		
		try{
			if(isset($label)){
				// (1) insert new item
				if(($result = $j->insert_menu_node(str_replace('%#', '&#', preg_replace("/(\015\012)|(\015)|(\012)/",'',$label)), (int)$id, (int)$root, $div)) !== False){
					//create root entry of sub menu entries
					if(isset($subdiv)) $subdiv = json_decode(str_replace("\\",'',$subdiv));
					$res = $j->insert_sub_menu_root($div, $result, $subdiv);
					
					//only ID of insert to be used, remark do not use $div!
					$data = $j->get_menu_item_data($result,NULL,'',$ul);
					$_GET['id'] = $data[0]['id'];
					$_GET['cssid'] = $data[0]['cssid'];
					$_GET['said'] = $data[0]['said'];
					if($content == "" || $content == "none") {
						//delete transmitte parameter
						$_GET['cont'] = NULL; $_POST['cont'] = NULL;
					}
					$res = saveMenuItem();
				} 
			}		

			return $result;
		
			//TODO: return $j->resp_cont_xml($strHtml,$j->conv_task_html('maint',$buttonlst, (isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))));
		
		}catch (MyException $e) {
			$e->log();
			return "[jrcmsmenu.createMenuItem] failure!"; //TODO:		
		}
	} // createMenuItem
	

// ------------------------------

	/**
 	 * update menu item 
 	 * 
 	 * @param global
 	 * @access global
 	 * @return html string
 	 */
	function saveMenuItem(){

		$j = new JRCMS(); 
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=0;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['l'])) {$label = $_GET['l'];} else {if(isset($_POST['l'])) {$label = $_POST['l'];} else {$label=NULL;}}
		if(isset($_GET['tp'])) {$xtpID = $_GET['tp'];} else {if(isset($_POST['tp'])) {$xtpID = $_POST['tp'];} else {$xtpID=NULL;}}
		if(isset($_GET['u'])) {$sul = $_GET['u'];} else {if(isset($_POST['u'])) {$sul = $_POST['u'];} else {$sul=NULL;}}
		if(isset($_GET['cont'])) {$content = $_GET['cont'];} else {if(isset($_POST['cont'])) {$content = $_POST['cont'];} else {$content=NULL;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=NULL;}}
		if(isset($_GET['cssd'])) {$cssd = $_GET['cssd'];} else {if(isset($_POST['cssd'])) {$cssd = $_POST['cssd'];} else {$cssd=NULL;}}
		if(isset($_GET['mkey'])) {$mkey = $_GET['mkey'];} else {if(isset($_POST['mkey'])) {$mkey = $_POST['mkey'];} else {$mkey=NULL;}}
		if(isset($_GET['mdesc'])) {$mdesc = $_GET['mdesc'];} else {if(isset($_POST['mdesc'])) {$mdesc = $_POST['mdesc'];} else {$mdesc=NULL;}}
		if(isset($_GET['said'])) {$said = $_GET['said'];} else {if(isset($_POST['said'])) {$said = $_POST['said'];} else {$said=NULL;}}
		if(isset($_GET['sact'])) {$sact = $_GET['sact'];} else {if(isset($_POST['sact'])) {$sact = $_POST['sact'];} else {$sact='none';}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=NULL;}}

		try{
			$eStr = '';	
			// TODO: Consider CTC
			// first update the menu item
			if(($result = $j->update_menu_node($id, $root, $div, $sul, 
							str_replace('%#', '&#', preg_replace("/(\015\012)|(\015)|(\012)/",'',$label)),$xtpID)) !== False) {
				// update the content if necessary
				if(isset($content)) 
					if($j->update_menu_node_content($id, str_replace('%#', '&#', preg_replace("/(\015\012)|(\015)|(\012)/",'',$content))) === False ) 
						throw new MyException("update_menu_node_content failure");

				// update special action if necessary
				if($sact != 'none')
					if($j->update_special_action_data($said, str_replace('%#', '&#',$sact)) === False )
						throw new MyException("update_special_action_data failure");

				// update styles if necessary
				if(isset($cssid) && $result===True) 
					if($j->update_style_data($cssid, 
								(isset($cssd))?(str_replace('%#', '&#',$cssd)):(NULL),
								(isset($mkey))?(str_replace('%#', '&#',$mkey)):(NULL),
								(isset($mdesc))?(str_replace('%#', '&#',$mdesc)):(NULL)) === False )
						throw new MyException("update_style_data failure");
					
				
			} else {
				//failure updating menu item
				throw new MyException("update_menu_node failure");
			}
			// update access files
			if($result)	waccfile();
			return '';
			//return ($result)?(get_html_menu()):('failure while updating item');
		}catch (MyException $e) {
			$e->log();
			return "[jrcmsmenu.saveMenuItem] failure!"; //TODO:		
		}
	} // saveMenuItem

	
// ------------------------------

	/**
 	 * delete menu item 
 	 * 
 	 * @param global
 	 * @access global
 	 * @return html string
 	 */
	function deleteMenuItem(){

		$j = new JRCMS();
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=0;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=NULL;}}
		
		try{
			// delete item
			// TODO: consider CTC
			if(isset($root)){
				$result = $j->delete_menu_node((int)$id, (int)$root, $div);
			}
			
			$_GET['id'] = -1; $_POST['id'] = -1;
			$_GET['root'] = 1; $_POST['root'] = 1;
			$_GET['div'] = NULL; $_POST['div'] = NULL;
			
			// update access files
			waccfile();
			
			return getMenuList();
			
		}catch (MyException $e) {
			$e->log();
			return "[jrcmsmenu.deleteMenuItem] failure!"; //TODO:		
		}
	} // deleteMenuItem
	
// ------------------------------

	/**
 	* move menu item up
 	* 
 	* @param global
 	* @access global
 	* @return Html string
 	*/
	function moveMenuItemUp(){

		$j = new JRCMS();;
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=NULL;}}
		
		$result = $j->move_menu_node((int)$id, (int)$root, $div, 'up');

		return ($result)?(getMenuList()):('failure while moving item up');
	}

// ------------------------------

	/**
 	* move vertical menu item down
 	* 
 	* @param global
 	* @access global
 	* @return Html string
 	* @author Jens Raabe <jens@raabe-berlin.de>
 	*/
	function moveMenuItemDown(){

		$j = new JRCMS();;
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=NULL;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=NULL;}}
		
		$result = $j->move_menu_node((int)$id, (int)$root, $div, 'down');

		return ($result)?(getMenuList()):('failure while moving item down');

	}

// ------------------------------
// TODO: .htaccess
// ------------------------------

	/**
 	* provides the menu data
 	* 
 	* @param 
 	* @access private
 	* @return json string
 	* @author Jens Raabe <jens@raabe-berlin.de>
 	*/
	function waccfile(){
		
		$m = new MENU();
		$ht_txt = "";
		$site_xml = "";
		$hmenulst = $m->get_menu_brunch(-1, CONFIG::divHMenu, 0, '000');
		if (isset($hmenulst) && is_array($hmenulst)) {
			//1.1 htaccess with RetrieveEngine
			$ht_txt.= "RewriteEngine on\n";
			//2.1 sitemap XML
			$site_xml = new DOMDocument('1.0', 'UTF-8');
			$site_xml->formatOutput = TRUE;
			$site_xml->createComment("Sitemap of ".CONFIG::title. " (c) Jens Raabe ".date("Y"));
			$site_xml_root = $site_xml->appendChild($site_xml->createElement('urlset'));
			$site_xml_root->setAttribute("xmlns","http://www.sitemaps.org/schemas/sitemap/0.9");
			$site_xml_root->setAttribute("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
			$site_xml_root->setAttribute("xsi:schemaLocation","http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd");
			//3.1 sitemap HTML
			$site_html = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
			$site_html.= '<html><head>';
			$site_html.= '<title>Sitemap of '.CONFIG::title.'</title>';
			$site_html.= '<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />';
			$site_html.= '<link rel="stylesheet" type="text/css" href="'.'http://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath.'/css/sitemap.css" />';
			$site_html.= '</head><body class="iFContent" >';
			$site_html.= '<h2>Site Map</h2>';
			$site_html.= '<h3><a href="'.'http://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath.'" target="_blank">of '.CONFIG::title.'</a></h3>';
			$site_html.= 'Last updated: '.date("r");
			$site_html.= '<br /><br />';
			$site_html.= '<table cellpadding="0" border="0">';
			$root_no = count($hmenulst);
			foreach($hmenulst as &$rootvalue) {
				$root_no--;
				if( $rootvalue['id'] > 1 ) {
//TODO: muss komplett neu gemacht werden
//					$parm = (CONFIG::codeSP == 'false')?
//										($rootvalue['classId'].CONFIG::rRDelim.$rootvalue['id'].",-1,".$rootvalue['cssid']):
//										(base64_encode($rootvalue['classId']."?".$rootvalue['id'].",-1,".$rootvalue['cssid']));
//					$label = str_replace(' ', '_', entities2char(CONFIG::rRPfx.$rootvalue['label'])).".html";
//					//1 == data htaccess
//					$ht_txt.= "RewriteRule ".$label." ".'http://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath."/".CONFIG::rRTarget."?rr=".$parm." ";
//						// finish xh line
//					if (($root_no+$id_no) > 0) {$ht_txt.= (CONFIG::rRCtrl!="")?("[".CONFIG::rRCtrl."]\n"):("\n");}
//					else {$ht_txt.=(CONFIG::rRCtrl!="")?("[".CONFIG::rRCtrl.",L]\n"):("[L]\n");}
//TODO: Zwischenlsung
					$parm = '/index.php#'.$rootvalue['classId'].'?{root:0,id:'.$rootvalue['id'].',cssid:'.$rootvalue['cssid'].'}';
					//2 == data sitemap XML
					$site_xml_url = $site_xml_root->appendChild($site_xml->createElement('url'));
//TODO:				$site_xml_url->appendChild($site_xml->createElement('loc','http://'.$_SERVER['HTTP_HOST']."/".$label));
					$site_xml_url->appendChild($site_xml->createElement('loc','http://'.$_SERVER['HTTP_HOST'].$parm));
					$site_xml_url->appendChild($site_xml->createElement('priority',"1.00"));
					//3 == data sitemap HTML
//TODO:				$site_html.= '<tr><td><a href="'.'http://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath.'/'.$label.'">'.entities2char(CONFIG::rRPfx.$rootvalue['label']).'</a></td></tr>';
					$site_html.= '<tr><td><a href="'.'http://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath.$parm.'" target="_blank">'.entities2char(CONFIG::rRPfx.$rootvalue['label']).'</a></td></tr>';
					// inner loop for vertical menu
					$vmenulst = $m->get_menu_brunch(-1, CONFIG::divVMenu, $rootvalue['id'], '000');
					$id_no = count($vmenulst);
					if ($id_no > 0) {
						foreach($vmenulst as &$idvalue) {
							$id_no--;
							if( strcmp($idvalue['label'],"ROOT")!=0) {
//TODO: muss komplett neu gemacht werden
//								$parm = (CONFIG::codeSP == 'false')?
//													($idvalue['classId'].CONFIG::rRDelim.$rootvalue['id'].",".$idvalue['id'].",".$idvalue['cssid']):
//													(base64_encode($idvalue['classId']."?".$rootvalue['id'].",".$idvalue['id'].",".$idvalue['cssid']));
//								$label = str_replace(' ', '_', entities2char(CONFIG::rRPfx.$rootvalue['label']))."/".str_replace(' ', '_', entities2char(CONFIG::rRPfx.$idvalue['label'])).".html";
//								//1 == data htaccess
//								$ht_txt.= "RewriteRule ".$label." ".'http://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath."/".CONFIG::rRTarget."?rr=".$parm." ";
//								if (($root_no+$id_no) > 0) {$ht_txt.= (CONFIG::rRCtrl!="")?("[".CONFIG::rRCtrl."]\n"):("\n");}
//								else {$ht_txt.=(CONFIG::rRCtrl!="")?("[".CONFIG::rRCtrl.",L]\n"):("[L]\n");}
//TODO: Zwischenlsung
								$parm = '/index.php#'.$idvalue['classId'].'?{root:'.$rootvalue['id'].',id:'.$idvalue['id'].',cssid:'.$idvalue['cssid'].'}';
								//2 == data sitemap XML
								$site_xml_url = $site_xml_root->appendChild($site_xml->createElement('url'));
//TODO:							$site_xml_url->appendChild($site_xml->createElement('loc','http://'.$_SERVER['HTTP_HOST']."/".$label));
								$site_xml_url->appendChild($site_xml->createElement('loc','http://'.$_SERVER['HTTP_HOST'].$parm));
								$site_xml_url->appendChild($site_xml->createElement('changefreq',"monthly"));
								$site_xml_url->appendChild($site_xml->createElement('priority',"0.80"));
								//3 == data sitemap HTML
//TODO:							$site_html.= '<tr><td><a href="'.'http://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath.'/'.$label.'" target="_blank">'.entities2char(CONFIG::rRPfx.$idvalue['label']).'</a></td></tr>';
								$site_html.= '<tr><td><a href="'.'http://'.$_SERVER['HTTP_HOST'].CONFIG::srcPath.$parm.'" target="_top"> + '.entities2char(CONFIG::rRPfx.$idvalue['label']).'</a></td></tr>';
							}
						}
					}
				}
			}
			
//TODO: muss komplett neu gemacht werden
//			//1.2. retrieve the standard content from DB
//			$result = getGeneralData($api);
//			if (isset($result) && $result !== False && $result[0]['htaccess'] != "") {
//				$ht_txt.= "\n".$result[0]['htaccess'];
//			}
		}
//TODO: muss komplett neu gemacht werden
//		//1 write data
//		if (CONFIG::rEngine == "on" && $ht_txt != "") {
//			$htaccess = fopen("../../../.htaccess","w");
//			fputs($htaccess, $ht_txt);
//			fclose($htaccess);
//		}
		//2 write data in file
		$ignore_response = $site_xml->save("../../../sitemap.xml");
		//3 write data in file
		$site_html.= '</table></body></html>';
		$site_html_f = fopen("../../../sitemap.html","w");
		fputs($site_html_f, $site_html);
		fclose($site_html_f);
	}


// ############## MAIN ##############
// calling functions of jrcmsmenu.php
$j = new JRCMS();
if (isset($act)) {
	switch ($act) {
	case "getMenuList":
		// retrieves the list of all menu items
		$strXml = $j->resp_xml($j->resp_cont_xml(getMenuList(),
								((getMaintButtons(True)!=NULL) ? $j->conv_task_html('maint',getMaintButtons(True),(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))) : (' '))));
		echo $strXml;
		break;
	case "getMaintButtons":
		$strXml = $j->resp_xml($j->resp_cont_xml(getMenuList(),$j->conv_task_html('maint',getMaintButtons(),(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon')))));
		echo $strXml;
		break;
	case "editMenuItem":
		$strXml = $j->resp_xml(editMenuItem());
		echo $strXml;
		break;
	case "insert_menu_node":
	case "insert_menu_item":
		$strXml = $j->resp_xml(insert_menu_item($act));
		echo $strXml;
		break;
	case "createMenuItem":
		//$strXml = $j->resp_xml(createMenuItem());
		$str = createMenuItem();
		echo $str;
		break;
	case "saveMenuItem":
		//$strXml = $j->resp_xml(createMenuItem());
		$str = saveMenuItem();
		echo $str;
		break;
	case "deleteMenuItem":
		$strXml = $j->resp_xml($j->resp_cont_xml(deleteMenuItem(),
								((getMaintButtons(True)!=NULL) ? $j->conv_task_html('maint',getMaintButtons(True),(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))) : (' '))));
		echo $strXml;
		break;
	case "moveMenuItemUp":
		$strXml = $j->resp_xml($j->resp_cont_xml(moveMenuItemUp(),
								((getMaintButtons(True)!=NULL) ? $j->conv_task_html('maint',getMaintButtons(True),(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))) : (' '))));
		echo $strXml;
		break;
	case "moveMenuItemDown":
		$strXml = $j->resp_xml($j->resp_cont_xml(moveMenuItemDown(),
								((getMaintButtons(True)!=NULL) ? $j->conv_task_html('maint',getMaintButtons(True),(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))) : (' '))));
		echo $strXml;
		break;
	case "getProcedures":
		// get procedures for ajax processing
		$strHtml = getProcedures();
		echo $strHtml;
		break;
	case "siteMap":
		//generate sitemap
		waccfile();
		break;		
	default: 
		print_r("jrcmsmenu.php with wrong action called!!");
	}

} else {

	print_r("jrcmsmenu.php with wrong parameter called!!");
	
}
$j = NULL;
flush(); // send really out all stuff
?>