<?php
/**
 * This module processes all tasks regarding reports
 *
 * @package: jrCmsReports
 * @author Jens Raabe <jens@raabe-berlin.de>
 * @version $Id: jrcmsreports.php 584 2011-08-11 07:52:25Z ctna0371 $
 *
 * @copyright Copyright (c) 2009, Jens Raabe (MIT)
 * license: MIT-style license, see jrcms.js
 */
 
// set some headers values
header("Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . " GMT" ); 
header("Content-Type: text/plain; charset=utf-8");
header("Connection: close");
// set header
session_cache_limiter( 'nocache' ); //Expires, Cache-Control, Pragma
// start session
session_start(); 
// usage of classes
require_once('../../../conf/cConfig.php');
//global language values
CONFIG::loadLanguage();
//language support of plugin
require_once(('lang/lang.'.$_SESSION["language"]));
$lang_php = array_merge($lang_rpt, $lang_php);
CONFIG::loadClasses();
CONFIG::loadScripts();
//retrieve parameter
if(isset($_GET['a'])) {$act = $_GET['a'];} else {if(isset($_POST['a'])) {$act = $_POST['a'];} else {$act=NULL;}}
define("sql_tbl_reports", 'web_reports');									// database table
define("default_thumbnail", 'src/plugins/jrcmsreports/images/buch.gif');	// default thumbnail of reports
define("reports_content_length", 1000);										// length of content retrieved for the list
$reportTaskList = array(
					0 => array(
						// Task: NEW
						"script" => Null,
						"id" => "task_new"),
					1 => array(
						// Task: EDIT
						"script" => Null,
						"id" => "task_edit"),
					2 => array(
						// Task: VIEW
						"script" => Null,
						"id" => "task_view"),
					3 => array(
						// Task: SAVE
						"script" => Null,
						"id" => "task_save"),
					4 => array(
						// Task: DELETE
						"script" => Null,
						"id" => "task_trash"),
					5 => array(
						// Separator
						"script" => '##',
						"id" => NULL),
					6 => array(
						// Task: MOVE UP
						"script" => NULL,
						"id" => "task_up"),
					7 => array(
						// Task: MOVE DOWN
						"script" => NULL,
						"id" => "task_down"),
					8 => array(
						// Task: COPY
						"script" => NULL,
						"id" => "task_copy"),
					9 => array(
						// Separator
						"script" => '##',
						"id" => NULL),
					10 => array(
						// Task: Help
						"script" => NULL,
						"id" => "task_help")
					);

// ------------------------------
// Utilities
// ------------------------------
    	
	/**
	 * the reports string will be transfered and shorted as intro text
	 * 
	 * @access public
	 * @param string	report text
	 * @param int		length of intro text (default 120 character)
	 */
	function reportIntroString($report, $introLength=120) {
		global $lang_php;
		$str = removeTagsWContent($report, 'script');
		$allowable_tags = "<h1><h2><br /><br/><br>";
		$str = strip_tags( $str, $allowable_tags );

		$str = str_replace( '<h1', '<b', $str); 
		$str = str_replace( '</h1>', '</b><br />', $str); 
		$str = str_replace( '<h2', '<b', $str); 
		$str = str_replace( '</h2>', '</b><br />', $str); 
		$str = str_replace( '\n', '', $str);
		$str = strlen($str) < $introLength ? $str : substr ($str , 0 , (stripos($str,' ',$introLength) !== False ? stripos($str,' ',$introLength) : NULL));
		return $str.' <span class="repmore">'.$lang_php['r_more'].'</span></b>';
		
	}

	// ------------------------------
	
	/**
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function getReportContentArray($api, $content, $cid=NULL, $writeacc=FALSE, $dlgdata=NULL ){
		global $reportTaskList;
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['rid'])) {$rid = $_GET['rid'];} else {if(isset($_POST['rid'])) {$rid = $_POST['rid'];} else {$rid=0;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		
		if(!$writeacc){
			//read (w/o editor and no buttons)
			return $api->getContentAndButtons( $content,
						(!$api->checkAccessRight($id, $ul, 'write')?NULL:			 
						$api->convertOwnTaskList($reportTaskList,	
						array(
								1 => "jrCmsReports.processReport({root:".$root.",id:".$id.",div:'".$div."',rid:".$rid.",a:'editSingleReport'});return false;"
							),
						(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon')))
						),
						$api->getRightContent(),
						$dlgdata);
			
		} else {
			// CTC: START OPTIMISTIC TRANSACTION - RESERVE
			// we use the content ID like as in the MENU class and the content table
			$api->ctcReserveTable(CONFIG::sql_tbl_cnt, $cid);								
			
			//write (w/- editor and delete/back button)
			return $api->getContentAndButtons(
						'<form id="to_submit" name="to_submit" method="post" action="" />
						<input type="hidden" name="root" id="root" value="'.$root.'" />
						<input type="hidden" name="id" id="id" value="'.$id.'" />
						<input type="hidden" name="div" id="div" value="'.$div.'" />
						<input type="hidden" name="rid" id="rid" value="'.$rid.'" />
						<input type="hidden" name="cid" id="cid" value="'.$cid.'" />
						<input type="hidden" name="a" id="a" value="sacnt" />
						<textarea id="myXinhaReportarea" name="myXinhaReportarea" rows="0" cols="0" 
						style="position:relative; width:100%">'.$content.'</textarea></form>',
						$api->convertOwnTaskList($reportTaskList,	
							array(
								10 => "jrCmsReports.getHelpDoc();return false;"),
							(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))),
						$api->getRightContent(),
						$dlgdata);
		}				
	}
	
	// ------------------------------
	
	function popUpReportList($api, $totalreports=1, $reportlst, $writeacc=FALSE, $app=FALSE){
		
		global $lang_php;
		
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['il'])) {$introLenght = $_GET['il'];} else {if(isset($_POST['il'])) {$introLenght = $_POST['il'];} else {$introLenght=240;}}
		if(isset($_GET['mviewstyle'])) {$mviewstyle = $_GET['mviewstyle'];} else {if(isset($_POST['mviewstyle'])) {$mviewstyle = $_POST['mviewstyle'];} else {$mviewstyle='line';}}
		if(isset($_GET['page'])) {$page = $_GET['page'];} else {if(isset($_POST['page'])) {$page = $_POST['page'];} else {$page=1;}}
		if(isset($_GET['page'])) {$_GET['total'] = $totalreports; $jr_reportlst = json_encode($_GET);} else {$_POST['total'] = $totalreports; $jr_reportlst = json_encode($_POST);}
		
		$uploadDir= 'http://'.$_SERVER['HTTP_HOST'].CONFIG::docPath;
		$strHtml = '<script type="text/javascript">var jr_reportparam = '.$jr_reportlst.';</script>';
		if(!$app)
			$strHtml.= (isset($lang_php['r_reports'])&&$lang_php['r_reports']!='')?('<div class="rheader">'.$lang_php['r_reports'].'</div>'):'';
		else
			$strHtml.= (isset($lang_php['r_reportsAppHeader'])&&$lang_php['r_reportsAppHeader']!='')?('<div class="rAppHeader">'.$lang_php['r_reportsAppHeader'].'</div>'):'';
		$strHtml.= '<div class="rlist'.($app?" rlistapp":"").'">';
		if(!$app)
			$strHtml.= '<form name="reportlst" action="">';

		if (isset($reportlst) && is_array($reportlst)) {
			$strHtml.= '<table border="0">';
			$lastLabel = '';
			foreach ($reportlst as &$report){
				if(isset($report['label']) && $lastLabel != $report['label']) {
					//separate Line
					$strHtml.= '<tr><td colspan="'.($writeacc?"3":"2").'" valign="top">';
					$strHtml.= '<span class="report_cat'.($app?" report_catapp":"").'">';
					switch ($mviewstyle){
						case 'label':
							$strHtml.= $lang_php['r_reports_of'].' '.$report['label'];
						default:
							if($lastLabel != '') $strHtml.= '<hr>';
					}
					$strHtml.= '</span></td></tr>';
					$lastLabel = $report['label'];
				}
				$strHtml.= '<tr>';
				//##col:multiselect
				if ($writeacc){
					$strHtml.= '<td class="reportListCheckbox">';
					$strHtml.= '<input type="checkbox" name="chklist" value="'.$report['rid'].'" />';
					$strHtml.= '</td>';
				}			
				//##col:icon
				$strHtml.= '<td class="report_thb'.($app?" report_thbapp":"").'">';
				$strHtml.= (isset($report['thumbnail']) && ($report['thumbnail'] != 'none'))?('<img class="report_thb" src="'.$uploadDir.'/'.$report['thumbnail'].'" />'):('&nbsp;');
				$strHtml.= '</td>';
				//##col:overview
				$strHtml.= '<td class="report_ovw'.($app?" report_ovwapp":"").'"><span ';
				$strHtml.= 'onclick="jrCmsReports.processReport({root:'.$root.',id:'.$id.',cssid:'.$cssid.',div:\''.$div.'\',rid:'.$report['rid'].',a:\'getPreviewSingleReport\',el:this}); return false;"';
				$strHtml.= '>'.utf8_decode(reportIntroString($report['content'], $introLenght)).'</span></td></tr>';
			}	
			$strHtml.= '</table>';
		} else {

			$strHtml.= '&nbsp;<br /><span class="report_cat">'.$lang_php['r_no_reports'].'</span>';
		}
		$strHtml.= (!$app)?'</form></div>':'</div>';
			//var_dump($strHtml);
		return $strHtml;	
	}
	
	/**
 	* @access public
 	* @param string 
 	* @return string
 	* 
 	*/
	function popUpReportAppHtml($api, $reportlst){
		
		global $lang_php;
		
		return popUpReportList($api, 1, $reportlst, FALSE, TRUE);
		
	}

	/**
 	* @access public
 	* @param string 
 	* @return string
 	* 
 	*/
	function popUpReportListXml($api, $totalreports, $reportlst, $writeacc=FALSE){

		global $lang_php;
		global $reportTaskList;
		
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
			
		// provide XML container
		$xmlStr = $api->getMessageContainer(
						$api->getContentAndButtons(popUpReportList($api, $totalreports, $reportlst, $writeacc),
							(($writeacc)?(
							$api->convertOwnTaskList($reportTaskList,	
										array(
										0 => "jrCmsReports.processReport({root:".$root.",id:".$id.",div:'".$div."', a:'createReport'});return false;"
										,1 => "jrCmsReports.processReport({root:".$root.",id:".$id.",div:'".$div."', a:'editSingleReport'});return false;"
										,2 => "jrCmsReports.processReport({root:".$root.",id:".$id.",div:'".$div."', a:'getPreviewSingleReport'});return false;"
										,4 => "jrCmsReports.processReport({root:".$root.",id:".$id.",div:'".$div."', a:'deleteReport'});return false;"
										,6 => "jrCmsReports.processReport({root:".$root.",id:".$id.",div:'".$div."', a:'moveUpSingleReport'});return false;"
										,7 => "jrCmsReports.processReport({root:".$root.",id:".$id.",div:'".$div."', a:'moveDownSingleReport'});return false;"
										,10 => "jrCmsReports.getHelpDoc();return false;"
										),
										(isset($_SESSION["taskType"])?($_SESSION["taskType"]):('icon'))))
									: NULL),
						$api->getRightContent()),
						$api->getMenu('xml'),
						$api->getStyles());

		return $xmlStr;
	}

	// ------------------------------

	/**
 	* @access public
 	* @param string 
 	* @return string
 	* 
 	*/
	function popUpReportMenuXml($api, $totalreports, $reportlst, $writeacc=FALSE, $menuLabelLength=20){
		
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['page'])) {$page = $_GET['page'];} else {if(isset($_POST['page'])) {$page = $_POST['page'];} else {$page=1;}}
		if(isset($_GET['page'])) {$_GET['total'] = $totalreports; $jr_reportlst = json_encode($_GET);} else {$_POST['total'] = $totalreports; $jr_reportlst = json_encode($_POST);}
		
		if (isset($reportlst) && is_array($reportlst)) {
			$contArr = getReportContentArray($api, $reportlst[0]['content'], $reportlst[0]['cid'], $writeacc);
			$menuHtml = '<script type="text/javascript">var jr_reportparam = '.$jr_reportlst.';</script>';
			$menuHtml.= '<ul>';
			foreach ($reportlst as &$report){
				$menuHtml.= '<li class="report_ovw" ';
				$menuHtml.= 'onclick="jrCmsReports.processReport({root:'.$root.',id:'.$id.',cssid:'.$cssid.',div:\''.$div.'\',rid:'.$report['rid'].',a:\'getSingleReport\',el:this}); return false;"';
				$menuHtml.= '>'.reportIntroString($report['content'], $menuLabelLength).'</li>';
			}
			$menuHtml.= '</ul>';
		} else {
			$strHtml.= '&nbsp;<br /><span class="report_cat">'.$lang_php['r_no_reports'].'</span>';
			$menuHtml = '';
		}
		// provide XML container
		$xmlStr = $api->getMessageContainer($contArr,
						$api->getOwnMenu($menuHtml,'divVMenu'),
						$api->getStyles());

		return $xmlStr;
	}
		
	// ------------------------------
	
	/**
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function getReportsConfData($api, $rid){
		
		try{
			//retrieve the config data
			$result = getReportDB($api, $rid);
			if(is_array($result) && !empty($result)) {
				//delete content
				$result[0]['content'] = NULL;
				//access rights
				$ar = $api->checkAccessRight($rid, (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000'), 'write', CONFIG::webmasterLevel);
				foreach($result[0] as $key => $value){
					if (isset($value)) {
						switch($key) {
							case "rid":
								break;	//provided as header
							case "masterId":
								$reportDialogData[] = ($ar
													  ?	$api->dialogElement($key, intval($value), 'reportDialog', 'select:jrCmsReports', 'required')
													  :	$api->dialogElement($key, intval($value), 'reportDialog', 'hidden'));
								break;
							case "link":
								$reportDialogData[] = $api->dialogElement($key, $value, 'reportDialog', 'select:jrCmsReports', ($ar?'none':'disabled'));
								break;
							case "published":
								$reportDialogData[] = $api->dialogElement($key, $value, 'reportDialog', 'input', ($ar?'required':'disabled'));
								break;
							case "thumbnail":
								$reportDialogData[] = $api->dialogElement($key, $value, 'reportDialog', 'select:jrCmsReports', 'required');
								break;
							default:	
								if((intval($value) != 0) && (strpos($value, '%')===False)) 
									$reportDialogData[] = $api->dialogElement($key, intval($value), 'reportDialog', 'hidden');
								else
									$reportDialogData[] = $api->dialogElement($key, $value, 'reportDialog', 'hidden');
						}
					}
				}
				//retrieve the global data (rMasterId)
				if(($result = getReportMasterIdDB($api)) !== False) 
					$reportDialogData[] = ( $ar
											? $api->dialogElement('rMasterId', $result[0]['rMasterId'], 'reportDialog', 'select:jrCmsReports', 'required')
											: $api->dialogElement('rMasterId', $result[0]['rMasterId'], 'reportDialog', 'hidden'));
			} else {
				$reportDialogData = Array();
			} 
			//dialog dataset
			$dataset = array(
							'header' => $api->dialogHeader('rid', $rid),
						 	'data' => $reportDialogData);
			return $dataset;
	
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.getReportsConfData] failure!"; 		
		}
	} //getReportsConfData
			
// ------------------------------
// Database routines
// ------------------------------

	//web_reports
	//	rid, 		int, 			Report ID
	//	id,			int, 			Reference to anchor menu id
	//	cid,	 	int, 			Reference to own content id
	//	masterId, 	int, 			Master menu Id
	//	published, 	datetime,		Date of update
	//	link, 		varchar(120), 	Link to file (flyer)
	//	thumbnail, 	varchar(120), 	Thumbnail file

	/**
	 * The report will be stored like as a normal content but there is a corresponding 
	 * configuration set in table 'web_reports'. The conten Id of the menu entry is used as
	 * anchor only.
	 * 
	 * @access private
	 * @return data
	 */
	function getReportsDB($api, $id=0, $repAllId=NULL, $start = NULL, $limit = NULL, $strLength = NULL) {

		try{
			return (isset($repAllId) && $id == $repAllId) 
				//all reports sorted by publishing stamp and label
				//where the subquery returns the publishing list
					//SELECT rep.published, rep.link, rep.thumbnail, c.content, m.label
					//FROM `web_reports` AS rep
					//INNER JOIN `web_content` AS c ON rep.cid = c.cid
					//INNER JOIN `web_menu` AS m ON m.id = rep.id
					//WHERE rep.rid IN
					//(
					//	SELECT rep.rid
					//	FROM `web_reports` AS rep
					//	WHERE rep.masterId = $repAllId
					//	ORDER BY rep.published DESC 
					//)
					//ORDER BY m.label ASC, rep.published DESC
					//LIMIT $limit				
					? ($api->getArrayFromDb('rep.published, rep.link, rep.thumbnail, rep.rid, rep.cid, '.
										 (isset($strLength) ? 'LEFT(c.content, '.$strLength.')' : 'c.content').' AS content, m.label',
										'`'.sql_tbl_reports.'` AS rep
										 INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON rep.cid = c.cid
										 INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = rep.id',
										'rep.rid IN(SELECT rep.rid FROM `'.sql_tbl_reports.'` AS rep
						 				 WHERE rep.masterId ='.$repAllId.' ORDER BY rep.published DESC)',
										$start, $limit, NULL,
										'ORDER BY rep.published DESC, m.label ASC'))
				
				//only the reports of 'id' has to be provided
					//SELECT rep.published, rep.link, rep.thumbnail, c.content
					//FROM `web_reports` AS rep
					//INNER JOIN `web_content` AS c ON rep.cid = c.cid
					//INNER JOIN `web_menu` AS m ON m.id = rep.id
					//WHERE rep.id =37
					//ORDER BY rep.masterId, rep.published DESC
					: ($id != -1
						? ($api->getArrayFromDb('rep.published, rep.link, rep.thumbnail, rep.rid, rep.cid, '. 
										(isset($strLength) ? 'LEFT(c.content, '.$strLength.')' : 'c.content').' AS content, m.label as l',
										'`'.sql_tbl_reports.'` AS rep
										INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON rep.cid = c.cid
										INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = rep.id',
										'rep.id = '.$id,
										$start, $limit, "rep.rid ",
										'ORDER BY rep.masterId, rep.published DESC'))
						: ($api->getArrayFromDb('rep.published, rep.link, rep.thumbnail, rep.rid, rep.cid, '.
										(isset($strLength) ? 'LEFT(c.content, '.$strLength.')' : 'c.content').' AS content, m.label as l',
										'`'.sql_tbl_reports.'` AS rep
										INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON rep.cid = c.cid
										INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = rep.id',
										1,
										$start, $limit, "rep.rid ",
										'ORDER BY rep.published DESC')));
										
		}catch (MyException $e) {
			$e->log();
			return False;
		}
	}
	
	// ------------------------------
	/**
	 * 
	 * @access private
	 * @return data
	 */
	function getReportNo($api, $id=0, $repAllId=NULL){

//			return	count(getReportsDB($api, $id, $repAllId, NULL, NULL, 1));

		try{
			$result = (isset($repAllId) && $id == $repAllId) 
					? ($api->getArrayFromDb('COUNT(rep.rid) AS number',
										'`'.sql_tbl_reports.'` AS rep
										 INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON rep.cid = c.cid
										 INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = rep.id',
										'rep.rid IN(SELECT rep.rid FROM `'.sql_tbl_reports.'` AS rep
						 				 WHERE rep.masterId ='.$repAllId.' ORDER BY rep.published DESC)',
										NULL, NULL, NULL,
										'ORDER BY rep.published DESC, m.label ASC'))
				
					: ($api->getArrayFromDb('COUNT(rep.rid) AS number',
										'`'.sql_tbl_reports.'` AS rep
										INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON rep.cid = c.cid
										INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = rep.id',
										'rep.id = '.$id,
										NULL, NULL, "rep.rid ",
										'ORDER BY rep.masterId, rep.published DESC'));
			return $result[0]['number'];										
			
		}catch (MyException $e) {
			$e->log();
			return False;
		}
			
	
	
	} 
	
	// ------------------------------
	/**
	 * 
	 * @access private
	 * @return data
	 */
	function getReportDB($api, $rid=0) {

		try{
			//SELECT rep.published, rep.link, rep.thumbnail, c.content
			//FROM `web_reports` AS rep
			//INNER JOIN `web_content` AS c ON rep.cid = c.cid
			//INNER JOIN `web_menu` AS m ON m.id = rep.id
			//WHERE rep.rid = $rid
			return $api->getSingleValueFromDb('rep.*, c.content, m.label as l',
												'`'.sql_tbl_reports.'` AS rep
										 		INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON rep.cid = c.cid
										 		INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = rep.id',
												'rep.rid = '.$rid);
		}catch (MyException $e) {
			$e->log();
			return False;
		}
	}
	
	// ------------------------------
	/**
	 * 
	 * @access private
	 * @return data
	 */
	function getReportsLinkDB($api) {
		//function to alter the directory array
		function alterDir(&$item, $key){
			$labelLength = 20;
			$item['label'] = strip_tags(removeTagsWContent($item['label'], 'script'));
			$item['label'] = strlen($item['label']) < $labelLength ? $item['label'] : substr ($item['label'] , 0 , (stripos($item['label'],' ',$labelLength) !== False ? stripos($item['label'],' ',$labelLength) : NULL));
		}
		$result = $api->getArrayFromDb('m.id, m.cssid, m.rootId as root, m.htmlDiv as `div`, rep.rid, 
										LEFT(c.content, 120) AS label, \'getPreviewSingleReport\' AS a',
										'`'.sql_tbl_reports.'` AS rep
									 	INNER JOIN `'.CONFIG::sql_tbl_cnt.'` AS c ON rep.cid = c.cid
									 	INNER JOIN `'.CONFIG::sql_tbl_menu.'` AS m ON m.id = rep.id');
		array_walk($result, 'alterDir');
		return $result;
			
	}
	
	// ------------------------------
	/**
 	 * create report
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function createReportDB($api, $id, $dthb) {

		global $lang_php;
		
		// at first try to define a default thumbnail
		if(!isset($dthb)) $dthb = default_thumbnail;
		
		// create a new content entry
		if(($cid = $api->insertSingleValueInDb('`'.CONFIG::sql_tbl_cnt.'`',
												'content', 
												"'".addslashes($lang_php['r_report_init'])."'", True)) !== False) {
			//2) create a new report entry
			//web_reports
			//	rid, 		int, 			Report ID
			//	id,			int, 			Reference to anchor menu id
			//	cid,	 	int, 			Reference to own content id
			//	masterId, 	int, 			Master menu Id
			//	published, 	datetime,		Date of update
			//	link, 		varchar(120), 	Link to file (flyer)
			//	thumbnail, 	varchar(120), 	Thumbnail file
			
			//due to compatibility reasons with other SQL databases datetime format 
			//is used instead of the MYSQL timestamp format
			$myTimeStamp = date("Y-m-d H:i:s");
			
			//retrieve the master Id
			if(($result = getReportMasterIdDB($api)) !== False) 
				$masterId = $result[0]['rMasterId'];
			else 
				$masterId = NULL;
			
			if(($_GET['rid'] = $api->insertSingleValueInDb('`'.sql_tbl_reports.'`',
													'id, cid, masterId, published, link, thumbnail',
													(int)$id."
													,".(int)$cid."
													,".(isset($masterId)?((int)$masterId):0)."
													,'".(string)$myTimeStamp."'
													,'none','".$dthb."'", True)) !== False){
				return $cid;													
			} else {
				$_GET['rid'] = NULL;
				$api->deleteSingleValueOfDb('c.*','`'.CONFIG::sql_tbl_cnt.'` AS c',	'c.cid = '.(int)$cid	);
			}
		}													
  		return 'XXX'; 									
  		//return False; 									
	} // createReportDB
	
	// ------------------------------
	/**
 	 * delete report
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function deleteReportDB($api, $rid) {
		
		if(($result = $api->getSingleValueFromDb('r.cid', '`'.sql_tbl_reports.'` AS r', 'r.rid = '.(int)$rid)) !== False) {
			//1 delete the content
			// CTC: START PESSIMISTIC TRANSACTION - LOCK
			$cid = (int)$result[0]['cid'];
			if( $api->ctcLockTable(CONFIG::sql_tbl_cnt, $cid) &&
			   ($result=$api->deleteSingleValueOfDb('c.*','`'.CONFIG::sql_tbl_cnt.'` AS c',	'c.cid = '.(int)$result[0]['cid'])) !== False) {
				//2 delete the report entry
				$result = $api->deleteSingleValueOfDb('r.*','`'.sql_tbl_reports.'` AS r',	'r.rid = '.(int)$rid);
				// CTC: FINISH PESSIMISTIC TRANSACTION	
				$api->ctcUnlockTable(CONFIG::sql_tbl_cnt, $cid);
				return $result;
			}
		}
		return False;
	} // deleteReportDB
  	
	// ------------------------------
	/**
 	 * move report
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */
	function moveReportDB($api, $rid, $mrid, $act=Null) {
		
		//simple solution: retrieve the anchor element and
		//manipulate the time with a fix setting of seconds
		if(($result = getReportDB($api, $mrid)) !== False) {
			$cd = strtotime($result[0]['published']);
			
			// CTC: START OPTIMISTIC TRANSACTION - RESERVE
			// we use the content ID like as in the MENU class and the content table
			$result = $api->getSingleValueFromDb('r.cid', '`'.sql_tbl_reports.'` AS r', 'r.rid = '.(int)$rid);
			$cid = $result[0]['cid'];
			$api->ctcReserveTable(CONFIG::sql_tbl_cnt, $cid);								
			//new time
			if($act == 'moveUpSingleReport') {
				$cti = ((date('i',$cd)+1)<60)?(date('i',$cd)+1):0;
				$ctH = ((date('i',$cd)+1)>=60 && (date('H',$cd)+1)<60)?(date('H',$cd)+1):(date('H',$cd));
			} else {
				$cti = ((date('i',$cd)-1)>=0)?(date('i',$cd)-1):0;
				$ctH = ((date('i',$cd)-1)<0 && (date('H',$cd)-1)>=0)?(date('H',$cd)-1):(date('H',$cd));
			}
      		$newTimeStamp = date('Y-m-d H:i:s', mktime($ctH, $cti, 59, date('m',$cd), date('d',$cd), date('Y',$cd)));
      		$result = updateReportConfDB($api, $rid, Null, $newTimeStamp);
			// CTC: FINISH TRANSACTION, started again, see updateReportConfDB	
			$api->ctcUnlockTable(CONFIG::sql_tbl_cnt, $cid);
			return $result;
		}	
		return False;
	}
	
	// ------------------------------
	/**
 	 * update report conf data
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function updateReportConfDB($api, $rid, $thumbnail=NULL, $published=NULL, $repMasterId=NULL) {
		
		if(($result = $api->getSingleValueFromDb('r.cid', '`'.sql_tbl_reports.'` AS r', 'r.rid = '.(int)$rid)) !== False) {
			// Transaction was started by Edit Task (see getEventContentXml)
			// CTC: CHECK OPTIMISTIC TRANSACTION - LOCK
			$cid = $result[0]['cid'];
			if($api->ctcCheckAndLockTable(CONFIG::sql_tbl_cnt, $cid)) {

				$myTimeStamp = isset($published) ? $published : date("Y-m-d H:i:s");
				$parStr = "published = '".$myTimeStamp."'";
				$parStr.= (isset($thumbnail) ? ",thumbnail = '".$thumbnail."'" : "");
				$parStr.= (isset($repMasterId)? ",masterId = ".(int)$repMasterId : "");
// Clemens 2011.08.11: replaced due to compatibility reasons to MsSql				
//				$result = $api->updateSingleValueOfDb('`'.sql_tbl_reports.'` AS r',
//													$parStr,
//													'r.rid ='.$rid);
				$result = $api->updateSingleValueOfDb(sql_tbl_reports,
													$parStr,
													'rid ='.$rid);
													
				// CTC: CLOSE OPTIMISTIC TRANSACTION - UNLOCK 	
				$result &= $api->ctcUnlockTable(CONFIG::sql_tbl_cnt, $cid);
				// CTC: RESERVE THE ENTRY AGAIN
				// because the editor should be still active and
				// due to the optimistic method this as no negative
				// impact on further actions
				$result &= $api->ctcReserveTable(CONFIG::sql_tbl_cnt, $cid);

				return (boolean)$result;
			}
		}
		return false;
		
	} // updateReportConfDB

	// ------------------------------
	/**
 	 * retrieve Master ID
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function getReportMasterIdDB($api) {
		
		try{
			return $api->getSingleValueFromDb('g.rMasterId', '`'.CONFIG::sql_tbl_gData.'` AS g', 1);
		}catch (MyException $e) {
			$e->log();
			return False;
		}
				
	} // getReportMasterIdDB
	
	// ------------------------------
	/**
 	 * retrieve Master ID
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function updateReportMasterIdDB($api, $rMasterId) {
		
		try{
			// no CTC needed, only webmaster Task
			if(isset($rMasterId)) {
//Clemens 2011.08.11: replaced due to compatibility reasons to MsSql				
//				return $api->updateSingleValueOfDb('`'.CONFIG::sql_tbl_gData.'` AS g', "rMasterId = '".$rMasterId."'", 1);
				return $api->updateSingleValueOfDb(CONFIG::sql_tbl_gData, "rMasterId = '".$rMasterId."'", 1);
			}
			return false;
			
		}catch (MyException $e) {
			$e->log();
			return False;
		}
				
	} // updateReportMasterIdDB
	
	
	// ------------------------------
	/**
 	 * retrieve all available menu items
 	 * 
 	 * @param
 	 * @access private
 	 * @return Id / boolean
 	 */

	function getReportMenuItemsDB($api) {
		
		if(isset($_GET['all'])) {$all = $_GET['all'];} else {if(isset($_POST['all'])) {$all = $_POST['all'];} else {$all=1;}}
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		$ul = ($all==1)?CONFIG::webmasterLevel:$ul;
		
		try{
			//1) retrieve the xtpId
			// SELECT x.xtpID
			// FROM CONFIG::sql_tbl_xTP AS x
			// INNER JOIN CONFIG::sql_tbl_proc AS p ON p.procId=x.procId
			// WHERE p.procId LIKE 'jrCmsReports.getReports'
			if(($result = $api->getSingleValueFromDb('x.xtpID',
											'`'.CONFIG::sql_tbl_xTP.'` AS x
											INNER JOIN `'.CONFIG::sql_tbl_proc.'` AS p ON p.procId=x.procId',
											'p.procName LIKE \'jrCmsReports.getReports\'')) !== False) 
			
				// SELECT m.id, m.label
				// FROM CONFIG::sql_tbl_menu AS m
				// INNER JOIN CONFIG::sql_tbl_ul AS u ON u.ulid=m.ulid
				// WHERE m.label NOT LIKE 'ROOT' AND
				// LEFT(u.ul,1) <= (substr($ul,0,1))
				// ORDER BY m.label
				return	$api->getArrayFromDb('m.id, m.label',
											'`'.CONFIG::sql_tbl_menu.'` AS m
											 INNER JOIN `'.CONFIG::sql_tbl_ul.'` AS u ON u.ulid=m.ulid',
							 				 'm.label NOT LIKE \'ROOT\' AND 
							 				 LEFT(u.ul,1) <= '.(substr($ul,0,1)).' AND
							 				 m.xtpID = '.$result[0]['xtpID'],
											 NULL, NULL, NULL,
											 'ORDER BY m.label ASC');
			
			return Null;
			
		}catch (MyException $e) {
			$e->log();
			return False;
		}
				
	} // getMenuItemsDB
	
// ------------------------------
// Task routines
// ------------------------------

	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function getReports($api, $lastonly=false){
		
		global $lang_php;
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['rlt'])) {$repListType = $_GET['rlt'];} else {if(isset($_POST['rlt'])) {$repListType = $_POST['rlt'];} else {$repListType='list';}}
		if(isset($_GET['rall'])) {$repAll = $_GET['rall'];} else {if(isset($_POST['rall'])) {$repAll = $_POST['rall'];} else {$repAll=False;}}
		if(isset($_GET['rmnl'])) {$repMenuNodeLength = $_GET['rmnl'];} else {if(isset($_POST['rmnl'])) {$repMenuNodeLength = $_POST['rmnl'];} else {$repMenuNodeLength=20;}}
		if(isset($_GET['page'])) {$page = $_GET['page'];} else {if(isset($_POST['page'])) {$page = $_POST['page'];} else {$page=1;}}
		if(isset($_GET['perpage'])) {$perpage = $_GET['perpage'];} else {if(isset($_POST['perpage'])) {$perpage = $_POST['perpage'];} else {$perpage=10;}}
		
		try{
			//******** Report List ***********
			//1 ensure presence of table
			if( CONFIG::dbUpgrade && $api->checkAccessRight(0, $ul, 'create', CONFIG::webmasterLevel)) {
				require_once('jrcmsreportsinit.php');
				if ($api->checkTable(sql_tbl_reports) !== True){
					if(!initReportsDb())
						throw new MyException('jrcmsreports.getReport DB wrong initialized!');
				} else {		
					if(!upgradeReportsDb())
						throw new MyException('jrcmsreports.getReport DB wrong initialized!');
				}
			}
			
			//2 check for central report item (repAllId)
			$repAllId = ((boolean)$repAll)?(getReportMasterIdDB($api)):NULL; 
			
			//3 pagination
			$n = ( $page -1 ) * $perpage;
			$totalreports = getReportNo($api, $id, $repAllId[0]['rMasterId']);
			if($lastonly) {
				$n = 0; $perpage = 1;
			}

			//4 retrive the reports
			$reportlst = getReportsDB($api, $id, $repAllId[0]['rMasterId'], $n, $perpage, reports_content_length);

			//5 retrieve overview of reports
			return (!$lastonly
					?(($repListType == 'list')
						//provide overview as 'html list' in the XML container
						? popUpReportListXml($api, $totalreports, $reportlst, $api->checkAccessRight($id, $ul, 'write'))
						//provide overview as 'menu'
						: popUpReportMenuXml($api, $totalreports, $reportlst, $api->checkAccessRight($id, $ul, 'write'), $repMenuNodeLength))
					//provide the last entry only
					: popUpReportAppHtml($api, $reportlst));
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.getReports] failure!"; 		
		}
	} //getReports
			
	// ------------------------------
	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function getSingleReport($api, $act=NULL){
		
		global $lang_php;
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['rid'])) {$rid = $_GET['rid'];} else {if(isset($_POST['rid'])) {$rid = $_POST['rid'];} else {$rid=0;}}
		
		try{
			if(($result=getReportDB($api, $rid))!==FALSE) {
				
				if(!$api->checkAccessRight($id, $ul, 'write') || (isset($act) && $act == 'getPreviewSingleReport')) {
					return $api->getMessageContainer(
							getReportContentArray($api, 
												  $result[0]['content'], 
												  $result[0]['cid'], 
												  FALSE),
							NULL, NULL);
				} else {
					return $api->getMessageContainer(
							getReportContentArray($api, 
												  $result[0]['content'], 
												  $result[0]['cid'], 
												  TRUE,
												  getReportsConfData($api, $rid)),
							NULL, NULL);

				}
			} else {
				throw new MyException('getReportDB failed!');
			}
						
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.getSingleReport] failure!";		
		}
	} //getSingleReport

	// ------------------------------
	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function createReport($api){
		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		if(isset($_GET['dthb'])) {$dthb = $_GET['dthb'];} else {if(isset($_POST['dthb'])) {$dthb = $_POST['dthb'];} else {$dthb=NULL;}}
		
		try{
			
			if(($result = createReportDB($api, $id, $dthb)) !== False)
				//the generated 'rid' is set as $_GET['rid'] inside of the DB routine
				return getSingleReport($api,'getSingleReport');
			else
				return $api->getMessageContainer(
						getReportContentArray($api, $lang_php['r_create_report_failure'], 0, FALSE),
						NULL, NULL);
		
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.createReport] failure!"; 		
		}
	} //createReport
			
	// ------------------------------
	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function deleteReport($api){
		
		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['rid'])) {$rid = $_GET['rid'];} else {if(isset($_POST['rid'])) {$rid = $_POST['rid'];} else {$rid=NULL;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		try{
			
			if(isset($rid)){
				if(($result = deleteReportDB($api, $rid)) !== False)
					//return $api->getMessageContainer($api->getContentAndButtons(''),NULL, NULL);
					return getReports($api);
				else
					return $api->getMessageContainer(
						getReportContentArray($api, $lang_php['r_delete_report_failure'], 0, FALSE),
						NULL, NULL);
			} else {
				throw new MyException('jrcmsreports.deleteReport wrong parameter supplied!');
			}
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.deleteReport] failure!"; 		
		}
	}

	// ------------------------------
	/**
 	 *  
 	 * @param object	- interface to JRCMS
 	 * @access private
 	 * @return array
 	 */
	function moveReport($api, $act){
		
		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['root'])) {$root = $_GET['root'];} else {if(isset($_POST['root'])) {$root = $_POST['root'];} else {$root=NULL;}}
		if(isset($_GET['id'])) {$id = $_GET['id'];} else {if(isset($_POST['id'])) {$id = $_POST['id'];} else {$id=-1;}}
		if(isset($_GET['rid'])) {$rid = $_GET['rid'];} else {if(isset($_POST['rid'])) {$rid = $_POST['rid'];} else {$rid=NULL;}}
		if(isset($_GET['mrid'])) {$mrid = $_GET['mrid'];} else {if(isset($_POST['mrid'])) {$mrid = $_POST['mrid'];} else {$mrid=NULL;}}
		if(isset($_GET['cssid'])) {$cssid = $_GET['cssid'];} else {if(isset($_POST['cssid'])) {$cssid = $_POST['cssid'];} else {$cssid=-1;}}
		if(isset($_GET['div'])) {$div = $_GET['div'];} else {if(isset($_POST['div'])) {$div = $_POST['div'];} else {$div=CONFIG::divHMenu;}}
		try{
			
			if(isset($rid) && isset($mrid)){
				if(($result = moveReportDB($api, $rid, $mrid, $act)) !== False)
					return getReports($api);
				else
					return $api->getMessageContainer(
						getReportContentArray($api, $lang_php['r_move_report_failure'], 0, FALSE),
						NULL, NULL);
			} else {
				throw new MyException('jrcmsreports.moveReport wrong parameter supplied!');
			}
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.moveReport] failure!"; 		
		}
	}
	
	// ------------------------------
	
	/**
 	 * get image directories 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getThumbnails($api){
		
		//function to alter the directory array
		function alterDir(&$item, $key){
			$item = Array('src' => str_replace($_SERVER['DOCUMENT_ROOT'].CONFIG::docPath.'/','',$item));
		}

		$imgDirArray = list_thumbnail_files($_SERVER['DOCUMENT_ROOT'].CONFIG::docPath.CONFIG::uploadDIR,
						(isset($_SESSION["thumbnail_dir"])?$_SESSION["thumbnail_dir"]:'.thumbs'),
						CONFIG::thumbExclSubDir);
		array_walk($imgDirArray, 'alterDir');
		$imgDirArray[] = Array('src' => default_thumbnail);
		$dataset = Array('jr_imgDirs' => $imgDirArray);
		return $api->array2Xml($dataset);				
	}
	
	// ------------------------------
	
	/**
 	 * save report conf data 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function saveReportThumbnail($api){

		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['rid'])) {$rid = $_GET['rid'];} else {if(isset($_POST['rid'])) {$rid = $_POST['rid'];} else {$rid=NULL;}}
		if(isset($_GET['thumbnail'])) {$thumbnail = $_GET['thumbnail'];} else {if(isset($_POST['thumbnail'])) {$thumbnail = $_POST['thumbnail'];} else {$thumbnail='none';}}
		if(isset($_GET['published'])) {$published = $_GET['published'];} else {if(isset($_POST['published'])) {$published = $_POST['published'];} else {$published=NULL;}}
		if(isset($_GET['rMasterId'])) {$repMasterId = $_GET['rMasterId'];} else {if(isset($_POST['rMasterId'])) {$repMasterId = $_POST['rMasterId'];} else {$repMasterId=0;}}
		if(isset($_GET['masterId'])) {$masterId = $_GET['masterId'];} else {if(isset($_POST['masterId'])) {$masterId = $_POST['masterId'];} else {$masterId=0;}}

		try{

			if(($result = updateReportConfDB($api, $rid, $thumbnail, $published, $masterId)) !== False)
			
				if(($result = updateReportMasterIdDB($api, $repMasterId)) !== False)
			
					return '<script type="text/javascript">alert("'.$lang_php['r_data_updated'].'");</script>';
					
			return '<script type="text/javascript">alert("'.$lang_php['r_data_update_failure'].'");</script>';
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.saveReportThumbnail] failure!"; 		
		}
	}
	
	// ------------------------------
	
	/**
 	 * save report conf data 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function deleteReportThumbnail($api){

		global $lang_php;	//needed for DB access
		$ul = (isset($_SESSION["ul"]))?($_SESSION["ul"]):('000');
		if(isset($_GET['rid'])) {$rid = $_GET['rid'];} else {if(isset($_POST['rid'])) {$rid = $_POST['rid'];} else {$rid=NULL;}}
		try{

			//currently the thumbnail could be updated only
			if(($result = updateReportConfDB($api, $rid, 'none')) !== False)
				return '<script type="text/javascript">alert("'.$lang_php['r_data_updated'].'");</script>';
			else
				return '<script type="text/javascript">alert("'.$lang_php['r_data_update_failure'].'");</script>';
			
		}catch(MyException $e){
			$e->log();
			return "[jrcmsreports.deleteReportThumbnail] failure!"; 		
		}
	}

	// ------------------------------
	
	/**
 	 * get report master Id 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getReportMasterId($api){
	
		if(($result = getReportMasterIdDB($api)) !== False) {
			return (!empty($result))
					? ($api->array2Xml(Array('jr_repMasterId' => $result[0]['rMasterId'])))
					: ($api->array2Xml(Array('jr_repMasterId' => 0)));
		}
		return "[jrcmsreports.getReportMasterId] failure!";
	}
	
	// ------------------------------
	
	/**
 	 * get report master Id 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getMenuItems($api){
	
		if(($result = getReportMenuItemsDB($api)) !== False) {
			return (!empty($result))
					? ($api->array2Xml(Array('jr_repMenuItems' => $result)))
					: ($api->array2Xml(Array('jr_repMenuItems' => '')));
		}
		return "[jrcmsreports.getMenuItems] failure!";
	}
	
	// ------------------------------
	/**
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getInternalLink($api){
	
		$data = getReportsLinkDB($api);
		$dataset = Array('jr_linkProc' => 'jrCmsReports.processReport'
						,'jr_linkList' => $data);
		return $api->array2Xml($dataset);				
	}

	// ------------------------------
	/**
 	 * get report flyer 
 	 * 
 	 * @param
 	 * @access
 	 * @return 
 	 */
	function getReportFlyer($api){

		//function to alter the directory array
		function alterDir(&$item, $key){
			$item = Array('src' => str_replace($_SERVER['DOCUMENT_ROOT'].CONFIG::docPath.'/','',$item));
		}
		//we use the image utility to find files
		$filesArray = list_jpg_files($_SERVER['DOCUMENT_ROOT'].CONFIG::docPath.CONFIG::uploadDIR, False, $pattern="(\.pdf$)|(\.jpeg$)|(\.html$)");
		array_walk($filesArray, 'alterDir');
//TODO: not supported for now		
		$dataset = Array('jr_reportFlyer' => $filesArray);
		return $api->array2Xml($dataset);				
	}
	
// ############ MAIN #############
$api = new JRCMSAPI();
if (isset($act)) {
	switch ($act) {
	case "getReports":
		// retrieves all data and provide a xml container
		$e = getReports($api);
		break;
	case "getReportApp":
		// retrieves all data and provide a xml container
		$e = getReports($api, TRUE);
		break;
	case "getSingleReport":
	case "getPreviewSingleReport":
		// retrieve a report and provide a xml container
		$e = getSingleReport($api, $act);
		break;
	case "createReport":
		// first create and internal getSingleReport
		$e = createReport($api);
		break;	
	case "deleteReport":
		// delete Report and internal getReports
		$e = deleteReport($api);
		break;	
	case "moveUpSingleReport":
	case "moveDownSingleReport":
		// first create and internal getSingleReport
		$e = moveReport($api, $act);
		break;	
	case "getThumbnails":
		// first create and internal getSingleReport
		$e = getThumbnails($api);
		break;	
	case "saveReportThumbnail":
		// 
		$e = saveReportThumbnail($api);
		break;	
	case "deleteReportThumbnail":
		// 
		$e = deleteReportThumbnail($api);
		break;	
	case "getReportMasterId":
		// 
		$e = getReportMasterId($api);
		break;	
	case "getMenuItems":
		// 
		$e = getMenuItems($api);
		break;	
	case "getInternalLink":
		//  
		$e = getInternalLink($api);
		break;
	case "getReportFlyer":
		// 
		$e = getReportFlyer($api);
		break;	
	default: 
		print_r("jrCmsReportss.php with wrong parameter called!!");
	}

} else {
	print_r("jrCmsReportss.php with wrong parameter called!!");
	
}
$api = NULL;
echo $e;
flush(); // send really out all stuff
?>