<?php
/**
 * This module initializes the database used by the jrCmsReports
 *
 * @package jrCMS: jrCmsReports
 * @author Jens Raabe
 * @version $Id: jrcmsreportsinit.php 265 2010-08-17 12:17:27Z jensraabe $
 *  
 * @copyright Copyright (c) 2008,2009 Jens Raabe
 * Permission is hereby granted, free of charge, to any person 
 * obtaining a copy of this software and associated documentation 
 * files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included 
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR 
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

function initProcedure($api){
	//TODO:as first try we use fix values
	return $api->insertProcedure('jrCmsReports.getReports',3501,'ajax','Entry routine of reports');
}

function initReportsTbl($api){

	//global define sql_tbl_reports;
	$columns = array();
	$columns[0] = array('name' => 'rid', 'type' => 'int', 'null' => FALSE,	'auto_inc' => TRUE, 'key' => TRUE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'Report ID');
	$columns[1] = array('name' => 'id', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => NULL, 'comment' => 'Reference to content id (menu id)');
	$columns[2] = array('name' => 'cid', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => TRUE, 'default' => NULL, 'comment' => 'Reference to own content id');
	$columns[3] = array('name' => 'masterId', 'type' => 'int', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment' => 'Master menu Id');
	$columns[4] = array('name' => 'published', 'type' => 'datetime', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => '1914-01-01 00:00:00', 'comment' => 'Date of update');
	$columns[5] = array('name' => 'link', 'type' => 'varchar(120)', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'Link to file (flyer)');
	$columns[6] = array('name' => 'thumbnail', 'type' => 'varchar(120)', 'null' => FALSE, 'auto_inc' => FALSE, 'key' => FALSE, 'unique' => FALSE, 'default' => 'none', 'comment' => 'Thumbnail file');

	return $api->createTable(sql_tbl_reports, $columns);
}

function alterGenericDataTbl($api){
	
	$columns = array();
	$columns[0] = array('alter' => 'ADD', 'name' => 'rMasterId', 'type' => 'int', 'null' => FALSE,	'auto_inc' => FALSE, 'unique' => FALSE, 'default' => '0', 'comment' => 'Default Value of Report Master ID');

	return $api->alterTable(CONFIG::sql_tbl_gData, $columns);
}

function initReportsDb() {
	$api = new JRCMSAPI();
	
	$result = initProcedure($api);
	//print_r(' initProcedure: '.$result.'<br>');
	$result &= initReportsTbl($api);
	//print_r(' initImageShowTbl: '.$result.'<br>');
	$result &= alterGenericDataTbl($api);
	//print_r(' alterGenericDataTbl: '.$result.'<br>');
	
	$api = NULL;
	return (!isset($result) || $result === False)?False:True;
}

function upgradeReportsDb() {
	
	$result = True;
	$api = new JRCMSAPI();
	$version = $api->getSingleValueFromDb("g.version", CONFIG::sql_tbl_gData." AS g", 1);
	$version = (isset($version) && is_array($version)) ? $version[0]['version'] : '';
	switch ($version) {
		case 'V0.1.2':
			//set updates and changes of DB, but do not forgot updating of version itself
			//$result &= alterGenericDataTbl($api);
			break;
		default:	
			$result &= alterGenericDataTbl($api);
			break;
	}
	return $result;
}

?>